SystemOrganization addCategory: #Familiar!
SystemOrganization addCategory: #'Familiar-Core'!
SystemOrganization addCategory: #'Familiar-Moose'!
SystemOrganization addCategory: #'Familiar-SPINE'!
SystemOrganization addCategory: #'Familiar-SPINE-Moose'!
SystemOrganization addCategory: #'Familiar-SPINE-Tests'!
SystemOrganization addCategory: #'Familiar-Tests'!
SystemOrganization addCategory: #'Familiar-Visitor'!

MooseGroup subclass: #FMAssignmentGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMAssignmentGroup commentStamp: '<historical>' prior: 0!
MooseModel resetMeta!

!FMAssignmentGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 15:44'!
annotation

	<MSEClass: #AssignmentGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:12'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>
	
	"Preambule. It includes the initialization. "
	| view assignments |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"
	self viewComplexityOn: view.
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:15'!
viewComplexityOn: view

"	(assignments anySatisfy:  [ :ass | ass featureModel numberOfConstraints > 0])
		ifTrue: 
			[ view shape rectangle 
				linearFillColor: [ :ass | ass featureModel numberOfConstraints] within: assignments ]."
	
	 self do: [:ass | ass viewComplexityOn: view ].
! !

MooseGroup subclass: #FMFeatureGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMFeatureGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 14:29'!
annotation

	<MSEClass: #FeatureGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/2/2012 14:59'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view nodes |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"

	nodes := self asArray.
	view interaction action: #inspect; popupText.

	view nodes: nodes.
	view edges: nodes from: #yourself toAll:  #subFeatures.
	view treeLayout.
	"-------------" 
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

MooseGroup subclass: #FMFeatureModelGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMFeatureModelGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 01:12'!
annotation

	<MSEClass: #FeatureModelGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 16:58'!
setInteractionOfNodes: view
	view interaction 
			popupText: #description.! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/3/2012 13:24'!
viewDistribution
	<menuItem: 'Distribution' category: 'Visualize'>
	
	| view | 
	view := MOViewRenderer new.
	view shape rectangle 
			width: [ :fm | fm numberOfProductions * 5 ];
			height: [ :fm | fm numberOfConstraints * 5 ].
	
	self setInteractionOfNodes: view.
	view nodes: self entities.
	^ view openWithStatusbar title: 'Class Blueprint'! !

MooseGroup subclass: #SPDomainElementGroup
	instanceVariableNames: 'hlParent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/25/2013 11:57'!
addHighlightParentButtonOn: view
	| hlParentBox hlParentBoxElement titleHL hlParent |
	
	hlParent := false. 
	hlParentBox := ROBox new
		color: Color red;
		borderWidth: 0.
	hlParentBoxElement := ROElement new + hlParentBox.
	view stack add: hlParentBoxElement.
	
	titleHL := ROLabel text: 'HL Parents OFF'.
	hlParentBoxElement add: ROElement new + titleHL.
	view
		addMenu: 'Highlight parent'
		callBack: [ :stack | 
			hlParent := hlParent not.
			self switchHLBox: hlParentBox text: titleHL state: hlParent.
			stack signalUpdate ].
	ROConstraint stickToTopRight: hlParentBoxElement.	"hlParentBoxElement translateTo: (((view raw camera windowSize x)-(hlParentBox width)-5) @ 5)."
! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/25/2013 11:43'!
addKeyLegendButtonOn: view
	| keyLegend |
	keyLegend := nil.
	view
		addMenu: 'Key'
		callBack: [ :aStack | 
			keyLegend
				ifNil: [ 
					keyLegend := self getKey.
					aStack add: keyLegend.
					keyLegend translateTo: 10 @ 40 ]
				ifNotNil: [ 
					keyLegend remove.
					keyLegend := nil ].
			aStack signalUpdate ]! !

!SPDomainElementGroup methodsFor: 'converting' stamp: 'SimonUrli 12/17/2012 23:16'!
associationEdgeFrom: node to: targetNode
	| targetEdge |
	targetEdge := ROEdge from: node to: targetNode.
	targetEdge + (ROLine red).
	^targetEdge! !

!SPDomainElementGroup methodsFor: 'configuration' stamp: 'AlexandreBergel 7/25/2013 11:43'!
defaultWindowSize
	^ 1024 @ 768! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/25/2013 10:59'!
defineButton: stack
	stack serializeButton.
	stack exportButton.
	stack zoomOutButton.
	stack zoomInButton.
	stack findButton.
	stack exportButton! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 7/25/2013 12:10'!
defineFeatureInteractionOn: view
	view interaction action: #inspect.
	view interaction
		on: ROMouseEnter
		do: [ :el | 
			| sourceElement parents |
			sourceElement := el element model.
			
			self pointFeature: sourceElement onView: view.
			el element forShape: ROBox do: [:s | s color: (Color green)].
			hlParent ifTrue: [
				parents := sourceElement recursivelyGetParents: (OrderedCollection new).
				parents do: [:fcal |
					(view raw elementFromModel: fcal) forShape: ROBox do: [:s | s color: (Color lightGreen)].
					self pointFeature: fcal onView: view.
				].
			].
	].
		
	view interaction
		on: ROMouseLeave
		do: [ :el | 
			| sourceElement parents |
			sourceElement := el element model.
			
			self unpointFeature: sourceElement onView: view.
			el element forShape: ROBox do: [:s | s color: (Color white)].
			hlParent ifTrue: [
				parents := sourceElement recursivelyGetParents: (OrderedCollection new).
				parents do: [:fcal |
					(view raw elementFromModel: fcal) forShape: ROBox do: [:s | s color: (Color white)].
					self unpointFeature: fcal onView: view.
				].
			].
		].
	
	
	view interaction popupText: [ :feat | feat popupText ].
	
	view interaction
		forward: ROMouseDragging;
		on: ROMouseLeftClick
		do: [ :el | el model visualize ].	"view interaction item: 'focus on it' action: [ :el | el model visualize ]."	""! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'SimonUrli 12/4/2012 14:49'!
defineHighlightingOn: view withFunction: aBlock 
	view interaction
		on: ROMouseEnter
		do: [ :el | 
			| nodesToHL |
			nodesToHL := view raw elementsFromModels: (aBlock value:  (el element model)).
			ROHighlightElements on: nodesToHL color: Color blue.
			el element forShape: ROBox do: [:s | s borderColor: (Color blue)]. ].
	view interaction
		on: ROMouseLeave
		do: [ :el | 
			| nodesToHL |
			nodesToHL := view raw elementsFromModels: (aBlock value:  (el element model)).
			ROUnhighlightElements on: nodesToHL.
			el element forShape: ROBox do: [:s | s borderColor: (Color black)]. ].! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 7/31/2013 08:10'!
defineRuleInteractionOnView: view
	view interaction
		on: ROMouseEnter
		do: [ :el | 
			| sourceElement featuresSelected featuresDeselected featureActioned colorFA |
			sourceElement := el element model.
			featuresSelected := sourceElement state selected.
			featuresDeselected := sourceElement state deselected.
			featureActioned := sourceElement actions feature.
			colorFA := (sourceElement actions isKindOf: SPActionSelect)
				ifFalse: Color blue
				ifTrue: Color orange.

			ROBlink highlightElements: (view raw elementsFromModels: featuresSelected) color: Color green.
			ROBlink highlightElements: (view raw elementsFromModels: featuresDeselected) color: Color red.

			ROBlink highlight: (view raw elementFromModel: featureActioned) color: colorFA.
			ROBlink highlight: (view raw elementFromModel: sourceElement) color: Color yellow ].
		
	view interaction
		on: ROMouseLeave
		do: [ :el | 
			| sourceElement featuresSelected featuresDeselected featureActioned colorFA |
			sourceElement := el element model.
			featuresSelected := sourceElement state selected.
			featuresDeselected := sourceElement state deselected.
			featureActioned := sourceElement actions feature.
			colorFA := (sourceElement actions isKindOf: SPActionSelect)
				ifFalse: Color blue
				ifTrue: Color orange.
			ROBlink unhighlightElements: (view raw elementsFromModels: featuresSelected).
			ROBlink unhighlightElements: (view raw elementsFromModels: featuresDeselected).
			ROBlink unhighlight: (view raw elementFromModel: featureActioned).
			ROBlink unhighlight: (view raw elementFromModel: sourceElement) ]! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'SimonUrli 12/17/2012 22:57'!
getAssociationsBetweenDE1: de1 andDE2: de2
	^(self mooseModel entityStorage selectAllWithType: SPDEAssociation) select: [:asso |
		((asso source applyOn == de1) & (asso target applyOn == de2)) | ((asso source applyOn == de2) & (asso target applyOn == de1) )].! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 12/18/2012 14:02'!
getKey
	"Define the legend of the visualization"
	
	| mainBox box greenBox title greenLabel blueBox blueLabel redBox redLabel yellowBox yellowLabel orangeBox orangeLabel |
	
	mainBox := (ROElement new) + (ROBox new color: (Color white); borderWidth: 1).
	
	title := (ROElement new) + (ROLabel text: 'If a feature is pointed :').
	mainBox add: title.
	title translateTo: (5 @ 5).
	
	title := (ROElement new) + (ROLabel text: 'Features :').
	mainBox add: title.
	title translateTo: (5 @ 25).
	
	greenBox := (ROElement new) + (ROBox new color: (Color green); borderWidth: 1; width: 20; height: 15).
	mainBox add: greenBox.
	greenBox translateTo: (5 @ 45).
	
	greenLabel := (ROElement new) + (ROLabel text: 'Feature pointed').
	mainBox add: greenLabel.
	greenLabel translateTo: (30 @ 45).
	
	blueBox := (ROElement new) + (ROBox new color: (Color blue); borderWidth: 1; width: 20; height: 15).
	mainBox add: blueBox.
	blueBox translateTo: (5 @ 65).
	
	blueLabel := (ROElement new) + (ROLabel text: ('Feature directly',(String with:(Character cr)), 'impacted')).
	mainBox add: blueLabel.
	blueLabel translateTo: (30 @ 65).
	
	redBox := (ROElement new) + (ROBox new color: (Color white); borderWidth: 2; borderColor: (Color red); width: 20; height: 15).
	mainBox add: redBox.
	redBox translateTo: (5 @ 100).
	
	redLabel := (ROElement new) + (ROLabel text: ('Feature secondly',(String with:(Character cr)), 'impacted')).
	mainBox add: redLabel.
	redLabel translateTo: (30 @ 100).
	
	yellowBox := (ROElement new) + (ROBox new color: (Color yellow); borderWidth: 1; width: 20; height: 15).
	mainBox add: yellowBox.
	yellowBox translateTo: (5 @ 135).
	
	yellowLabel := (ROElement new) + (ROLabel text: ('Feature implyied',(String with:(Character cr)), 'internally')).
	mainBox add: yellowLabel.
	yellowLabel translateTo: (30 @ 135).
	
	orangeBox := (ROElement new) + (ROBox new color: (Color orange); borderWidth: 1; width: 20; height: 15).
	mainBox add: orangeBox.
	orangeBox translateTo: (5 @ 170).
	
	orangeLabel := (ROElement new) + (ROLabel text: ('Feature excluded',(String with:(Character cr)), 'internally')).
	mainBox add: orangeLabel.
	orangeLabel translateTo: (30 @ 170).
	
	title := (ROElement new) + (ROLabel text: 'Rules :').
	mainBox add: title.
	title translateTo: (5 @ 205).
	
	greenBox := (ROElement new) + (ROBox new color: (Color green); borderWidth: 1; width: 20; height: 15).
	mainBox add: greenBox.
	greenBox translateTo: (5 @ 225).
	
	greenLabel := (ROElement new) + (ROLabel text: 'Rules launch').
	mainBox add: greenLabel.
	greenLabel translateTo: (30 @ 225).
	
	title := (ROElement new) + (ROLabel text: 'If a rule is pointed :').
	mainBox add: title.
	title translateTo: (5 @ 255).
	
	title := (ROElement new) + (ROLabel text: 'Features :').
	mainBox add: title.
	title translateTo: (5 @ 275).
	
	greenBox := (ROElement new) + (ROBox new color: (Color green); borderWidth: 1; width: 20; height: 15).
	mainBox add: greenBox.
	greenBox translateTo: (5 @ 295).
	
	greenLabel := (ROElement new) + (ROLabel  text: ('Source feature',(String with:(Character cr)), 'if selected')).
	mainBox add: greenLabel.
	greenLabel translateTo: (30 @ 295).
	
	redBox := (ROElement new) + (ROBox new color: (Color red); borderWidth: 1; width: 20; height: 15).
	mainBox add: redBox.
	redBox translateTo: (5 @ 330).
	
	redLabel := (ROElement new) + (ROLabel text: ('Source feature',(String with:(Character cr)), 'if deselected')).
	mainBox add: redLabel.
	redLabel translateTo: (30 @ 330).
	
	blueBox := (ROElement new) + (ROBox new color: (Color blue); borderWidth: 1; width: 20; height: 15).
	mainBox add: blueBox.
	blueBox translateTo: (5 @ 365).
	
	blueLabel := (ROElement new) + (ROLabel text: ('Target feature',(String with:(Character cr)), 'deselected')).
	mainBox add: blueLabel.
	blueLabel translateTo: (30 @ 365).
	
	orangeBox := (ROElement new) + (ROBox new color: (Color orange); borderWidth: 1; width: 20; height: 15).
	mainBox add: orangeBox.
	orangeBox translateTo: (5 @ 400).
	
	orangeLabel := (ROElement new) + (ROLabel text: ('Target feature',(String with:(Character cr)), 'selected')).
	mainBox add: orangeLabel.
	orangeLabel translateTo: (30 @ 400).
	
	title := (ROElement new) + (ROLabel text: 'Rules :').
	mainBox add: title.
	title translateTo: (5 @ 440).
	
	yellowBox := (ROElement new) + (ROBox new color: (Color yellow); borderWidth: 1; width: 20; height: 15).
	mainBox add: yellowBox.
	yellowBox translateTo: (5 @ 470).
	
	yellowLabel := (ROElement new) + (ROLabel text: ('Rule pointed')).
	mainBox add: yellowLabel.
	yellowLabel translateTo: (30 @ 470).
	^mainBox! !

!SPDomainElementGroup methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/25/2013 12:10'!
initialize
	super initialize.
	hlParent := false! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 7/25/2013 11:17'!
pointFeature: sourceElement onView: view
	| rulesNodes firstLevelModel firstLevelNodes secondLevelModel exclusions implying impliedBy |
	exclusions := OrderedCollection new.
	implying := OrderedCollection new.
	rulesNodes := OrderedCollection new.
	impliedBy := OrderedCollection new.
	
	firstLevelModel := sourceElement launchActionsOnFeatures.
	firstLevelNodes := view raw elementsFromModels: firstLevelModel.
	rulesNodes addAll: (view raw elementsFromModels: sourceElement launchRules).
			
	exclusions addAll: (sourceElement fmFeature exclusions collect: [ :if | 
				(self mooseModel allWithType: SPFeature) detect: [ :feat | 
					(sourceElement featureModel features includes: feat) & (feat shortName = if name)
				]
		]).
	
	implying addAll: (sourceElement fmFeature implying collect: [ :if | 
				(self mooseModel allWithType: SPFeature) detect: [ :feat | 
					(sourceElement featureModel features includes: feat) & (feat shortName = if name)
				]
		]).

	impliedBy addAll: (sourceElement fmFeature impliedBy collect: [ :if | 
				(self mooseModel allWithType: SPFeature) detect: [ :feat | 
					(sourceElement featureModel features includes: feat) & (feat shortName = if name)
				]
		]).



	secondLevelModel := OrderedCollection new.

	firstLevelModel do: [ :f | 
		rulesNodes addAll: (view raw elementsFromModels: f launchRules). 
		secondLevelModel addAll: (f launchActionsOnFeatures). 
		exclusions addAll: (f fmFeature exclusions collect: [:if | 
			(self mooseModel allWithType: SPFeature) detect: [:feat | 
				(f featureModel features includes: feat) & (feat shortName = if name)
			]
		]).
		implying addAll: (f fmFeature implying collect: [:if | 
			(self mooseModel allWithType: SPFeature) detect: [:feat | 
				(f featureModel features includes: feat) & (feat shortName = if name)
			]
		]).

		impliedBy addAll: (f fmFeature impliedBy collect: [:if | 
			(self mooseModel allWithType: SPFeature) detect: [:feat | 
				(f featureModel features includes: feat) & (feat shortName = if name)
			]
		]).

	
	].
	
	secondLevelModel do: [:f | 
		exclusions addAll: (f fmFeature exclusions collect: [ :if | 
			(self mooseModel allWithType: SPFeature) detect: [ :feat | 
				(f featureModel features includes: feat) & (feat shortName = if name) ]
		]).
		implying addAll: (f fmFeature implying collect: [ :if | 
			(self mooseModel allWithType: SPFeature) detect: [ :feat | 
				(f featureModel features includes: feat) & (feat shortName = if name) ]
		]).
		impliedBy addAll: (f fmFeature implying collect: [ :if | 
			(self mooseModel allWithType: SPFeature) detect: [ :feat | 
				(f featureModel features includes: feat) & (feat shortName = if name) ]
		]).
	].
	
	self turnRedBorderElementsFromModels: secondLevelModel on: view.


	ROBlink 
		highlightElements: (view raw elementsFromModels: exclusions) 
		color: Color orange.
	
	
	ROBlink 
		highlightElements:  firstLevelNodes 
		color: Color blue.
	
	ROBlink 
		highlightElements:  (view raw elementsFromModels: implying)
		color: Color yellow.

	ROBlink 
		highlightElements:  (view raw elementsFromModels: impliedBy)
		color: Color lightGray.
		
	ROBlink 
		highlightElements:  rulesNodes 
		color: Color green.! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 12/18/2012 14:02'!
switchHLBox: box text: title
	hlParent ifFalse: [
		box color: Color red.
		title text: 'HL Parent OFF'.
	] ifTrue: [
		box color: Color green.
		title text: 'HL Parent ON'.
	].! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 7/25/2013 11:57'!
switchHLBox: box text: title state: hlParentBoolean
	hlParentBoolean ifFalse: [
		box color: Color red.
		title text: 'HL Parent OFF'.
	] ifTrue: [
		box color: Color green.
		title text: 'HL Parent ON'.
	].! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 12/18/2012 16:31'!
turnBlackBorderElementsFromModels: models on: view

	| elements |
	elements := view raw elementsFromModels: models.
	
	elements do: [:n | 
		n forShape: ROBox do: [:s | s borderColor: (Color black); borderWidth: 1 ].
		"ROAddName toElement: n."
	].! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 12/18/2012 16:31'!
turnRedBorderElementsFromModels: models on: view

	| elements |
	elements := view raw elementsFromModels: models.
	
	elements do: [:n | 
		n forShape: ROBox do: [:s | s borderColor: (Color red); borderWidth: 2.].
		"ROAddName toElement: n."
	].! !

!SPDomainElementGroup methodsFor: 'visualization util' stamp: 'AlexandreBergel 7/25/2013 11:17'!
unpointFeature: sourceElement onView: view
	| allInternal rulesNodes firstLevelModel firstLevelNodes secondLevelModel secondLevelNodes |
	allInternal := OrderedCollection new.
	rulesNodes := OrderedCollection new.
	firstLevelModel := sourceElement launchActionsOnFeatures.
	firstLevelNodes := view raw elementsFromModels: firstLevelModel.
	rulesNodes addAll: (view raw elementsFromModels: sourceElement launchRules).
	allInternal
		addAll:
			(sourceElement fmFeature impactedFeatures
				collect: [ :if | 
					(self mooseModel allWithType: SPFeature)
						detect: [ :feat | (sourceElement featureModel features includes: feat) & (feat shortName = if name) ] ]).
	secondLevelModel := OrderedCollection new.
	
	firstLevelModel
		do: [ :f | 
			rulesNodes addAll: (view raw elementsFromModels: f launchRules).
			secondLevelModel addAll: f launchActionsOnFeatures.
			allInternal
				addAll:
					(f fmFeature impactedFeatures
						collect: [ :if | 
							(self mooseModel allWithType: SPFeature)
								detect: [ :feat | (f featureModel features includes: feat) & (feat shortName = if name) ] ]) ].

	secondLevelNodes := view raw elementsFromModels: secondLevelModel.
	secondLevelModel
		do: [ :f | 
			allInternal
				addAll:
					(f fmFeature impactedFeatures
						collect: [ :if | 
							(self mooseModel allWithType: SPFeature)
								detect: [ :feat | (f featureModel features includes: feat) & (feat shortName = if name) ] ]) ].

	self turnBlackBorderElementsFromModels: secondLevelModel on: view.
	ROBlink unhighlightElements: (view raw elementsFromModels: allInternal).
	ROBlink unhighlightElements: firstLevelNodes.
	ROBlink unhighlightElements: rulesNodes! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/25/2013 11:46'!
visualize
	<menuItem: 'Spine Domain Element' category: 'Visualize'>
	| view |
	view := ROMondrianViewBuilder titled: 'SPL Blueprint'.
	self visualizeOn: view.
	^ view openInWindowSized: self defaultWindowSize! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/31/2013 10:35'!
visualizeDomainElement: de on: view
	| element nodes |
	view shape label text: #name.
	view interaction forward.
	view node: de.
	view shape rectangle borderColor: Color white.
	view interaction forward.
	view
		node: de refersOn
		forIt: [ 
			element := de refersOn.
			self defineFeatureInteractionOn: view.
			view shape rectangle
				width: [ :f | f numberOfConfigurationStates * 10 ];
				height: [ :f | f weightedNumberOfLocalConstraints * 2 ].	"linearFillColor: #numberOfLocalConstraints within: (self mooseModel allWithType: SPFeature) asArray"
			nodes := element features.
			view nodes: nodes.	"view edges: nodes from: #yourself toAll: #featureChildren."
			nodes
				do: [ :n | 
					n featureChildren
						do: [ :f | 
							| edge |
							edge := view edgeFromAssociation: n -> f.
							f fmFeature setColorShape: edge ] ].
			view treeLayout ].
	^ view verticalLineLayout! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/31/2013 10:36'!
visualizeOn: view
	| assoArray center denodes nodesassociation visited |
	assoArray := (self mooseModel allWithType: SPDEAssociation) asArray.	"Contain all the association of the model"
	view shape rectangle borderColor: Color lightGray.
	denodes := 	view
		nodes: self asArray
		forEach: [ :de | 
			self visualizeDomainElement: de on: view ].
	
	visited := OrderedCollection new.
	nodesassociation := OrderedCollection new.
	
	
	self asArray do: [:de1 |
		| assos node targetNode sourceNode |
		visited add: de1.
		self asArray do: [: de2 |
			(visited includes: de2) ifFalse: [
				assos := self getAssociationsBetweenDE1: de1 andDE2: de2.

				assos ifNotEmpty: [
				view shape rectangle borderColor: Color lightGray.
				node := view node: (assos) forIt: [
					
					view shape rectangle
						fillColor:
							(RONColorLinearNormalizer
								inContext: assoArray
								withCommand: #numberOfRules
								lowColor: Color white
								highColor: Color red).
					view interaction popupText: [ :a | a popupText ].
					view interaction forward.
					view nodes: assos forEach: [ :asso | 
						view shape label text: #getDescription.
						view interaction forward.
						view node: asso.
						view interaction forward.
						view
							nodes: asso restrictionFunctions forEach: [ :rf | 
								view interaction popupText: [ :r | r popupText ].
								self defineRuleInteractionOnView: view.
								view shape rectangle
									linearFillColor: #numberOfFeaturesImplicated
									within: (self mooseModel allWithType: SPRule) asArray.
								view nodes: rf rules.
								view flowLayout gapSize: 2 ].
					view flowLayout ].
					
					view verticalLineLayout.
				].

				nodesassociation add: node.
				targetNode := view raw elementFromModel: de1.
				sourceNode := view raw elementFromModel: de2.
				view raw add: (self associationEdgeFrom: node to: targetNode).
				view raw add: (self associationEdgeFrom: sourceNode to: node).
			].
			].
		].
	].
	"nodesassociation := view
		nodes: assoArray
		forEach: [ :asso | 
			view shape label text: #getDescription.
			view interaction forward.
			view node: asso.
			view interaction forward.
			view
				nodes: asso restrictionFunctions
				forEach: [ :rf | 
					view interaction popupText: [ :r | r popupText ].
					self defineRuleInteractionOnView: view.
					view shape rectangle
						linearFillColor: #numberOfFeaturesImplicated
						within: (self mooseModel allWithType: SPRule) asArray.
					view nodes: rf rules.
					view gridLayout ].
			view flowLayout ]."
	
	"assoArray
		do: [ :asso | 
			|  Name is already defined ->node targetNode sourceNode |
			node := view raw elementFromModel: asso.
			targetNode := view raw elementFromModel: asso target applyOn.
			sourceNode := view raw elementFromModel: asso source applyOn.
			view raw add: (self associationEdgeFrom: node to: targetNode).
			view raw add: (self associationEdgeFrom: sourceNode to: node) ]."


	"ROCircleLayout new
		scaleBy: 65;
		on: nodesassociation.
	ROCircleLayout new
		scaleBy: 55;
		on: denodes."
	
	"ROCircleLayout new 
		scaleBy: 50;
		on: nodesassociation, denodes."

"	ROForceBasedLayout new iterations: 50;
		repellingForce: 700;
		attractingForce: 0.02; on: nodesassociation, denodes.
"	
	"ROForceBasedLayout new on: nodesassociation, denodes."
"	ROCircleLayout new on: denodes."
	ROGridLayout new on: denodes.

		
	center := nodesassociation size * 65 - (denodes size * 65).
	denodes do: [ :el | el translateBy: center @ center ].
	ROFocusView new view: view raw toPosition: center @ center.
	view noLayout.
	
	self defineButton: view stack.
	self addHighlightParentButtonOn: view.
	self addKeyLegendButtonOn: view.
! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/31/2013 10:31'!
visualizeSimple
	<menuItem: 'Simple Spine Domain Element' category: 'Visualize'>
	| view |
	view := ROMondrianViewBuilder titled: 'Simple SPL Blueprint'.
	self visualizeSimpleOn: view.
	^ view openInWindowSized: self defaultWindowSize! !

!SPDomainElementGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/31/2013 10:36'!
visualizeSimpleOn: view
	view shape rectangle borderColor: Color lightGray.
	view
		nodes: self asArray
		forEach: [ :de | 
			self visualizeDomainElement: de on: view ].
	view gridLayout.
	self defineButton: view stack.
	self addHighlightParentButtonOn: view.
	self addKeyLegendButtonOn: view! !

MooseGroup subclass: #SPFeatureGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 11/23/2012 12:08'!
visualizeSPINE
	<menuItem: 'Spine Feature System' category: 'Visualize'> 
	
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeSPINEOn: view.
	view open.! !

!SPFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 11/23/2012 12:16'!
visualizeSPINEOn: view

	view shape rectangle
		width: [ :f | f numberOfActions * 10 ];
		height: [ :f | f numberOfConfigurationStates * 10 ].
		
	view nodes: self asArray.
	
	view gridLayout ! !

MooseGroup subclass: #SPFeatureModelGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPFeatureModelGroup methodsFor: 'visualization' stamp: 'SimonUrli 11/23/2012 16:13'!
visualizeSPINE
	<menuItem: 'Spine Feature Model System' category: 'Visualize'> 
	
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeSPINEOn: view.
	view open.! !

!SPFeatureModelGroup methodsFor: 'visualization' stamp: 'SimonUrli 11/23/2012 16:06'!
visualizeSPINEOn: view

	view shape rectangle
		width: [ :f | f numberOfActions * 10 ];
		height: [ :f | f numberOfConfigurationStates * 10 ].
		
	view nodes: (self asArray) forEach:[:element |
		view shape rectangle
			width: [ :f | f numberOfActions * 10 ];
			height: [ :f | f numberOfConfigurationStates * 10 ].
		view nodes: element features.
	].
	
	view gridLayout ! !

MooseEntity subclass: #FMObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMObject subclass: #FMConstraintExpr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMConstraintExpr subclass: #FMConstraintBinOp
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMConstraintBinOp subclass: #FMConstraintAnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '&'! !

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	^ 'and'! !

!FMConstraintAnd methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintAnd: self.
	super accept: aVisitor! !

FMConstraintBinOp subclass: #FMConstraintArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintArrow class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '->'! !

!FMConstraintArrow methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:40'!
accept: aVisitor
	aVisitor visitConstraintArrow: self.
	super accept: aVisitor! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:26'!
for: string
	"Return the class that correspond to the string. 
	We here assume that all the subclasses have a distint operator"
	^ self allSubclasses detect: [:cls | (cls operator = string) or: [ cls operator2 = string ] ]! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 10:00'!
operator
	^ self subclassResponsibility ! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	"Express the alternative of operator, for example or | and and &"
	^ self operator! !

!FMConstraintBinOp methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor

	left accept: aVisitor.
	right accept: aVisitor.! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 09:58'!
features
	"Return the list of features that are recursively obtained from myself"
	
	| v |
	v := CountingFeatureVisitor new.
	self accept: v.
	^ v features! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left
	^ left! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left: anObject
	left := anObject! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right
	^ right! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right: anObject
	right := anObject! !

FMConstraintBinOp subclass: #FMConstraintEquiv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintEquiv class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '<->'! !

!FMConstraintEquiv methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintEquiv: self.
	super accept: aVisitor! !

FMConstraintBinOp subclass: #FMConstraintPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '|'! !

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	^ 'or'! !

!FMConstraintPipe methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintPipe: self.
	super accept: aVisitor! !

!FMConstraintExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	self subclassResponsibility ! !

FMConstraintExpr subclass: #FMConstraintNegated
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintNegated methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintNegated: self.
	expr accept: aVisitor! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr
	^ expr! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr: anObject
	expr := anObject! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:23'!
features
	^ expr features! !

FMObject subclass: #FMFeature
	instanceVariableNames: 'name featureModel kind constraintsCache subFeaturesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeature class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/2/2012 11:01'!
named: aName
	^ self new name: aName; yourself! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 11/23/2012 09:59'!
= aFeature
	^ (self name = aFeature name) 
	"^ (self name = aFeature name) and: [ self featureModel == aFeature featureModel ]"! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
accept: aVisitor 
	aVisitor visitFeature: self! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/4/2012 14:37'!
constrainedFeatures
	<navigation: 'constrained features'>
	^ ((self constraints inject: #() into: [ :sum :c | sum , c features ]) asSet asArray) copyWithout: self! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:11'!
constraints
	"Return the list of constraints in which I am involved"
	
	constraintsCache ifNotNil: [ ^ constraintsCache ].
	^ constraintsCache := featureModel constraintsContainingFeature: self! !

!FMFeature methodsFor: 'visualizing' stamp: 'SimonUrli 12/12/2012 20:27'!
constraintsInfo
	| str |
	
	str := WriteStream on: String new.
	(self impliedBy copyFrom: 1 to: (self impliedBy size min: 5)) do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll: f name, ' -> '
		].
	(self impliedBy size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self impliedBy size printString, ')'		
	].

	(self implying copyFrom: 1 to: (self implying size min: 5))  do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll:  ' -> ', f name
		].
	(self implying size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self implying size printString, ')'	
	].

	(self exclusions copyFrom: 1 to: (self exclusions size min: 5))  do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll:  ' -> !!', f name
		].
	(self exclusions size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self exclusions size printString, ')'	
	].
	^ str contents! !

!FMFeature methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 17:03'!
description

	| v |
	self isOr ifTrue: [ v := ' or' ].
	self isXor ifTrue: [ v := ' xor' ].
	self isMandatory ifTrue: [ v := ' mendatory' ].
	self isMutex ifTrue: [ v := ' mutex' ].
	self isOptional ifTrue: [ v := ' optional' ].	 

	^ ' Feature ', self name, v, self constraintsInfo! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 16:40'!
exclusions
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v exclusions! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:11'!
featureModel
	"Return the feature model that defines me"
	
	^ featureModel! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:25'!
featureModel: fm
	featureModel := fm! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 7/2/2012 11:00'!
hash
	^ self name hash! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 12/18/2012 17:07'!
impactedFeatures
	^ self exclusions, self implying, self impliedBy! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/4/2012 17:27'!
impliedBy
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v featuresImplied! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/4/2012 17:27'!
implying
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v featuresImplying! !

!FMFeature methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/3/2012 17:14'!
initialize 
	"We say that per default, a feature is mendatory. Actually, the kind variable is always set"

	super initialize.
	kind := FMFeatureMendatory new! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory
	^ kind isMandatory! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isMutex
	^ kind isMutex! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isOptional
	^ kind isOptional! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isOr
	^ kind isOr! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isXor
	^ kind isXor! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
kind
	"return the instance of FMFeatureExpr that says whether I am mendatory, mutex, or, xor, or optional"

	^ kind! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 18:10'!
kind: anObject
	kind := anObject! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
name
	"My name"
	^ name! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
name: aString
	"My name"
	name := aString! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/3/2012 17:14'!
numberOfConstraints
	"Return the number of constraints in which I am involved"
	
	^ self constraints size! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/6/2012 17:34'!
numberOfExclusions 
	^ self exclusions size! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 11:45'!
numberOfFeaturesImpliedBy
	^ self impliedBy size
! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 11:42'!
numberOfFeaturesImplying
	^ self implying size! !

!FMFeature methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/26/2013 10:39'!
setColorShape: edge
	| shape |
	shape := edge getShape: ROLine.
	self isOr ifTrue: [  shape width: 2; color: (Color black). ].
	self isXor ifTrue: [ shape width: 2. ].
	self isMandatory ifTrue: [ ].
	self isMutex ifTrue: [ shape color: (Color green).].
	self isOptional ifTrue: [  shape color: (Color blue).  ].	 
! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/3/2012 14:14'!
subFeatures
	<navigation: 'sub features'>
	subFeaturesCache ifNotNil: [ ^ subFeaturesCache ].
  
	^ subFeaturesCache := featureModel subFeaturesOf: self! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/26/2013 08:34'!
weightedNumberOfLocalConstraints
	| v |
	v := FMWeightedVisitor new.
	self constraints do: [ :c | c accept: v ].
	^ v weight! !

FMObject subclass: #FMFeatureExpr
	instanceVariableNames: 'feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:15'!
accept: aVisitor
	feature accept: aVisitor
	! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:57'!
feature
	^ feature! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 18:10'!
feature: aFeature
	feature := aFeature.
	aFeature kind: self.! !

!FMFeatureExpr methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isMutex
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isOptional
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isOr
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isXor
	^ false! !

!FMFeatureExpr methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 10:45'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: id ].
	str nextPut: $>.! !

FMFeatureExpr subclass: #FMFeatureMendatory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureMendatory methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory 
	^ true! !

FMFeatureExpr subclass: #FMFeatureMutex
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureMutex methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isMutex 
	^ true! !

FMFeatureExpr subclass: #FMFeatureOptional
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureOptional methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isOptional 
	^ true! !

FMFeatureExpr subclass: #FMFeatureOr
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureOr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isOr
	^ true! !

FMFeatureExpr subclass: #FMFeatureXor
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureXor methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isXor
	^ true! !

FMObject subclass: #FMFeatureModel
	instanceVariableNames: 'exprs constraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureModel methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:45'!
accept: aVisitor 
	aVisitor visitFeatureModel: self.
	exprs do: [ :expr | expr accept: aVisitor ]. 
	constraints do: [ :cons | cons accept: aVisitor ].! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/2/2012 13:25'!
addAllConstraints: cons
	self assert: [ cons isCollection ].
	self assert: [ cons isEmpty or: [ cons first isKindOf: FMConstraintExpr ] ].
	constraints addAll: cons! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:22'!
addAllExpressions: exps
	exprs addAll: exps! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
constraintAt: index
	^ constraints at: index! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 09:51'!
constraintsContainingFeature: aFeature
	
	| v |
	^ self constraintsSelect: [ :cons | 
		cons features anySatisfy: [ :f | f name = aFeature name ] ]! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 15:00'!
constraintsInfo
	^ ''! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 14:34'!
constraintsSelect: aBlock
	^ constraints select: aBlock! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:44'!
featureNamed: aName 
	^ self features detect: [ :f | f name = aName ]! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:28'!
features
	| v |
	v := CountingFeatureVisitor new.
	self accept: v.
	v features do: [ :f | f featureModel: self ].
	^ v features! !

!FMFeatureModel methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:26'!
initialize 
	super initialize.
	exprs := OrderedCollection new.
	constraints := OrderedCollection new! !

!FMFeatureModel methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 14:15'!
mooseNameOn: str 

	str nextPutAll: 'FM ('.
	exprs
		do: [ :expr | str nextPutAll: expr root name ].
	str nextPutAll: ')'.
	^ str contents! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfConstraints
	<MSEProperty: #numberOfConstraints type: #Number>
	^ constraints size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 10:41'!
numberOfFeatures
	^ self features size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfProductions
	<MSEProperty: #numberOfProductions type: #Number>
	^ exprs size! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
productionAt: index
	^ exprs at: index! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:49'!
setInteractionOfFeature: view
	view interaction 
			popupText: #description;
	
			item: 'constrained features' action: [ :f | f constrainedFeatures inspect ];
			item: 'inspect' action: #inspect;
			item: 'implications' action: [ :e | self visualizeImplications ];
						
			highlightWhenOver: #implying color: Color lightBlue;
			highlightWhenOver: #impliedBy color: Color blue;
			highlightWhenOver: #exclusions color: Color red.
			"highlightWhenOver: #constrainedFeatures color: Color green"! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:45'!
subFeaturesOf: aFMFeature 
	^ ((exprs detect: [ :prod | prod root = aFMFeature ] ifNone: [ ^ #() ] ) allChildren collect: #feature) asArray! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:46'!
viewComplexityOn: view

	view node: self forIt: [		
		view shape rectangle 
			"size:  [ :f | f numberOfConstraints * 3 ];"
			height: [ :f | f numberOfFeaturesImplying * 3 ];
			width: [ :f | f numberOfFeaturesImpliedBy * 3 ]; 
			borderWidth: [ :f |  f numberOfExclusions max: 1 ];
			if: #isMandatory fillColor: Color white;
			if: #isOr fillColor: Color pink;
			if: #isMutex fillColor: Color lightYellow;
			if: #isOptional fillColor: Color lightGray;
			if: #isXor fillColor: Color yellow.
		self setInteractionOfFeature: view.
		view nodes: self features.
					
		view edges: self features from: #yourself toAll: #subFeatures.
		view treeLayout ].
	! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:46'!
visualizeImplications
	| view |
	view := ROMondrianViewBuilder new.
	
	view shape rectangle 
			"size:  [ :f | f numberOfConstraints * 3 ];"
			height: [ :f | f numberOfFeaturesImplying * 3 ];
			width: [ :f | f numberOfFeaturesImpliedBy * 3 ]; 
			borderWidth: [ :f |  f numberOfExclusions max: 1 ];
			if: #isMandatory fillColor: Color white;
			if: #isOr fillColor: Color pink;
			if: #isMutex fillColor: Color lightYellow;
			if: #isOptional fillColor: Color lightGray;
			if: #isXor fillColor: Color yellow.
			
	view nodes: self features.
	
	view shape arrowedLineWithOffset: 0.3; color: Color green.
	view edges: self features from: #yourself toAll: #implying.

	view shape line color: Color red.
	view edges: self features from: #yourself toAll: #exclusions.

	view circleLayout .
	view open! !

FMObject subclass: #FMFeatureProduction
	instanceVariableNames: 'root children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureProduction methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:50'!
accept: aVisitor
	root accept: aVisitor.
	children do: [ :child | child accept: aVisitor ] ! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:32'!
addAll: featureExpressions
	self assert: [ featureExpressions isCollection ].

	children addAll: featureExpressions! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:43'!
allChildren
	^ children copy! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:37'!
childAt: index
	^ children at: index! !

!FMFeatureProduction methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 10:32'!
initialize
	super initialize.
	children := OrderedCollection new! !

!FMFeatureProduction methodsFor: 'metrics' stamp: 'AlexandreBergel 7/1/2012 10:37'!
numberOfChildren
	^ children size! !

!FMFeatureProduction methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 15:23'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: root ].
	str nextPut: $>.! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root
	^ root! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root: anObject
	root := anObject! !

!FMObject methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/23/2012 09:22'!
resolve! !

FMObject subclass: #FMProgram
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMProgram methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:03'!
accept: aVisitor
	aVisitor visitProgram: self.
	self statements do: [ :s | s accept: aVisitor ]! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 14:57'!
add: aStatement
	statements add: aStatement ! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:06'!
addAll: ss
	ss do: [ :s | self add: s ]! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:09'!
featureNamed: aName
	| v t |
	v := CollectingVisitor new.
	self accept: v.
	t := (v elementsOfKind: FMFeature) select: [ :f | f name = aName ] .
	self assert: [ t size =  1 ].
	^ t first! !

!FMProgram methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:57'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:24'!
lastStatement 
	^ statements last! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:58'!
numberOfStatements
	<MSEProperty: #numberOfStatements type: #Number>
	^ statements size! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/3/2012 16:56'!
numberOfVariables
	^ (self statements collect: #variable) asSet size! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:08'!
statementAt: index
	^ statements at: index! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 00:14'!
statements
	^ statements copy! !

FMObject subclass: #FMStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMStatement subclass: #FMAssignment
	instanceVariableNames: 'variable featureModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMAssignment methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
accept: aVisitor
	aVisitor visitAssigment: self.
	
	aVisitor visitVariable: variable.
	featureModel accept: aVisitor.! !

!FMAssignment methodsFor: 'navigating' stamp: 'AlexandreBergel 7/2/2012 00:57'!
featureModel
	<navigation: 'Feature model'>
	^ featureModel! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
featureModel: anObject
	featureModel := anObject! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 11:35'!
mooseFinderComplexityIn: composite
	<moosePresentationOrder: 20>
	
	composite roassal 
			title: 'Complexity';
			titleIcon: MooseIcons mooseBlueprint;
			painting: [ :view :each | each mooseInterestingEntity viewComplexityOn: view ]! !

!FMAssignment methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 00:49'!
mooseNameOn: str
	str nextPutAll: variable! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 16:59'!
setInteractionOfNodes: view
	view interaction 
			popupText: #description;

			item: 'constrained features' action: [ :f | f constrainedFeatures inspect ];
			highlightWhenOver: #impliedBy color: Color green! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable
	^ variable! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable: anObject
	variable := anObject! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:14'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view assignments |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"
	self viewComplexityOn: view.
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 11:39'!
viewComplexityOn: view
	| fm |

	view interaction popupText: self variable; action: #inspect.
	featureModel viewComplexityOn: view.
! !

MooseEntity subclass: #SPObject
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPObject subclass: #SPAbstractAction
	instanceVariableNames: 'fm feature rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
feature
	^ feature! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
feature: anObject
	feature := anObject! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
fm
	^ fm! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
fm: anObject
	fm := anObject! !

!SPAbstractAction methodsFor: 'resolving dependencies' stamp: 'SimonUrli 12/11/2012 11:26'!
resolve
	fm := self mooseModel entityNamed: (self fm).
	self assert: [fm isKindOf: SPFeatureModel].

	feature  :=self mooseModel entityNamed: (self feature).
	self assert: [ feature isKindOf: SPFeature ].
	
! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:33'!
rule
	^ rule! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:33'!
rule: anObject
	rule := anObject! !

SPAbstractAction subclass: #SPActionDeselect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPActionDeselect methodsFor: 'as yet unclassified' stamp: 'SimonUrli 12/5/2012 14:39'!
description
	^'deselect'! !

SPAbstractAction subclass: #SPActionSelect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPActionSelect methodsFor: 'as yet unclassified' stamp: 'SimonUrli 12/5/2012 14:39'!
description
	^'select'! !

SPObject subclass: #SPConfigurationState
	instanceVariableNames: 'fm selected deselected rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
deselected
	^ deselected! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
deselected: anObject
	deselected := anObject! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:55'!
fm
	^ fm! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:55'!
fm: anObject
	fm := anObject! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'SimonUrli 12/3/2012 14:45'!
numberOfFeatures
	^ self selected size + self deselected size! !

!SPConfigurationState methodsFor: 'resolving dependencies' stamp: 'SimonUrli 12/12/2012 12:30'!
resolve
	selected  := selected collect: [ :idName | self mooseModel entityNamed: idName ].
	"self assert: [ selected allSatisfy: [ :obj | obj isKindOf: FMFeature ] ]."

	deselected  := deselected collect: [ :idName | self mooseModel entityNamed: idName ].
	"self assert: [ deselected allSatisfy: [ :obj | obj isKindOf: FMFeature ] ]."
	
	fm := self mooseModel entityNamed: self fm.
	self assert: [ fm isKindOf: SPFeatureModel ].! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:36'!
rule
	^ rule! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:36'!
rule: anObject
	rule := anObject! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
selected
	^ selected! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
selected: anObject
	selected := anObject! !

SPObject subclass: #SPDEAssociation
	instanceVariableNames: 'source target restrictionFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDEAssociation methodsFor: 'accessing' stamp: 'SimonUrli 12/12/2012 16:20'!
getDescription
	^self source applyOn name , '->' , self target applyOn name! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'SimonUrli 11/27/2012 18:52'!
numberOfRules
	| total |
	total := 0.
	self restrictionFunctions do: [:rf | total := total + rf rules size].
	^total! !

!SPDEAssociation methodsFor: 'vizualisation' stamp: 'SimonUrli 12/4/2012 14:22'!
popupText
	^self getDescription , (String with: Character cr) , 'Functions: ' , self restrictionFunctions size printString
		, (String with: Character cr) , 'Rules: ' , self numberOfRules printString! !

!SPDEAssociation methodsFor: 'resolving dependencies' stamp: 'SimonUrli 12/12/2012 15:40'!
resolve
	source  := self mooseModel entityNamed: source.
	self assert: [ source isKindOf: SPDomainElementEnd ].

	target  := self mooseModel entityNamed: target.
	self assert: [ target isKindOf: SPDomainElementEnd ].
	
	restrictionFunctions := restrictionFunctions collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ restrictionFunctions allSatisfy: [ :obj | obj isKindOf: SPRestrictionFunction ] ].! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
restrictionFunctions
	^ restrictionFunctions! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
restrictionFunctions: anObject
	restrictionFunctions := anObject! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
source
	^ source! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
source: anObject
	source := anObject! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
target
	^ target! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
target: anObject
	target := anObject! !

SPObject subclass: #SPDomainElement
	instanceVariableNames: 'belongsTo refersOn multiplicityElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDomainElement methodsFor: 'accessing' stamp: 'SimonUrli 12/12/2012 15:53'!
associatedDomainElements
	| listeDESource |
	listeDESource := self belongsTo collect: [ :asso | asso source applyOn ].
	^ listeDESource select: [:de | de ~~ self]. ! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
belongsTo
	^ belongsTo! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
belongsTo: anObject
	belongsTo := anObject! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:53'!
multiplicityElement
	^ multiplicityElement! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:53'!
multiplicityElement: anObject
	multiplicityElement := anObject! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
refersOn
	^ refersOn! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
refersOn: anObject
	refersOn := anObject! !

!SPDomainElement methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 7/25/2013 06:18'!
resolve
	| ref |
	refersOn  := self mooseModel entityNamed: refersOn.
	self assert: [ refersOn isKindOf: SPFeatureModel ].

	multiplicityElement  := self mooseModel entityNamed: multiplicityElement.
	self assert: [ multiplicityElement isKindOf: SPMultiplicityElement ].
	
	ref := belongsTo collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ ref allSatisfy: #notNil ] description: 'Reference without a definition. Please check'.
	belongsTo := belongsTo collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ belongsTo allSatisfy: [ :obj | obj isKindOf: SPDEAssociation ] ].! !

!SPDomainElement methodsFor: 'visualize' stamp: 'AlexandreBergel 12/18/2012 16:06'!
visualize
	<menuItem: 'Spine Domain Element' category: 'Visualize'> 
	
	SPDomainElementGroup new add: self; visualize! !

SPObject subclass: #SPDomainElementEnd
	instanceVariableNames: 'applyOn linkMultiplicity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
applyOn
	^ applyOn! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
applyOn: anObject
	applyOn := anObject! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
linkMultiplicity
	^ linkMultiplicity! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
linkMultiplicity: anObject
	linkMultiplicity := anObject! !

!SPDomainElementEnd methodsFor: 'resolving dependencies' stamp: 'SimonUrli 12/12/2012 15:51'!
resolve
	applyOn := self mooseModel entityNamed: applyOn.
	self assert: [ applyOn isKindOf: SPDomainElement ].
	
	linkMultiplicity := self mooseModel entityNamed: linkMultiplicity.
	self assert: [ linkMultiplicity isKindOf: SPMultiplicityElement ].! !

SPObject subclass: #SPFeature
	instanceVariableNames: 'fmFeature shortName featureModel featureChildren parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/26/2012 17:26'!
actions
	^ (self deselectedActions),(self selectedActions)! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:34'!
configurationDeselectedStates
	^ (self mooseModel allWithType: SPConfigurationState) select: [ :config | config deselected includes: self ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:34'!
configurationSelectedStates
	^ (self mooseModel allWithType: SPConfigurationState) select: [ :config | config selected includes: self ]! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/26/2012 15:57'!
configurationStates
	^ (self mooseModel allWithType: SPConfigurationState) select: [ :config | (config deselected includes: self) | (config selected includes: self) ]! !

!SPFeature methodsFor: 'visualize' stamp: 'SimonUrli 12/6/2012 13:51'!
createFeatureNodesOn: view fromCenterNode:centerNode toElement: f fillColor: filling arrowColor: arrow textColor: text popupText: popup
	| node edge |
	view shape rectangle fillColor: filling.
	view interaction popupText: [ :feat | popup ].
	view interaction
			on: ROMouseLeftClick
			do: [ :el | view raw elementsDo: #remove. el model visualizeOn: view. view raw signalUpdate. ].
	node := view node: f forIt: [ 
		view interaction forward.
		view shape label text: #name; color: text.
		view node: f.
	].
	edge := ROEdge from: centerNode to: node.
	edge + ((ROLine new color:arrow) add: ROArrow new offset: 0.6).
	view raw add: (edge).
	^node ! !

!SPFeature methodsFor: 'visualize' stamp: 'SimonUrli 12/6/2012 16:11'!
createFeatureNodesOn: view withElement: f centerNode:centerNode fillColor: filling arrowColor: arrow textColor: text popupText: popup
	| node edge |
	view shape rectangle fillColor: filling.
	view interaction popupText: [ :feat | popup ].
	view interaction
			on: ROMouseLeftClick
			do: [ :el | view raw elementsDo: #remove. el model visualizeOn: view. view raw signalUpdate. ].
	node := view node: f forIt: [ 
		view interaction forward.
		view shape label text: #name; color: text.
		view node: f.
	].
	edge := ROEdge from: node to: centerNode.
	edge + ((ROLine new color:arrow) add: ROArrow new offset: 0.6).
	edge @ ROPopup.
	view raw add: (edge).
	^node ! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:03'!
deselectFeaturesWhenIsDeselected
	| cs  rules features |
	cs := self configurationStates select: [:c | c deselected includes: self].
	rules := cs collect: [:c | c rule].
	rules := rules select: [:r | (r actions isKindOf: SPActionDeselect)].
	features := (rules collect: [:r | r actions feature ]) asArray.
	^features! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:03'!
deselectFeaturesWhenIsSelected
	| cs  rules features |
	cs := self configurationStates select: [:c | c selected includes: self].
	rules := cs collect: [:c | c rule].
	rules := rules select: [:r | (r actions isKindOf: SPActionDeselect)].
	features := (rules collect: [:r | r actions feature ]) asArray.
	^features! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/11/2012 11:30'!
deselectedActions
	^ (self mooseModel allWithType: SPActionDeselect) select: [ :action | action feature == self ]! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:02'!
deselectedFeaturesWhichDeselectIt
	| cs selected deselected retour rules |
	rules := self deselectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray.
	deselected := (cs collect: [:c | c deselected ]) asArray flatten.
	retour := deselected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:01'!
deselectedFeaturesWhichSelectIt
	| cs selected deselected retour rules |
	rules := self selectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray.
	deselected := (cs collect: [:c | c deselected ]) asArray flatten.
	retour := deselected.
	^retour! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:45'!
featureChildren
	^ featureChildren! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:45'!
featureChildren: anObject
	featureChildren := anObject! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:13'!
featureModel
	^ featureModel! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:13'!
featureModel: anObject
	featureModel := anObject! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:29'!
fmFeature
	^ fmFeature! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:29'!
fmFeature: anObject
	fmFeature := anObject! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/7/2012 15:15'!
getNeighboursFeaturesExcludedByInternalConstraints
	^self fmFeature exclusions collect: [:if | 
				(self mooseModel allWithType: SPFeature) detect: [:feat | 
					(self featureModel features includes: feat) & (feat shortName = if name)
				]
			].! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/5/2012 11:40'!
getNeighboursFeaturesImpactedByInternalConstraints
	^self fmFeature impactedFeatures collect: [:if | 
				(self mooseModel allWithType: SPFeature) detect: [:feat | 
					(self featureModel features includes: feat) & (feat shortName = if name)
				]
			].! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/7/2012 15:15'!
getNeighboursFeaturesImpliedByInternalConstraints
	^self fmFeature implying collect: [:if | 
				(self mooseModel allWithType: SPFeature) detect: [:feat | 
					(self featureModel features includes: feat) & (feat shortName = if name)
				]
			].! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 15:58'!
isLaunchedByFeatures
	| cs selected deselected retour rules |
	rules := self actions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	selected := (cs collect: [:c | c selected ]) asArray flatten.
	deselected := (cs collect: [:c | c deselected ]) asArray flatten.
	retour := selected,deselected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 16:00'!
launchActionsOnFeatures
	| actions retour rules |
	rules := self configurationStates collect: [:cs | cs rule].
	actions := rules collect: [:r | r actions ].
	retour := (actions collect: [:a | a feature ]) asArray.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/4/2012 17:23'!
launchRules
	| actions retour rules |
	rules := self configurationStates collect: [:cs | cs rule].
	^rules asArray ! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 12:18'!
numberOfActions
	<MSEProperty: #numberOfActions type: #Number>
	<MSEComment: 'The number of actions that uses me'>
	
	^self
		lookUpPropertyNamed: #numberOfActions
		computedAs: [ self numberOfDeselectedActions + self numberOfSelectedActions ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 12:18'!
numberOfConfigurationDeselectedStates
	<MSEProperty: #numberOfConfigurationDeselectedStates type: #Number>
	<MSEComment: 'The number of configuration state that deselect me'>
	
	^self
		lookUpPropertyNamed: #numberOfConfigurationDeselectedStates
		computedAs: [ self configurationDeselectedStates size ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 12:18'!
numberOfConfigurationSelectedStates
	<MSEProperty: #numberOfConfigurationSelectedStates type: #Number>
	<MSEComment: 'The number of configuration state that select me'>
	
	^self
		lookUpPropertyNamed: #numberOfConfigurationDeselectedStates
		computedAs: [ self configurationSelectedStates size ]! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/26/2012 16:02'!
numberOfConfigurationStates
	<MSEProperty: #numberOfConfigurationStates type: #Number>
	<MSEComment: 'The number of configuration states that uses me'>
	
	^self
		lookUpPropertyNamed: #numberOfConfigurationStates
		computedAs: [ self configurationStates size ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:38'!
numberOfDeselectedActions
	^ self deselectedActions size! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/27/2012 16:30'!
numberOfLocalConstraints
	^ self fmFeature numberOfConstraints! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:38'!
numberOfSelectedActions
	^ self selectedActions size! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 12/6/2012 14:59'!
parent
	^ parent! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 12/6/2012 14:59'!
parent: anObject
	parent := anObject! !

!SPFeature methodsFor: 'visualize' stamp: 'AlexandreBergel 7/26/2013 09:10'!
popupText
	^ self name , (String with: Character cr) , 'Internal constraints: ' , self numberOfLocalConstraints printString
		, (String with: Character cr) , 'Weighted Internal constraints: ' , self weightedNumberOfLocalConstraints printString
		, (String with: Character cr) , 'Launch ' , self launchActionsOnFeatures size printString , ' actions'
		, (String with: Character cr) , 'Affected by: ' , self isLaunchedByFeatures size printString , ' features'
		, (String with: Character cr) , self fmFeature constraintsInfo.! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 12/7/2012 10:27'!
recursivelyGetParents: list
	self parent ifNotNil: [
		list add: self parent.
		self parent recursivelyGetParents:list.
	].
	^list! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:03'!
selectFeaturesWhenIsDeselected
	| cs  rules features |
	cs := self configurationStates select: [:c | c deselected includes: self].
	rules := cs collect: [:c | c rule].
	rules := rules select: [:r | (r actions isKindOf: SPActionSelect)].
	features := (rules collect: [:r | r actions feature ]) asArray.
	^features! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:02'!
selectFeaturesWhenIsSelected
	| cs  rules features |
	cs := self configurationStates select: [:c | c selected includes: self].
	rules := cs collect: [:c | c rule].
	rules := rules select: [:r | (r actions isKindOf: SPActionSelect)].
	features := (rules collect: [:r | r actions feature ]) asArray.
	^features! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/11/2012 11:30'!
selectedActions
	^ (self mooseModel allWithType: SPActionSelect) select: [ :action | action feature == self ]! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:02'!
selectedFeaturesWhichDeselectIt
	| cs selected deselected retour rules |
	rules := self deselectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray.
	selected := (cs collect: [:c | c selected ]) asArray flatten.
	retour := selected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 12/12/2012 17:01'!
selectedFeaturesWhichSelectIt
	| cs selected deselected retour rules |
	rules := self selectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray.
	selected := (cs collect: [:c | c selected ]) asArray flatten.
	retour := selected.
	^retour! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:35'!
shortName
	^ shortName! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:35'!
shortName: anObject
	shortName := anObject! !

!SPFeature methodsFor: 'visualize' stamp: 'AlexandreBergel 7/25/2013 05:15'!
visualize
	<menuItem: 'Spine Domain Element' category: 'Visualize'> 
	
	| view rawView |
	rawView := ROView new.
	view := ROMondrianViewBuilder view:rawView.
	"view withPopup."
	self visualizeOn: view.
	view open.! !

!SPFeature methodsFor: 'visualize' stamp: 'SimonUrli 12/7/2012 15:24'!
visualizeOn: view
	| centerNode allNodes center parentNode |
	
	view shape rectangle fillColor: (Color white).
	centerNode := view node: self forIt:[
		view interaction forward.
		view shape label text: #name.
		view node: self.
	].
	allNodes := Set new.
	
	self parent ifNotNil: [
		parentNode := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: (self parent) fillColor: (Color purple) arrowColor:  (Color purple) textColor: (Color white) popupText: ('The parent feature', (String with: (Character cr)),'of the central feature.').
		allNodes add: parentNode.
	].

	self featureChildren do:  [ :f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color lightGray) arrowColor:  (Color lightGray) textColor: (Color black) popupText: ('A children feature', (String with: (Character cr)),'of the central feature.').
		allNodes add: node.
		].

	 self selectedFeaturesWhichSelectIt do: [:f |
		| node |
		node := self createFeatureNodesOn: view withElement: f centerNode: centerNode fillColor: (Color cyan) arrowColor:  (Color green) textColor: (Color black) popupText: ('Central feature is selected', (String with: (Character cr)),'if this one is selected').
		allNodes add: node.
        ].

	self deselectedFeaturesWhichSelectIt do: [:f |
		| node |
		node := self createFeatureNodesOn: view withElement: f centerNode: centerNode fillColor: (Color black) arrowColor:  (Color green) textColor: (Color white) popupText: ('Central feature is selected', (String with: (Character cr)),'if this one is deselected').
		allNodes add: node.
        ].

	self deselectedFeaturesWhichDeselectIt do: [:f |
		| node |
		node := self createFeatureNodesOn: view withElement: f centerNode: centerNode fillColor: (Color black) arrowColor:  (Color red) textColor: (Color white) popupText: ('Central feature is deselected', (String with: (Character cr)),'if this one is deselected').
		allNodes add: node.
	].

	self selectedFeaturesWhichDeselectIt do: [:f |
		| node |
		node := self createFeatureNodesOn: view withElement: f centerNode: centerNode fillColor: (Color white) arrowColor:  (Color red) textColor: (Color black) popupText: ('Central feature is deselected', (String with: (Character cr)),'if this one is selected').
		allNodes add: node.
        ].

	self selectFeaturesWhenIsSelected do: [:f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color green) arrowColor:  (Color orange) textColor: (Color black) popupText: ('This one is selected', (String with: (Character cr)),'if central feature is selected').
		allNodes add: node.
        ].

	self selectFeaturesWhenIsDeselected do: [:f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color green) arrowColor:  (Color blue) textColor: (Color black) popupText: ('This one is selected', (String with: (Character cr)),'if central feature is deselected').
		allNodes add: node.
        ].

	self deselectFeaturesWhenIsDeselected do: [:f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color red) arrowColor:  (Color blue) textColor: (Color black) popupText: ('This one is deselected', (String with: (Character cr)),'if central feature is deselected').
		allNodes add: node.
        ].

	self deselectFeaturesWhenIsSelected do: [:f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color red) arrowColor:  (Color orange) textColor: (Color black) popupText: ('This one is deselected', (String with: (Character cr)),'if central feature is selected').
		allNodes add: node.
        ].

	self getNeighboursFeaturesImpliedByInternalConstraints do: [:f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color yellow) arrowColor:  (Color black) textColor: (Color black) popupText: ('This one is implied by internal', (String with: (Character cr)),'constraint launch by central feature.').
		allNodes add: node.
        ].

	self getNeighboursFeaturesExcludedByInternalConstraints do: [:f |
		| node |
		node := self createFeatureNodesOn: view fromCenterNode: centerNode toElement: f fillColor: (Color orange) arrowColor:  (Color black) textColor: (Color black) popupText: ('This one is excluded by internal', (String with: (Character cr)),'constraint launch by central feature.').
		allNodes add: node.
        ].

	allNodes ifNotEmpty: [
		ROCircleLayout new
		scaleBy: 30;
		on: allNodes.	
	].
	
	"ROCircleLayout on: {centerNode}."	
		
	center := (allNodes size * 30).
	centerNode translateBy: center @ center.
	
	view noLayout.! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/26/2013 08:30'!
weightedNumberOfLocalConstraints
	^ self fmFeature weightedNumberOfLocalConstraints! !

SPObject subclass: #SPFeatureModel
	instanceVariableNames: 'fmFeatureModel features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 10:42'!
features
	^ features! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 10:42'!
features: anObject
	features := anObject! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:05'!
fmFeatureModel
	^ fmFeatureModel! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:05'!
fmFeatureModel: anObject
	fmFeatureModel := anObject! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 11:08'!
getFeatureNamed: aName
	^ features detect: [ :f | f name = aName ]
	"^ fmFeatureModel featureNamed: aName"! !

!SPFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:02'!
numberOfFeatures
	^ features size ! !

!SPFeatureModel methodsFor: 'vizualisation' stamp: 'SimonUrli 12/4/2012 16:43'!
popupText
	^self name! !

!SPFeatureModel methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 12/18/2012 13:40'!
resolve
	| fmFeatures |
	features  := features collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ features allSatisfy: [ :obj | obj isKindOf: SPFeature ] ].
	
	fmFeatures := fmFeatureModel features.
	features do: [ :f | 
		 f fmFeature: (fmFeatures detect: [ :fmFeat | fmFeat name = f shortName ])
		].
	features do: [ :f | f featureModel: self ].
	features do: [ :f | 
		f featureChildren: ((self mooseModel entityStorage selectAllWithType: SPFeature) select:[:feat | (feat featureModel == self) & ((f fmFeature subFeatures collect:[:myf | myf name]) includes: (feat shortName))])].
	
	features do: [ :f | 
		f featureChildren do: [ :fc |
			fc parent: f.
		].
	].

	
"	| collectingVisitor |
	collectingVisitor := CollectingVisitor new.
	fmFeatureModel accept: collectingVisitor.
	self mooseModel addAll: collectingVisitor elements.
"! !

SPObject subclass: #SPMultiplicityElement
	instanceVariableNames: 'lowerBound upperBound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
lowerBound
	^ lowerBound! !

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
lowerBound: anObject
	self assert: [ anObject isInteger ].
	lowerBound := anObject! !

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
upperBound
	^ upperBound! !

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
upperBound: anObject
	self assert: [ anObject isInteger ].
	upperBound := anObject! !

!SPObject methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:04'!
name
	^ name! !

!SPObject methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:04'!
name: aName
	name := aName! !

!SPObject methodsFor: 'printing' stamp: 'AlexandreBergel 11/22/2012 09:38'!
printOn: stream
	super printOn: stream.
	stream nextPut: $<.
	stream nextPutAll: self name.
	stream nextPut: $>.! !

!SPObject methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 08:58'!
resolve! !

SPObject subclass: #SPRestrictionFunction
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPRestrictionFunction methodsFor: 'vizualisation' stamp: 'SimonUrli 12/4/2012 14:28'!
popupText
	^ 'toto'! !

!SPRestrictionFunction methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 09:13'!
resolve
	rules  := rules collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ rules allSatisfy: [ :obj | obj isKindOf: SPRule ] ].
! !

!SPRestrictionFunction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:11'!
rules
	^ rules! !

!SPRestrictionFunction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:11'!
rules: anObject
	rules := anObject! !

SPObject subclass: #SPRule
	instanceVariableNames: 'actions ruleState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:00'!
actions
	^ actions! !

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:00'!
actions: anObject
	actions := anObject! !

!SPRule methodsFor: 'accessing' stamp: 'SimonUrli 12/12/2012 16:20'!
numberOfFeaturesImplicated
	^ self state numberOfFeatures ! !

!SPRule methodsFor: 'vizualisation' stamp: 'SimonUrli 12/17/2012 23:13'!
popupText
	^self name, (String with: Character cr),
	  self state selected size printString, ' selected features',(String with: Character cr),
	  self state deselected size printString, ' deselected features',(String with: Character cr),
	  '=> ', self actions description,' ', self actions feature name.! !

!SPRule methodsFor: 'resolving dependencies' stamp: 'SimonUrli 12/12/2012 15:57'!
resolve
	ruleState  := self mooseModel entityNamed: ruleState.
	self assert: [ ruleState isKindOf: SPConfigurationState ].

	ruleState rule: self.

	actions  := self mooseModel entityNamed: actions.
	self assert: [ actions isKindOf: SPAbstractAction ].

	actions rule: self.! !

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:47'!
state
	^ ruleState! !

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:47'!
state: anObject
	ruleState := anObject! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 15:44'!
allAssignments
	<navigation: 'All assigment'>
	^ FMAssignmentGroup 
		withAll: (self allWithType: FMAssignment )
		withDescription: 'Assignment'
	! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 01:05'!
allFeatureModels
	<navigation: 'All feature models'>
	^ FMFeatureModelGroup 
		withAll: (self allWithType: FMFeatureModel )
		withDescription: 'Feature models'
	! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 14:29'!
allFeatures
	<navigation: 'All features'>
	^ FMFeatureGroup 
		withAll: (self allWithType: FMFeature )
		withDescription: 'Features'
	! !

!MooseModel methodsFor: '*familiar-spine' stamp: 'SimonUrli 11/23/2012 21:14'!
allSpineDomainElements
	<navigation: 'All Spine domain elements'>
	^ SPDomainElementGroup
		withAll: (self allWithType: SPDomainElement)
		withDescription: 'Spine Domain Element'
	! !

!MooseModel methodsFor: '*familiar-spine' stamp: 'SimonUrli 11/23/2012 21:10'!
allSpineFeatureModels
	<navigation: 'All Spine feature models'>
	^ SPFeatureModelGroup
		withAll: (self allWithType: SPFeatureModel )
		withDescription: 'Spine Feature Model'
	! !

!MooseModel methodsFor: '*familiar-spine' stamp: 'AlexandreBergel 11/23/2012 12:08'!
allSpineFeatures
	<navigation: 'All Spine features'>
	^ SPFeatureGroup 
		withAll: (self allWithType: SPFeature )
		withDescription: 'Spine Features'
	! !

TestCase subclass: #FMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

FMTest subclass: #FMFeatureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 15:10'!
testConstraints1

	| fm c d |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> D ; )'.

	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: (fm constraintsContainingFeature: c) = c constraints.
	self assert: c constraints size = 1.
	
	self assert: (fm constraintsContainingFeature: d) = d constraints.
	self assert: d constraints size = 1.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
testConstraints2

	| fm c d |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C <-> D ; )'.

	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: (fm constraintsContainingFeature: c) = c constraints.
	self assert: c constraints size = 1.
	
	self assert: (fm constraintsContainingFeature: d) = d constraints.
	self assert: d constraints size = 1.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 17:02'!
testConstraints3

	| fm c d a b |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | ( D | !!E) ) ;  (C | A); C & D;)'.

	a := fm featureNamed: 'A'.
	b := fm featureNamed: 'B'.
	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: c numberOfConstraints = 3.
	self assert: d numberOfConstraints = 2.
	self assert: a numberOfConstraints = 1.
	self assert: b numberOfConstraints = 0.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 10:54'!
testConstraints4

	| fm c d a b e cons |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | ( D | !!(E & A) ) ) ; )'.

	a := fm featureNamed: 'A'.
	b := fm featureNamed: 'B'.
	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	e := fm featureNamed: 'E'.
	
	self assert: a constraints size = 1.
	
	cons := a constraints first.
	self assert:  (cons features includesAllOf: {c . e . a . d}).
	self assert:  ({c . e . a . d} includesAllOf: cons features).
	
	self assert: (a constrainedFeatures includesAllOf: {c .d .e}).
	self assert: ({c .d .e} includesAllOf: a constrainedFeatures).
	self assert: (b constrainedFeatures isEmpty).! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 10:59'!
testEquality

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 = fm2.
	self assert: fm1 ~~ fm2.
	
	self assert: fm1 ~= fm3.
	self assert: fm1 ~~ fm3.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/3/2012 17:13'!
testEquality2

	self deny: FMFeature new = Object new.
	self deny: (FMFeature named: 'foo') = 'foo'.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:26'!
testExclusion1
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> D ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.
	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'D' }.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:38'!
testExclusion2
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> (D | E) ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.

	self assert: (fm featureNamed: 'E') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'E') implying isEmpty.

	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:38'!
testExclusion3
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | Z) -> (D | E) ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'Z' .  fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.

	self assert: (fm featureNamed: 'E') impliedBy = { fm featureNamed: 'Z' .  fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'E') implying isEmpty.

	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.

	self assert: (fm featureNamed: 'Z') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'Z') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:32'!
testExclusion4
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; A -> !! B ; )'.
	
	self deny: (fm featureNamed: 'B') impliedBy = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'B') exclusions = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'A') exclusions = { fm featureNamed: 'B' }! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:12'!
testExclusion5
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ;  !!A -> B ; )'.
	
	self assert: (fm featureNamed: 'B') impliedBy isEmpty.
	self assert: (fm featureNamed: 'B') implying isEmpty.
	
	self assert: (fm featureNamed: 'A') impliedBy isEmpty.
	self assert: (fm featureNamed: 'A') implying isEmpty.
! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:35'!
testExclusion6
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; A -> !! (B | C) ; )'.
	
	self assert: (fm featureNamed: 'A') impliedBy isEmpty.
	self assert: (fm featureNamed: 'B') impliedBy isEmpty.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.

	self assert: (fm featureNamed: 'B') exclusions = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'A') exclusions = { fm featureNamed: 'B' .  fm featureNamed: 'C' }.
	
	self assert: (fm featureNamed: 'B') numberOfExclusions = 1.
	self assert: (fm featureNamed: 'C') numberOfExclusions = 1.
	self assert: (fm featureNamed: 'A') numberOfExclusions = 2.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 11:00'!
testHash

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 hash = fm2 hash.
	
	self assert: fm1 hash ~= fm3 hash.
	! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:32'!
testMooseName

	| fm |
	fm := FMFeatureModel new.
	self assert: fm mooseName isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:35'!
testMooseName2

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B C [D];)'.
	self assert: fm mooseName isString.
	
	str := WriteStream on: String new.
	fm mooseNameOn: str.
	self assert: str contents isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/6/2012 17:04'!
testSubFeatureKind

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B (C | D)? [E] (F | G)+ (H | I | J); )'.
	self assert: fm numberOfFeatures = 10.
	
	self assert: (fm featureNamed: 'A') isMandatory.
	self assert: (fm featureNamed: 'B') isMandatory.

	self assert: (fm featureNamed: 'C') isMutex.
	self assert: (fm featureNamed: 'D') isMutex.
	
	self assert: (fm featureNamed: 'E') isOptional.
	
	self assert: (fm featureNamed: 'F') isOr.
	self assert: (fm featureNamed: 'G') isOr.
	
	self assert: (fm featureNamed: 'H') isXor.
	self assert: (fm featureNamed: 'I') isXor.
	self assert: (fm featureNamed: 'J') isXor.
	
	self deny: (fm featureNamed: 'J') isOptional.
	self deny: (fm featureNamed: 'E') isXor.! !

FMTest subclass: #FMImportCommandTest
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMImportCommandTest methodsFor: 'running' stamp: 'AlexandreBergel 7/3/2012 16:18'!
setUp

	command := FMTextImportCommand new.! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 16:51'!
testIsParseable
	self assert: (command isParseable: 'foobar = FM (A : B C [D] ;)').
	"self deny: (command isParseable: 'foobar = FM ((A : B C [D] ;)')."! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 14:39'!
testParse
	| model |
	model := command modelForTextualDescription: 'foobar = FM (A : B C [D] ;)'.
	self assert: (model class == MooseModel).
	
	self assert: (model allFeatureModels size = 1).
	self assert: (model allAssignments size = 1).
	self assert: (model allFeatures size = 4).
	self assert: (model allFeatures allSatisfy: [ :f | f featureModel notNil ]).
	self assert: (model allFeatureModels allSatisfy: [ :fm | fm features allSatisfy: [ :f | f featureModel == fm ] ] ).
	
	"self assert: (model allVariables) = {'foobar'}"
	! !

FMTest subclass: #FMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

FMParserTest subclass: #FMASTBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMASTBuilderTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:30'!
parser
	^ FMASTBuilder new! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:04'!
source1

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			    

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild1
	| c firstChild secondChild thirdChild |
	c := self parser child parse: 'B'.
	self assert: c isCollection.
	self assert: c first class == FMFeatureMendatory.
	self assert: c first feature = (FMFeature named: 'B')
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild2Multiple
	| c firstChild secondChild thirdChild |
	c := self parser children parse: 'B C D'.
	
	self assert: (c class == Array).
	self assert: (c allSatisfy: [ :cc | cc class ==  FMFeatureMendatory ]).
	self assert: c first feature name = 'B'.
	self assert: c second feature name = 'C'.
	self assert: c third  feature name = 'D'.
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild3
	| c thirdChild firstChild secondChild |
	c := self parser children parse: 'B (C | D)+'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureOr.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild4
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)+ B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureOr .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild5
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)? B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureMutex .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureMutex.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint1
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right name = 'A'.
	self assert: c left name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint2
	| c |
	c := self parser constraint parse: 'C -> A'.
	self assert: c class == FMConstraintArrow.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint3
	| c |
	c := self parser constraint parse: 'C <-> A'.
	self assert: c class == FMConstraintEquiv.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint4
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/7/2012 13:40'!
testBuildingConstraint5
	| c |
	c := self parser constraint parse: 'C | !!A'.
	self assert: c class == FMConstraintPipe.
	self assert: c left  name = 'C'.
	self assert: c right  class == FMConstraintNegated.
	self assert: c right  expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/7/2012 13:57'!
testBuildingConstraint6
	| c |
	c := self parser constraint parse: '!!C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  class == FMConstraintNegated.
	self assert: c left  expr name = 'C'! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingExample1

	| program assigment feature |
	program := self parser program parse: 'renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
					
	self assert: (program class == FMProgram).
	self assert: (program numberOfStatements = 1).

	assigment := program statementAt: 1.
	self assert: (assigment variable = 'renderers11'). 
	
	feature := assigment featureModel.
	self assert: ((feature productionAt: 1) root name = 'Renderer').
	self assert: ((feature productionAt: 1) numberOfChildren = 3).
	
	self assert: (feature numberOfConstraints isZero).
	self assert: (feature numberOfProductions = 6).! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingFeature1
	| c prod |
	c := self parser featureModel parse: 'FM ( A : B ; )'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 1.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name = 'A'.
	self assert: prod numberOfChildren = 1.
	 
	self assert: (prod childAt: 1 ) feature name = 'B' .! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:08'!
testBuildingFeature2
	| c prod |
	c := self parser featureModel parse: 'FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 6.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name =  'Renderer'.
	self assert: prod numberOfChildren = 3.
	 
	prod := (c productionAt: 6).
	self assert: prod root name =  'CalendarRenderer'.
	self assert: prod numberOfChildren = 1.
	self assert: (prod childAt: 1) feature name = 'RenderCalendarDetail'.	! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingNegated
	| c |
	c := self parser constraint parse: '!! A'.
	self assert: c class == FMConstraintNegated.
	self assert: c expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction1
	| c firstChild |
	c := self parser production parse: 'A : B'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 1.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction2
	| c firstChild secondChild thirdChild |
	c := self parser production parse: 'A : B C D'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	secondChild := c childAt: 2.
	thirdChild := c childAt: 3.
	
	self assert: firstChild feature name = 'B'.
	self assert: secondChild class ==  FMFeatureMendatory.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: secondChild feature name = 'C'.
	self assert: thirdChild feature name  = 'D'.
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:48'!
testBuildingProduction3
	| c fourthChild |
	c := self parser production parse: 'A : B C D [E]'.
	self assert: c numberOfChildren = 4.

	fourthChild := c childAt: 4.
	
	self assert: fourthChild class ==  FMFeatureOptional.
	self assert: fourthChild feature name = 'E'.
	
	
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 12:36'!
testBuildingProduction4
	| c fourthChild firstChild secondChild |
	c := self parser production parse: 'A : (C | D | E | F) +'.
	self assert: c numberOfChildren = 4.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureOr.
	self assert: firstChild feature name = 'C'.
	
	
	fourthChild := c childAt: 4.
	self assert: fourthChild class ==  FMFeatureOr.
	self assert: fourthChild feature name = 'F'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction5
	| c thirdChild firstChild secondChild |
	c := self parser production parse: 'A : B (C | D)'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c childAt: 2.
	self assert: secondChild class ==  FMFeatureXor.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c childAt: 3.
	self assert: thirdChild class ==  FMFeatureXor.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 11/23/2012 09:46'!
testFeatureAndFeatureModel

	| featureModel |
	featureModel := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	self assert: (featureModel featureNamed: 'A') featureModel == featureModel! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 11/23/2012 09:47'!
testFeatureModelAndNumberOfFeature

	| featureModel v1 v2 |
	featureModel := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	v1 := featureModel numberOfFeatures.
	v2 := featureModel numberOfFeatures.
	self assert: v1 = v2! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 11/23/2012 09:50'!
testHierarchy1

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	
	self assert: fm numberOfProductions = 2.
	"self assert: fm features = (#('A' 'B' 'C' 'D' 'E') collect: [ :n | FMFeature named: n] )."
	self assert: fm numberOfFeatures = 5.
	
	"self assert: (fm subFeaturesOf: (FMFeature named: 'A')) = (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] )."
	
	firstFeature := fm features first.
	self assert: firstFeature featureModel == fm.
	"self assert: firstFeature subFeatures =  (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] )."! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:03'!
testHierarchy2

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( Z : G; A : B ;)'.
	
	self assert: fm numberOfFeatures = 4.

	self assert: (fm featureNamed: 'A') subFeatures first ==   (fm featureNamed: 'B').
	self assert: (fm featureNamed: 'B') == fm features fourth.
	self assert: (fm featureNamed: 'B') subFeatures isEmpty 
! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/1/2012 16:30'!
testProgram
	| program |
	program := FMASTBuilder new program parse: 
'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: program numberOfStatements = 13.
	self assert: program lastStatement featureModel numberOfProductions = 11.
	self assert: program lastStatement featureModel numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 12:38'!
testProgram2
	| fm |
	fm := FMASTBuilder new featureModel  parse: 
'FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: fm notNil.
	self assert: fm numberOfProductions = 11.
	self assert: fm numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/3/2012 16:55'!
testProgram3
	| program |
	program := FMASTBuilder new program  parse: 
'printer = FM(Xerox: Category Environmental Products Technology Price Performance Input Finishing Capabilites PrintControllers Security PaperHandling Output ; 
Category: (WideFormatSolutions|Workflowsoftware|DigitalPrintingPresses|ContinuousFeedPrinters|ProductionPrintersandCopiers|BusinessDevelopment) ; 
Environmental: Dimensions ElectricalRequirements ; 
Products: (ColorProducts|MonoProducts) ; 
Technology: ProcessorImaging Memory PDLs CPU PrintEngine_Zero UserInterface Harddisk NetworkInterfaces ; 
Performance: LineScreens RatedSpeed ScanSpeed Resolution Dutycycle Recommendedaveragemonthlyvolume ; 
Input: AutomaticDoucmentFeeder HighCapacityFeeder OtherInputDevices ElectronicInput Tray ; 
Finishing: (SlitterorMerger|Cutting|Finisher|BookletMaking|HolePunch|OtherFinishingOptions|TapeBound|Stacker|Binder|Stapler|ByPassTransport)+ ; 
Capabilites: PrintedSides ProductColor [OptionalCapabilties] PrintLineManagement MICR StandardCapabilities ; 
PrintControllers: Digitalfrontends ; 
Security: (IPfiltering|Imageoverwrite|Secureprint|IPvSixsupport|Authentication|EncryptedScantoemail)+ ; 
PaperHandling: MediaWeightMinimum MediaDimensionsMaximum MediaDimensionsMinimum MediaTypes Maximumpapercapacitywithoptions MediaWeightMaximum Standardpapercapacity Papersources ; 
Output: (OffsetOutputTray|Stacker_Zero|TopTray)+ ; 
WideFormatSolutions: (WideFormatFinishers|ColorWideFormatPrinters|DigitalWideFormatPrintersandCopiers|SoftwareSolutions) ; 
Workflowsoftware: (FreeflowSoftwareandscanners|Productionprintingsoftware|DFEsandcontrollers) ; 
DigitalPrintingPresses: (ColorDigitalPrintingPress|BandWPublishingDigitalPrintingPress|BandWTransactionDigitalPrintingPress|HighLightColorDigitalPrintingPress) ; 
ProductionPrintersandCopiers: (BandWPrinters|ColorPrinters|BandWPublishing|HighLightColor|BandWTransaction) ; 
Dimensions: (Professional|BasicFinisherModuleDC|FeederModuleWithIntegratedScanner|PrintEngine|MultifunctionFinisherProplus|XeroxDSThreeFiveZeroZeroStacker|SheetfeedandInsertionModule|FinishingTransportModule|XeroxTapeBinder|SheetEnhancementModule|BasicFinisherModule|BasicFinisherModulePlus)+ ; 
ColorProducts: (Malta|Chandon|Pinot|Chamonix|Mykonos) ; 
MonoProducts: (Teak|BB|HLC|Nuvera|QM) ; 
ProcessorImaging: (Black|Color)+ ; 
ScanSpeed: (IntegratedScanner|FreeFlowScanner)+ ; 
Resolution: (Scan|Print|Scantofile|RIP|Black_Zero|Color_Zero)+ ; 
HighCapacityFeeder: (StandardFourtraySheet|RollFeedSolution|OversizedHighCapacitySheetFeedModule)+ ; 
OtherInputDevices: (HighCapacityInsertionModule|PostprintFourtrayPaperInsertionModule|InsertionModule|PostprintOversizedTwotrayPaperInsertionModule)+ ; 
Tray: (TrayFive|TrayThree|TrayFour|TrayOne|TrayTwo)+ ; 
Finisher: (MultifunctionFinisherProfessional|BasicFinisherModulePlus_Zero|BasicFinisherModuleDC|BasicFinisherModule_Zero|MultifunctionFinisherProplus_Zero)+ ; 
PrintedSides: [Duplex] ; 
OptionalCapabilties: (Finishing_Zero|Scanning)+ ; 
MICR: (Yes|No) ; 
StandardCapabilities: (Fax|ProductionPrinting|Reprinting|HighvolumenetworkprintingandThreerdpartyfinishing|Copy|Scan_Zero|ProductionMICRPrinting|Print_Zero|Finishing_One)+ ; 
MediaWeightMinimum: (coated_One|uncoated_One)+ ; 
MediaTypes: (speciality|coated|uncoated)+ ; 
MediaWeightMaximum: (uncoated_Zero|coated_Zero)+ ; 
Standardpapercapacity: (SheetFeedModule|HighCapacitySheetFeedModule|StitchingandBindingoption|HighCapacityStackingOption)+ ; 
Papersources: (HighCapacityStackingOption_Zero|HighCapacitySheetFeedModule_Zero|StitchingandBindingoption_Zero|SheetFeedModule_Zero)+ ;)

v = FM ( A : B ; )
'.

	self assert: program notNil.
	self assert: program numberOfStatements = 2.
	self assert: program numberOfVariables = 2.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/3/2012 16:56'!
testProgram4

	| v |
	v := (FMASTBuilder new program parse: 'p = FM (A : B_C ; )') numberOfStatements .
	self assert: v = 1! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/26/2013 09:27'!
testWeightedCounting
	| c v |
	c := self parser constraint parse: 'C | A'.
	v := FMWeightedVisitor new.
	self assert: v weight = 0.
	c accept: v.
	self assert: v weight = 2
	! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/26/2013 08:54'!
testWeightedCountingArrow
	| c v |
	c := self parser constraint parse: 'C -> A'.
	v := FMWeightedVisitor new.
	self assert: v weight = 0.
	c accept: v.
	self assert: v weight = 2! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/26/2013 08:54'!
testWeightedCountingEquiv
	| c v |
	c := self parser constraint parse: 'C <-> A'.
	v := FMWeightedVisitor new.
	self assert: v weight = 0.
	c accept: v.
	self assert: v weight = 4
	! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/26/2013 09:27'!
testWeightedCountingOr
	| c v |
	c := self parser constraint parse: 'C | A'.
	v := FMWeightedVisitor new.
	self assert: v weight = 0.
	c accept: v.
	self assert: v weight = 2
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:45'!
parseFeatureModel: str
	self assert: (FMParser new featureModel matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:48'!
parseProgram: str
	self assert: (FMParser new program matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
parseStatement: str
	self assert: (FMParser new statement matches: str).
	! !

!FMParserTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:24'!
parser
	^ FMParser new! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:24'!
testConstraint1
	self assert: (self parser constraint matches: 'C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint2
	self assert: (self parser constraint matches: '!! C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint3
	self assert: (self parser constraint matches: '(C | A)').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'SimonUrli 12/3/2012 14:25'!
testExample10

	self assert: (self parser featureModel matches: 'FM(Behaviour: Animation Numbers Product Elements ;  Animation: (Appear|Pause)? (Toto|Tata)?; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample10WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (RenderAnnonceTitle -> Text);)')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample11WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (Thumbnails -> !!RenderNewsTitle); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample2
	self assert: (self parser featureModel matches: 'FM (A : B C [ D ] ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample3
	self assert: (self parser featureModel matches: 'FM ( A : B  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample4
	self assert: (self parser featureModel matches: 'FM (A : B  C  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample5
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample6
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); A :  (B  | C);  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample7
	self assert: (self parser featureModel matches: 'FM ( C : (H|I|J) + ;  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample8WithConstraint
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  !! C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testExample9WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); )')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
testExamples

	self parseStatement: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testIdentifier

	self assert: (self parser fmlIdentifier parse: 'HelloWorld') = 'HelloWorld'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 14:12'!
testIdentifier2

	self assert: (self parser fmlIdentifier parse: 'Hello World') = 'Hello' ! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 10:24'!
testParsing

	| ast |
	ast := self parser program parse: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'.
					
	! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testProduction
	self assert: (self parser production matches: 'A : B ')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:12'!
testProgram
	self parseProgram: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:13'!
testProgram2
	self parseProgram: 'rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

FMTest subclass: #FMVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:17'!
program1

^ 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)'! !

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:19'!
program2

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			      

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMVisitorTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:21'!
testVisitor

	| visitorClasses |
	visitorClasses := FMVisitor withAllSubclasses.
	visitorClasses do: [ :vcls |
		#(#program1 #program2 ) do: [ :k | 
			(FMASTBuilder new program parse: (self perform: k)) accept: vcls new ] ] ! !

TestCase subclass: #SPAbstractTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Tests'!

!SPAbstractTest methodsFor: 'running' stamp: 'AlexandreBergel 12/18/2012 13:18'!
setUp
	super setUp.
	parser := SPParser new.! !

SPAbstractTest subclass: #SPBlueprintTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Tests'!

!SPBlueprintTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2013 12:08'!
testOpeningVisualization
	| command modelAsText mooseModel domainGroup view rawView buttonParent |
	command := SPTextImportCommand new.
	modelAsText := SPParserTest new frascatiSingleFM.
	mooseModel := (command modelForTextualDescription: modelAsText).
	domainGroup := mooseModel allSpineDomainElements.
	self assert: domainGroup notEmpty.
	
	view := ROMondrianViewBuilder new.
	domainGroup visualizeOn: view.
	view applyLayout.
	
	rawView := view raw.
	
	"Checking all elements are present"
	self assert: rawView elements size = 1.
	self assert: rawView elements first numberOfElements = 2.
	self assert: rawView elements first elements second numberOfElements = 125.
	
	"Clicking on highlight parent"
	buttonParent := view stack elementFromModel: 'Highlight parent'.
	self assert: buttonParent notNil.
	buttonParent announce: ROMouseLeftClick.
	
	"Showing the parent highlight"
	rawView elements first elements second announce: ROMouseEnter.
	rawView elements first elements second announce: ROMouseLeave.! !

!SPBlueprintTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/25/2013 11:27'!
testVisualization
	| command modelAsText mooseModel domainGroup |
	command := SPTextImportCommand new.
	modelAsText := SPParserTest new frascatiSingleFM.
	mooseModel := (command modelForTextualDescription: modelAsText).
	domainGroup := mooseModel allSpineDomainElements.
	self assert: domainGroup notEmpty.
	
	self shouldnt: [ domainGroup visualize delete ] raise: Error.
	! !

SPAbstractTest subclass: #SPFailingParsingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Tests'!

!SPFailingParsingTest methodsFor: 'example' stamp: 'AlexandreBergel 12/18/2012 13:21'!
failingTrace

^'[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_Frascati" features=[fm_Frascati.Interface_Native,fm_Frascati.ComponentFactory,fm_Frascati.RemoteManagement,fm_Frascati.Interfaces,fm_Frascati.Explorer,fm_Frascati.Binding_JMS,fm_Frascati.Property_XSD,fm_Frascati.BindingFactory,fm_Frascati.Binding_SCA,fm_Frascati.Interface_WSDL,fm_Frascati.PropertyTypes,fm_Frascati.Property_JAXB,fm_Frascati.FraSCAti,fm_Frascati.Binding_WS,fm_Frascati.Binding_REST,fm_Frascati.Binding_UPnP,fm_Frascati.Binding_HTTP,fm_Frascati.Bindings,fm_Frascati.Property_Java,fm_Frascati.JMX,fm_Frascati.Binding_JSON_RPC,fm_Frascati.AssemblyFactory,fm_Frascati.Fscript,fm_Frascati.Binding_JavaRMI,fm_Frascati.Interface_Java,fm_Frascati.Binding_JNA] familiar="FM(FraSCAti: [Explorer] [RemoteManagement] [Fscript] [BindingFactory] ComponentFactory [JMX] AssemblyFactory ; AssemblyFactory: PropertyTypes Interfaces Bindings ;  PropertyTypes: [Property_JAXB] Property_Java Property_XSD ;  Interfaces: [Interface_Native] [Interface_WSDL] Interface_Java ;  Bindings: [Binding_WS] [Binding_UPnP] [Binding_JSON_RPC] [Binding_REST] Binding_SCA [Binding_JavaRMI] [Binding_HTTP] [Binding_JNA] [Binding_JMS] ;  (Explorer -> AssemblyFactory); (Fscript -> BindingFactory); (RemoteManagement -> Fscript); (JMX -> AssemblyFactory); (Binding_JMS -> BindingFactory); (RemoteManagement -> Binding_REST); (Binding_JSON_RPC -> BindingFactory); (Fscript -> AssemblyFactory); (AssemblyFactory -> ScaParser); (AssemblyFactory -> ComponentFactory); (Explorer -> BindingFactory); (Binding_UPnP -> BindingFactory); (Binding_JavaRMI -> BindingFactory); (Binding_REST -> BindingFactory); (RemoteManagement -> AssemblyFactory); (Binding_WS -> BindingFactory);)"
[ROASSAL] FeatureModel id="fm_ComponentFactory" features=[fm_ComponentFactory.MG_Tinfi,fm_ComponentFactory.ComponentFactory,fm_ComponentFactory.JDKSix,fm_ComponentFactory.JDT,fm_ComponentFactory.MF_OSGi,fm_ComponentFactory.MembraneFactories,fm_ComponentFactory.MF_Tinfi,fm_ComponentFactory.JavaCompilers,fm_ComponentFactory.MembraneGenerators,fm_ComponentFactory.MG_OSGi,fm_ComponentFactory.MembraneGeneration,fm_ComponentFactory.MF_Julia] familiar="FM(ComponentFactory: MembraneFactories [MembraneGeneration] ;  MembraneFactories: [MF_Julia] [MF_OSGi] MF_Tinfi ; MembraneGeneration: [JavaCompilers] MembraneGenerators ;  JavaCompilers: (JDKSix|JDT) ;  MembraneGenerators: [MG_Tinfi] [MG_OSGi] ; (MF_OSGi -> MG_OSGi); (MG_OSGi -> MF_OSGi);)"
[ROASSAL] FeatureModel id="fm_ScaParser" features=[fm_ScaParser.MM_UPnP,fm_ScaParser.MM_Native,fm_ScaParser.MM_SCA,fm_ScaParser.ScaParser,fm_ScaParser.MM_FraSCAti,fm_ScaParser.MM_Tuscany,fm_ScaParser.Metamodels] familiar="FM(ScaParser: Metamodels ;  Metamodels: [MM_Native] [MM_FraSCAti] [MM_Tuscany] [MM_UPnP] MM_SCA ;)"
[ROASSAL] FeatureModel id="fm_AssemblyFactoryImplementation" features=[fm_AssemblyFactoryImplementation.Jython,fm_AssemblyFactoryImplementation.Implementation_Resource,fm_AssemblyFactoryImplementation.Implementation_Fractal,fm_AssemblyFactoryImplementation.FScript,fm_AssemblyFactoryImplementation.Implementation_Spring,fm_AssemblyFactoryImplementation.Xquery,fm_AssemblyFactoryImplementation.AssemblyFactoryImplementation,fm_AssemblyFactoryImplementation.Knopflerfish,fm_AssemblyFactoryImplementation.Implementation_OSGi,fm_AssemblyFactoryImplementation.BeanShell,fm_AssemblyFactoryImplementation.Implementation_Java,fm_AssemblyFactoryImplementation.Implementation_Composite,fm_AssemblyFactoryImplementation.Groovy,fm_AssemblyFactoryImplementation.Equinox,fm_AssemblyFactoryImplementation.Apache_Felix,fm_AssemblyFactoryImplementation.Implementation_Script,fm_AssemblyFactoryImplementation.JavaScript,fm_AssemblyFactoryImplementation.JRuby,fm_AssemblyFactoryImplementation.Implementation_BPEL] familiar="FM(AssemblyFactoryImplementation: [Implementation_Script] [Implementation_Fractal] [Implementation_Resource] [Implementation_OSGi] Implementation_Composite [Implementation_BPEL] [Implementation_Spring] Implementation_Java ;  Implementation_Script: [JRuby] [Jython] [FScript] [BeanShell] [Groovy] [JavaScript] [Xquery] ;  Implementation_OSGi: (Apache_Felix|Knopflerfish|Equinox) ;)"
>> list of DEAEnd
[ROASSAL] DEAEnd id="DEAEnd_AssoComponentFactoryImplementation_source" apply_on=[ComponentFactory] linkMultiplicity=[me_DEAEnd_AssoComponentFactoryImplementation_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoComponentFactoryImplementation_target" apply_on=[AssemblyFactoryImplementation] linkMultiplicity=[me_DEAEnd_AssoComponentFactoryImplementation_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoFrascatiImplementation_source" apply_on=[Frascati] linkMultiplicity=[me_DEAEnd_AssoFrascatiImplementation_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoFrascatiImplementation_target" apply_on=[AssemblyFactoryImplementation] linkMultiplicity=[me_DEAEnd_AssoFrascatiImplementation_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoFrascatiScaParser_source" apply_on=[Frascati] linkMultiplicity=[me_DEAEnd_AssoFrascatiScaParser_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoFrascatiScaParser_target" apply_on=[ScaParser] linkMultiplicity=[me_DEAEnd_AssoFrascatiScaParser_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoImplementationComponentFactory_source" apply_on=[AssemblyFactoryImplementation] linkMultiplicity=[me_DEAEnd_AssoImplementationComponentFactory_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoImplementationComponentFactory_target" apply_on=[ComponentFactory] linkMultiplicity=[me_DEAEnd_AssoImplementationComponentFactory_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoImplementationFrascati_source" apply_on=[AssemblyFactoryImplementation] linkMultiplicity=[me_DEAEnd_AssoImplementationFrascati_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoImplementationFrascati_target" apply_on=[Frascati] linkMultiplicity=[me_DEAEnd_AssoImplementationFrascati_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoImplementationScaParser_source" apply_on=[AssemblyFactoryImplementation] linkMultiplicity=[me_DEAEnd_AssoImplementationScaParser_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoImplementationScaParser_target" apply_on=[ScaParser] linkMultiplicity=[me_DEAEnd_AssoImplementationScaParser_target]
>> list of ActionSelect
[ROASSAL] ActionSelect id="AS_0" feature=[fm_AssemblyFactoryImplementation.Implementation_OSGi] fm=[fm_AssemblyFactoryImplementation]
[ROASSAL] ActionSelect id="AS_1" feature=[fm_AssemblyFactoryImplementation.Implementation_OSGi] fm=[fm_AssemblyFactoryImplementation]
[ROASSAL] ActionSelect id="AS_2" feature=[fm_AssemblyFactoryImplementation.Implementation_Fractal] fm=[fm_AssemblyFactoryImplementation]
[ROASSAL] ActionSelect id="AS_3" feature=[fm_AssemblyFactoryImplementation.Implementation_Fractal] fm=[fm_AssemblyFactoryImplementation]
[ROASSAL] ActionSelect id="AS_4" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_5" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_6" feature=[fm_ScaParser.MM_UPnP] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_7" feature=[fm_ScaParser.MM_Tuscany] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_8" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_9" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_10" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_11" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_12" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_13" feature=[fm_ScaParser.MM_Native] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_14" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_15" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_16" feature=[fm_ScaParser.MM_Native] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_17" feature=[fm_ComponentFactory.MF_OSGi] fm=[fm_ComponentFactory]
[ROASSAL] ActionSelect id="AS_18" feature=[fm_ComponentFactory.MG_OSGi] fm=[fm_ComponentFactory]
[ROASSAL] ActionSelect id="AS_19" feature=[fm_Frascati.Interface_WSDL] fm=[fm_Frascati]
[ROASSAL] ActionSelect id="AS_20" feature=[fm_Frascati.Fscript] fm=[fm_Frascati]
[ROASSAL] ActionSelect id="AS_21" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_22" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_23" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_24" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_25" feature=[fm_ScaParser.MM_SCA] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_26" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_27" feature=[fm_ScaParser.MM_Tuscany] fm=[fm_ScaParser]
[ROASSAL] ActionSelect id="AS_28" feature=[fm_ScaParser.MM_FraSCAti] fm=[fm_ScaParser]
>> list of DomainElement
[ROASSAL] DomainElement id="Frascati" refers_on=[fm_Frascati] MultiplicityElement=[me_Frascati] belongs_to=[]
[ROASSAL] DomainElement id="ComponentFactory" refers_on=[fm_ComponentFactory] MultiplicityElement=[me_ComponentFactory] belongs_to=[]
[ROASSAL] DomainElement id="ScaParser" refers_on=[fm_ScaParser] MultiplicityElement=[me_ScaParser] belongs_to=[]
[ROASSAL] DomainElement id="AssemblyFactoryImplementation" refers_on=[fm_AssemblyFactoryImplementation] MultiplicityElement=[me_AssemblyFactoryImplementation] belongs_to=[]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_Frascati" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_ComponentFactory" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_ScaParser" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_AssemblyFactoryImplementation" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoComponentFactoryImplementation_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoComponentFactoryImplementation_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoFrascatiImplementation_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoFrascatiImplementation_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoFrascatiScaParser_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoFrascatiScaParser_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoImplementationComponentFactory_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoImplementationComponentFactory_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoImplementationFrascati_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoImplementationFrascati_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoImplementationScaParser_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoImplementationScaParser_target" lowerBound=1 upperBound=1
>> list of ConfigurationState
[ROASSAL] ConfigurationState id="cs_Rule_0" fm=[fm_ComponentFactory] selected=[fm_ComponentFactory.MF_OSGi] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_1" fm=[fm_ComponentFactory] selected=[fm_ComponentFactory.MG_OSGi] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_2" fm=[fm_Frascati] selected=[fm_Frascati.Explorer] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_3" fm=[fm_Frascati] selected=[fm_Frascati.Fscript] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_4" fm=[fm_Frascati] selected=[fm_Frascati.Binding_JSON_RPC] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_5" fm=[fm_Frascati] selected=[fm_Frascati.Binding_JSON_RPC] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_6" fm=[fm_Frascati] selected=[fm_Frascati.Binding_UPnP] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_7" fm=[fm_Frascati] selected=[fm_Frascati.Binding_HTTP] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_8" fm=[fm_Frascati] selected=[fm_Frascati.Binding_SCA] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_9" fm=[fm_Frascati] selected=[fm_Frascati.Binding_REST] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_10" fm=[fm_Frascati] selected=[fm_Frascati.Binding_JMS] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_11" fm=[fm_Frascati] selected=[fm_Frascati.Binding_WS] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_12" fm=[fm_Frascati] selected=[fm_Frascati.Binding_JavaRMI] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_13" fm=[fm_Frascati] selected=[fm_Frascati.Binding_JNA] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_14" fm=[fm_Frascati] selected=[fm_Frascati.Interface_Java] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_15" fm=[fm_Frascati] selected=[fm_Frascati.Interface_WSDL] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_16" fm=[fm_Frascati] selected=[fm_Frascati.Interface_Native] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_17" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_OSGi] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_18" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_OSGi] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_19" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_BPEL] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_20" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.FScript] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_21" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_Script] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_22" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_Spring] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_23" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_BPEL] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_24" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_OSGi] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_25" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_Java] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_26" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_Fractal] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_27" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_Resource] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_28" fm=[fm_AssemblyFactoryImplementation] selected=[fm_AssemblyFactoryImplementation.Implementation_Composite] deselected=[]
>> list of Rule
[ROASSAL] Rule id="Rule_0" state=[cs_Rule_0] actions=[AS_0]
[ROASSAL] Rule id="Rule_1" state=[cs_Rule_1] actions=[AS_1]
[ROASSAL] Rule id="Rule_2" state=[cs_Rule_2] actions=[AS_2]
[ROASSAL] Rule id="Rule_3" state=[cs_Rule_3] actions=[AS_3]
[ROASSAL] Rule id="Rule_4" state=[cs_Rule_4] actions=[AS_4]
[ROASSAL] Rule id="Rule_5" state=[cs_Rule_5] actions=[AS_5]
[ROASSAL] Rule id="Rule_6" state=[cs_Rule_6] actions=[AS_6]
[ROASSAL] Rule id="Rule_7" state=[cs_Rule_7] actions=[AS_7]
[ROASSAL] Rule id="Rule_8" state=[cs_Rule_8] actions=[AS_8]
[ROASSAL] Rule id="Rule_9" state=[cs_Rule_9] actions=[AS_9]
[ROASSAL] Rule id="Rule_10" state=[cs_Rule_10] actions=[AS_10]
[ROASSAL] Rule id="Rule_11" state=[cs_Rule_11] actions=[AS_11]
[ROASSAL] Rule id="Rule_12" state=[cs_Rule_12] actions=[AS_12]
[ROASSAL] Rule id="Rule_13" state=[cs_Rule_13] actions=[AS_13]
[ROASSAL] Rule id="Rule_14" state=[cs_Rule_14] actions=[AS_14]
[ROASSAL] Rule id="Rule_15" state=[cs_Rule_15] actions=[AS_15]
[ROASSAL] Rule id="Rule_16" state=[cs_Rule_16] actions=[AS_16]
[ROASSAL] Rule id="Rule_17" state=[cs_Rule_17] actions=[AS_17]
[ROASSAL] Rule id="Rule_18" state=[cs_Rule_18] actions=[AS_18]
[ROASSAL] Rule id="Rule_19" state=[cs_Rule_19] actions=[AS_19]
[ROASSAL] Rule id="Rule_20" state=[cs_Rule_20] actions=[AS_20]
[ROASSAL] Rule id="Rule_21" state=[cs_Rule_21] actions=[AS_21]
[ROASSAL] Rule id="Rule_22" state=[cs_Rule_22] actions=[AS_22]
[ROASSAL] Rule id="Rule_23" state=[cs_Rule_23] actions=[AS_23]
[ROASSAL] Rule id="Rule_24" state=[cs_Rule_24] actions=[AS_24]
[ROASSAL] Rule id="Rule_25" state=[cs_Rule_25] actions=[AS_25]
[ROASSAL] Rule id="Rule_26" state=[cs_Rule_26] actions=[AS_26]
[ROASSAL] Rule id="Rule_27" state=[cs_Rule_27] actions=[AS_27]
[ROASSAL] Rule id="Rule_28" state=[cs_Rule_28] actions=[AS_28]
>> list of DEAssociation
[ROASSAL] DEAssociation id="AssoComponentFactoryImplementation" source=[DEAEnd_AssoComponentFactoryImplementation_source] target=[DEAEnd_AssoComponentFactoryImplementation_target] restrictionFunctions=[membraneToImplem]
[ROASSAL] DEAssociation id="AssoFrascatiImplementation" source=[DEAEnd_AssoFrascatiImplementation_source] target=[DEAEnd_AssoFrascatiImplementation_target] restrictionFunctions=[OptToImplem]
[ROASSAL] DEAssociation id="AssoFrascatiScaParser" source=[DEAEnd_AssoFrascatiScaParser_source] target=[DEAEnd_AssoFrascatiScaParser_target] restrictionFunctions=[BindingToMM,InterfacesToMM]
[ROASSAL] DEAssociation id="AssoImplementationComponentFactory" source=[DEAEnd_AssoImplementationComponentFactory_source] target=[DEAEnd_AssoImplementationComponentFactory_target] restrictionFunctions=[ImplemToCF]
[ROASSAL] DEAssociation id="AssoImplementationFrascati" source=[DEAEnd_AssoImplementationFrascati_source] target=[DEAEnd_AssoImplementationFrascati_target] restrictionFunctions=[ImplemToInt]
[ROASSAL] DEAssociation id="AssoImplementationScaParser" source=[DEAEnd_AssoImplementationScaParser_source] target=[DEAEnd_AssoImplementationScaParser_target] restrictionFunctions=[ImplemToMM]
>> list of RestrictionFunction
[ROASSAL] RestrictionFunction id="membraneToImplem" rules=[Rule_0,Rule_1]
[ROASSAL] RestrictionFunction id="OptToImplem" rules=[Rule_2,Rule_3]
[ROASSAL] RestrictionFunction id="BindingToMM" rules=[Rule_4,Rule_5,Rule_6,Rule_7,Rule_8,Rule_9,Rule_10,Rule_11,Rule_12,Rule_13]
[ROASSAL] RestrictionFunction id="InterfacesToMM" rules=[Rule_14,Rule_15,Rule_16]
[ROASSAL] RestrictionFunction id="ImplemToCF" rules=[Rule_17,Rule_18]
[ROASSAL] RestrictionFunction id="ImplemToInt" rules=[Rule_19,Rule_20]
[ROASSAL] RestrictionFunction id="ImplemToMM" rules=[Rule_21,Rule_22,Rule_23,Rule_24,Rule_25,Rule_26,Rule_27,Rule_28]
>> list of Feature
[ROASSAL] Feature id="fm_Frascati.Interface_Native" name="Interface_Native"
[ROASSAL] Feature id="fm_Frascati.ComponentFactory" name="ComponentFactory"
[ROASSAL] Feature id="fm_Frascati.RemoteManagement" name="RemoteManagement"
[ROASSAL] Feature id="fm_Frascati.Interfaces" name="Interfaces"
[ROASSAL] Feature id="fm_Frascati.Explorer" name="Explorer"
[ROASSAL] Feature id="fm_Frascati.Binding_JMS" name="Binding_JMS"
[ROASSAL] Feature id="fm_Frascati.Property_XSD" name="Property_XSD"
[ROASSAL] Feature id="fm_Frascati.BindingFactory" name="BindingFactory"
[ROASSAL] Feature id="fm_Frascati.Binding_SCA" name="Binding_SCA"
[ROASSAL] Feature id="fm_Frascati.Interface_WSDL" name="Interface_WSDL"
[ROASSAL] Feature id="fm_Frascati.PropertyTypes" name="PropertyTypes"
[ROASSAL] Feature id="fm_Frascati.Property_JAXB" name="Property_JAXB"
[ROASSAL] Feature id="fm_Frascati.FraSCAti" name="FraSCAti"
[ROASSAL] Feature id="fm_Frascati.Binding_WS" name="Binding_WS"
[ROASSAL] Feature id="fm_Frascati.Binding_REST" name="Binding_REST"
[ROASSAL] Feature id="fm_Frascati.Binding_UPnP" name="Binding_UPnP"
[ROASSAL] Feature id="fm_Frascati.Binding_HTTP" name="Binding_HTTP"
[ROASSAL] Feature id="fm_Frascati.Bindings" name="Bindings"
[ROASSAL] Feature id="fm_Frascati.Property_Java" name="Property_Java"
[ROASSAL] Feature id="fm_Frascati.JMX" name="JMX"
[ROASSAL] Feature id="fm_Frascati.Binding_JSON_RPC" name="Binding_JSON_RPC"
[ROASSAL] Feature id="fm_Frascati.AssemblyFactory" name="AssemblyFactory"
[ROASSAL] Feature id="fm_Frascati.Fscript" name="Fscript"
[ROASSAL] Feature id="fm_Frascati.Binding_JavaRMI" name="Binding_JavaRMI"
[ROASSAL] Feature id="fm_Frascati.Interface_Java" name="Interface_Java"
[ROASSAL] Feature id="fm_Frascati.Binding_JNA" name="Binding_JNA"
[ROASSAL] Feature id="fm_ComponentFactory.MG_Tinfi" name="MG_Tinfi"
[ROASSAL] Feature id="fm_ComponentFactory.ComponentFactory" name="ComponentFactory"
[ROASSAL] Feature id="fm_ComponentFactory.JDKSix" name="JDKSix"
[ROASSAL] Feature id="fm_ComponentFactory.JDT" name="JDT"
[ROASSAL] Feature id="fm_ComponentFactory.MF_OSGi" name="MF_OSGi"
[ROASSAL] Feature id="fm_ComponentFactory.MembraneFactories" name="MembraneFactories"
[ROASSAL] Feature id="fm_ComponentFactory.MF_Tinfi" name="MF_Tinfi"
[ROASSAL] Feature id="fm_ComponentFactory.JavaCompilers" name="JavaCompilers"
[ROASSAL] Feature id="fm_ComponentFactory.MembraneGenerators" name="MembraneGenerators"
[ROASSAL] Feature id="fm_ComponentFactory.MG_OSGi" name="MG_OSGi"
[ROASSAL] Feature id="fm_ComponentFactory.MembraneGeneration" name="MembraneGeneration"
[ROASSAL] Feature id="fm_ComponentFactory.MF_Julia" name="MF_Julia"
[ROASSAL] Feature id="fm_ScaParser.MM_UPnP" name="MM_UPnP"
[ROASSAL] Feature id="fm_ScaParser.MM_Native" name="MM_Native"
[ROASSAL] Feature id="fm_ScaParser.MM_SCA" name="MM_SCA"
[ROASSAL] Feature id="fm_ScaParser.ScaParser" name="ScaParser"
[ROASSAL] Feature id="fm_ScaParser.MM_FraSCAti" name="MM_FraSCAti"
[ROASSAL] Feature id="fm_ScaParser.MM_Tuscany" name="MM_Tuscany"
[ROASSAL] Feature id="fm_ScaParser.Metamodels" name="Metamodels"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Jython" name="Jython"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_Resource" name="Implementation_Resource"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_Fractal" name="Implementation_Fractal"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.FScript" name="FScript"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_Spring" name="Implementation_Spring"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Xquery" name="Xquery"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.AssemblyFactoryImplementation" name="AssemblyFactoryImplementation"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Knopflerfish" name="Knopflerfish"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_OSGi" name="Implementation_OSGi"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.BeanShell" name="BeanShell"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_Java" name="Implementation_Java"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_Composite" name="Implementation_Composite"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Groovy" name="Groovy"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Equinox" name="Equinox"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Apache_Felix" name="Apache_Felix"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_Script" name="Implementation_Script"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.JavaScript" name="JavaScript"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.JRuby" name="JRuby"
[ROASSAL] Feature id="fm_AssemblyFactoryImplementation.Implementation_BPEL" name="Implementation_BPEL"
[ROASSAL] END MODEL'! !

!SPFailingParsingTest methodsFor: 'example' stamp: 'AlexandreBergel 12/18/2012 16:01'!
failingTrace2

^'[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_frascati" features=[fm_frascati.ComponentFactory,fm_frascati.MG_Tinfi,fm_frascati.Interfaces,fm_frascati.Explorer,fm_frascati.Binding_JMS,fm_frascati.JavaCompilers,fm_frascati.BindingFactory,fm_frascati.MF_Julia,fm_frascati.Interface_WSDL,fm_frascati.JDT,fm_frascati.Implementations,fm_frascati.Property_JAXB,fm_frascati.MembraneGenerators,fm_frascati.Implementation_Resource,fm_frascati.Implementation_Fractal,fm_frascati.Binding_REST,fm_frascati.Binding_UPnP,fm_frascati.JMX,fm_frascati.Metamodels,fm_frascati.Implementation_OSGi,fm_frascati.Binding_JavaRMI,fm_frascati.MM_SCA,fm_frascati.BeanShell,fm_frascati.Groovy,fm_frascati.Implementation_Composite,fm_frascati.MG_OSGi,fm_frascati.Equinox,fm_frascati.MembraneGeneration,fm_frascati.JavaScript,fm_frascati.Implementation_BPEL,fm_frascati.Binding_JNA,fm_frascati.Interface_Native,fm_frascati.RemoteManagement,fm_frascati.Property_XSD,fm_frascati.MM_FraSCAti,fm_frascati.Xquery,fm_frascati.Binding_SCA,fm_frascati.MF_OSGi,fm_frascati.PropertyTypes,fm_frascati.FraSCAti,fm_frascati.Binding_WS,fm_frascati.JRuby,fm_frascati.Jython,fm_frascati.FScript,fm_frascati.MF_Tinfi,fm_frascati.Binding_HTTP,fm_frascati.Bindings,fm_frascati.Property_Java,fm_frascati.Implementation_Spring,fm_frascati.Binding_JSON_RPC,fm_frascati.AssemblyFactory,fm_frascati.Knopflerfish,fm_frascati.JDKSix,fm_frascati.MM_UPnP,fm_frascati.Fscript,fm_frascati.MM_Native,fm_frascati.MembraneFactories,fm_frascati.ScaParser,fm_frascati.Implementation_Java,fm_frascati.Interface_Java,fm_frascati.Implementation_Script,fm_frascati.Apache_Felix,fm_frascati.MM_Tuscany] familiar="FM(FraSCAti: [Explorer] ScaParser [RemoteManagement] [Fscript] [BindingFactory] ComponentFactory [JMX] AssemblyFactory ;  ScaParser: Metamodels ;  ComponentFactory: MembraneFactories [MembraneGeneration] ; AssemblyFactory: PropertyTypes Interfaces Bindings Implementations ; Metamodels: [MM_Native] [MM_FraSCAti] [MM_Tuscany] [MM_UPnP] MM_SCA ; MembraneFactories: [MF_Julia] [MF_OSGi] MF_Tinfi ;  MembraneGeneration: [JavaCompilers] MembraneGenerators ;  PropertyTypes: [Property_JAXB] Property_Java Property_XSD ;  Interfaces: [Interface_Native] [Interface_WSDL] Interface_Java ;  Bindings: [Binding_WS] [Binding_UPnP] [Binding_JSON_RPC] [Binding_REST] Binding_SCA [Binding_JavaRMI] [Binding_HTTP] [Binding_JNA] [Binding_JMS] ;  Implementations: [Implementation_Script] [Implementation_Fractal] [Implementation_Resource] [Implementation_OSGi] Implementation_Composite [Implementation_BPEL] [Implementation_Spring] Implementation_Java ; JavaCompilers: (JDKSix|JDT) ;  MembraneGenerators: [MG_Tinfi] [MG_OSGi] ;  Implementation_Script: [JRuby] [Jython] [FScript] [BeanShell] [Groovy] [JavaScript] [Xquery] ;  Implementation_OSGi: (Apache_Felix|Knopflerfish|Equinox) ; (Interface_Java -> MM_SCA); (Implementation_Spring -> MM_SCA); (Implementation_Script -> MM_FraSCAti); (Implementation_OSGi -> MF_OSGi); (Fscript -> BindingFactory); (Implementation_BPEL -> MM_SCA); (Binding_JSON_RPC -> MM_FraSCAti); (Explorer -> Implementation_Fractal); (JMX -> AssemblyFactory); (Implementation_OSGi -> MM_FraSCAti); (Binding_JMS -> BindingFactory); (Implementation_Java -> MM_SCA); (Binding_UPnP -> MM_UPnP); (Fscript -> AssemblyFactory); (Implementation_BPEL -> Interface_WSDL); (MF_OSGi -> Implementation_OSGi); (MF_OSGi -> MG_OSGi); (Binding_HTTP -> MM_Tuscany); (Binding_SCA -> MM_SCA); (Binding_WS -> BindingFactory); (Binding_REST -> MM_FraSCAti); (Binding_JMS -> MM_SCA); (Explorer -> AssemblyFactory); (RemoteManagement -> Fscript); (Binding_WS -> MM_SCA); (RemoteManagement -> Binding_REST); (Binding_JSON_RPC -> BindingFactory); (Binding_JavaRMI -> MM_FraSCAti); (Fscript -> Implementation_Fractal); (Interface_WSDL -> MM_SCA); (Interface_Native -> MM_Native); (Implementation_Fractal -> MM_FraSCAti); (Implementation_OSGi -> MG_OSGi); (MG_OSGi -> Implementation_OSGi); (AssemblyFactory -> ScaParser); (FScript -> Fscript); (AssemblyFactory -> ComponentFactory); (Explorer -> BindingFactory); (MG_OSGi -> MF_OSGi); (Binding_UPnP -> BindingFactory); (Binding_JavaRMI -> BindingFactory); (Implementation_Composite -> MM_SCA); (Implementation_Resource -> MM_Tuscany); (Binding_REST -> BindingFactory); (RemoteManagement -> AssemblyFactory); (Binding_JNA -> MM_Native);)"
>> list of DomainElement
[ROASSAL] DomainElement id="frascati" refers_on=[fm_frascati] MultiplicityElement=[me_frascati] belongs_to=[]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_frascati" lowerBound=1 upperBound=1
>> list of Feature
[ROASSAL] Feature id="fm_frascati.ComponentFactory" name="ComponentFactory"
[ROASSAL] Feature id="fm_frascati.MG_Tinfi" name="MG_Tinfi"
[ROASSAL] Feature id="fm_frascati.Interfaces" name="Interfaces"
[ROASSAL] Feature id="fm_frascati.Explorer" name="Explorer"
[ROASSAL] Feature id="fm_frascati.Binding_JMS" name="Binding_JMS"
[ROASSAL] Feature id="fm_frascati.JavaCompilers" name="JavaCompilers"
[ROASSAL] Feature id="fm_frascati.BindingFactory" name="BindingFactory"
[ROASSAL] Feature id="fm_frascati.MF_Julia" name="MF_Julia"
[ROASSAL] Feature id="fm_frascati.Interface_WSDL" name="Interface_WSDL"
[ROASSAL] Feature id="fm_frascati.JDT" name="JDT"
[ROASSAL] Feature id="fm_frascati.Implementations" name="Implementations"
[ROASSAL] Feature id="fm_frascati.Property_JAXB" name="Property_JAXB"
[ROASSAL] Feature id="fm_frascati.MembraneGenerators" name="MembraneGenerators"
[ROASSAL] Feature id="fm_frascati.Implementation_Resource" name="Implementation_Resource"
[ROASSAL] Feature id="fm_frascati.Implementation_Fractal" name="Implementation_Fractal"
[ROASSAL] Feature id="fm_frascati.Binding_REST" name="Binding_REST"
[ROASSAL] Feature id="fm_frascati.Binding_UPnP" name="Binding_UPnP"
[ROASSAL] Feature id="fm_frascati.JMX" name="JMX"
[ROASSAL] Feature id="fm_frascati.Metamodels" name="Metamodels"
[ROASSAL] Feature id="fm_frascati.Implementation_OSGi" name="Implementation_OSGi"
[ROASSAL] Feature id="fm_frascati.Binding_JavaRMI" name="Binding_JavaRMI"
[ROASSAL] Feature id="fm_frascati.MM_SCA" name="MM_SCA"
[ROASSAL] Feature id="fm_frascati.BeanShell" name="BeanShell"
[ROASSAL] Feature id="fm_frascati.Groovy" name="Groovy"
[ROASSAL] Feature id="fm_frascati.Implementation_Composite" name="Implementation_Composite"
[ROASSAL] Feature id="fm_frascati.MG_OSGi" name="MG_OSGi"
[ROASSAL] Feature id="fm_frascati.Equinox" name="Equinox"
[ROASSAL] Feature id="fm_frascati.MembraneGeneration" name="MembraneGeneration"
[ROASSAL] Feature id="fm_frascati.JavaScript" name="JavaScript"
[ROASSAL] Feature id="fm_frascati.Implementation_BPEL" name="Implementation_BPEL"
[ROASSAL] Feature id="fm_frascati.Binding_JNA" name="Binding_JNA"
[ROASSAL] Feature id="fm_frascati.Interface_Native" name="Interface_Native"
[ROASSAL] Feature id="fm_frascati.RemoteManagement" name="RemoteManagement"
[ROASSAL] Feature id="fm_frascati.Property_XSD" name="Property_XSD"
[ROASSAL] Feature id="fm_frascati.MM_FraSCAti" name="MM_FraSCAti"
[ROASSAL] Feature id="fm_frascati.Xquery" name="Xquery"
[ROASSAL] Feature id="fm_frascati.Binding_SCA" name="Binding_SCA"
[ROASSAL] Feature id="fm_frascati.MF_OSGi" name="MF_OSGi"
[ROASSAL] Feature id="fm_frascati.PropertyTypes" name="PropertyTypes"
[ROASSAL] Feature id="fm_frascati.FraSCAti" name="FraSCAti"
[ROASSAL] Feature id="fm_frascati.Binding_WS" name="Binding_WS"
[ROASSAL] Feature id="fm_frascati.JRuby" name="JRuby"
[ROASSAL] Feature id="fm_frascati.Jython" name="Jython"
[ROASSAL] Feature id="fm_frascati.FScript" name="FScript"
[ROASSAL] Feature id="fm_frascati.MF_Tinfi" name="MF_Tinfi"
[ROASSAL] Feature id="fm_frascati.Binding_HTTP" name="Binding_HTTP"
[ROASSAL] Feature id="fm_frascati.Bindings" name="Bindings"
[ROASSAL] Feature id="fm_frascati.Property_Java" name="Property_Java"
[ROASSAL] Feature id="fm_frascati.Implementation_Spring" name="Implementation_Spring"
[ROASSAL] Feature id="fm_frascati.Binding_JSON_RPC" name="Binding_JSON_RPC"
[ROASSAL] Feature id="fm_frascati.AssemblyFactory" name="AssemblyFactory"
[ROASSAL] Feature id="fm_frascati.Knopflerfish" name="Knopflerfish"
[ROASSAL] Feature id="fm_frascati.JDKSix" name="JDKSix"
[ROASSAL] Feature id="fm_frascati.MM_UPnP" name="MM_UPnP"
[ROASSAL] Feature id="fm_frascati.Fscript" name="Fscript"
[ROASSAL] Feature id="fm_frascati.MM_Native" name="MM_Native"
[ROASSAL] Feature id="fm_frascati.MembraneFactories" name="MembraneFactories"
[ROASSAL] Feature id="fm_frascati.ScaParser" name="ScaParser"
[ROASSAL] Feature id="fm_frascati.Implementation_Java" name="Implementation_Java"
[ROASSAL] Feature id="fm_frascati.Interface_Java" name="Interface_Java"
[ROASSAL] Feature id="fm_frascati.Implementation_Script" name="Implementation_Script"
[ROASSAL] Feature id="fm_frascati.Apache_Felix" name="Apache_Felix"
[ROASSAL] Feature id="fm_frascati.MM_Tuscany" name="MM_Tuscany"
[ROASSAL] END MODEL'! !

!SPFailingParsingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/18/2012 13:47'!
testFailingTrace
	| feature |
	 parser parse: self failingTrace.
	self should: [ parser resolve ] raise: Error.

	feature := parser mooseModel entityNamed: 'fm_Frascati.AssemblyFactory'.
	self should: [
		feature fmFeature implying collect:  [ :if | 
					(parser mooseModel allWithType: SPFeature) detect: [ :feat | 
						(feature featureModel features includes: feat) & (feat shortName = if name)
					]
			] ] raise: Error.! !

!SPFailingParsingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/18/2012 13:47'!
testFailingTrace2
	| feature sourceElement view |
	 parser parse: self failingTrace.
	self should: [ parser resolve ] raise: Error.
	
	feature := parser mooseModel entityNamed: 'fm_Frascati.AssemblyFactory'.
	view := ROMondrianViewBuilder new.
	
	self should: [ 
		parser mooseModel allSpineDomainElements
			pointFeature: feature onView: view ] raise: Error ! !

!SPFailingParsingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/18/2012 13:57'!
testResolve
	| feature |
	 parser parse: self failingTrace.
	
	feature := parser mooseModel entityNamed: 'fm_Frascati.AssemblyFactory'.

	self assert: feature fmFeature isNil.
	
	self should: [ parser resolve ] raise: Error.
	self assert: feature fmFeature implying class == Array.
	self assert: feature fmFeature implying notEmpty! !

!SPFailingParsingTest methodsFor: 'tests' stamp: 'AlexandreBergel 12/18/2012 16:03'!
testTrace2

	| domainElement |
	parser parse: self failingTrace2.
	domainElement := parser mooseModel entityNamed: 'frascati'.
	self assert: domainElement class == SPDomainElement.
	self assert: parser mooseModel allSpineDomainElements size = 1.! !

SPAbstractTest subclass: #SPParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Tests'!

!SPParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 12/19/2012 13:19'!
frascatiSingleFM
	^ '[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_frascati" features=[fm_frascati.ComponentFactory,fm_frascati.MG_Tinfi,fm_frascati.Interfaces,fm_frascati.Explorer,fm_frascati.Binding_JMS,fm_frascati.JavaCompilers,fm_frascati.BindingFactory,fm_frascati.MF_Julia,fm_frascati.Interface_WSDL,fm_frascati.JDT,fm_frascati.Implementations,fm_frascati.Property_JAXB,fm_frascati.MembraneGenerators,fm_frascati.Implementation_Resource,fm_frascati.Implementation_Fractal,fm_frascati.Binding_REST,fm_frascati.Binding_UPnP,fm_frascati.JMX,fm_frascati.Metamodels,fm_frascati.Implementation_OSGi,fm_frascati.Binding_JavaRMI,fm_frascati.MM_SCA,fm_frascati.BeanShell,fm_frascati.Groovy,fm_frascati.Implementation_Composite,fm_frascati.MG_OSGi,fm_frascati.Equinox,fm_frascati.MembraneGeneration,fm_frascati.JavaScript,fm_frascati.Implementation_BPEL,fm_frascati.Binding_JNA,fm_frascati.Interface_Native,fm_frascati.RemoteManagement,fm_frascati.Property_XSD,fm_frascati.MM_FraSCAti,fm_frascati.Xquery,fm_frascati.Binding_SCA,fm_frascati.MF_OSGi,fm_frascati.PropertyTypes,fm_frascati.FraSCAti,fm_frascati.Binding_WS,fm_frascati.JRuby,fm_frascati.Jython,fm_frascati.FScript,fm_frascati.MF_Tinfi,fm_frascati.Binding_HTTP,fm_frascati.Bindings,fm_frascati.Property_Java,fm_frascati.Implementation_Spring,fm_frascati.Binding_JSON_RPC,fm_frascati.AssemblyFactory,fm_frascati.Knopflerfish,fm_frascati.JDKSix,fm_frascati.MM_UPnP,fm_frascati.Fscript,fm_frascati.MM_Native,fm_frascati.MembraneFactories,fm_frascati.ScaParser,fm_frascati.Implementation_Java,fm_frascati.Interface_Java,fm_frascati.Implementation_Script,fm_frascati.Apache_Felix,fm_frascati.MM_Tuscany] familiar="FM(FraSCAti: [Explorer] ScaParser [RemoteManagement] [Fscript] [BindingFactory] ComponentFactory [JMX] AssemblyFactory ;  ScaParser: Metamodels ;  ComponentFactory: MembraneFactories [MembraneGeneration] ; AssemblyFactory: PropertyTypes Interfaces Bindings Implementations ; Metamodels: [MM_Native] [MM_FraSCAti] [MM_Tuscany] [MM_UPnP] MM_SCA ; MembraneFactories: [MF_Julia] [MF_OSGi] MF_Tinfi ;  MembraneGeneration: [JavaCompilers] MembraneGenerators ;  PropertyTypes: [Property_JAXB] Property_Java Property_XSD ;  Interfaces: [Interface_Native] [Interface_WSDL] Interface_Java ;  Bindings: [Binding_WS] [Binding_UPnP] [Binding_JSON_RPC] [Binding_REST] Binding_SCA [Binding_JavaRMI] [Binding_HTTP] [Binding_JNA] [Binding_JMS] ;  Implementations: [Implementation_Script] [Implementation_Fractal] [Implementation_Resource] [Implementation_OSGi] Implementation_Composite [Implementation_BPEL] [Implementation_Spring] Implementation_Java ; JavaCompilers: (JDKSix|JDT) ;  MembraneGenerators: [MG_Tinfi] [MG_OSGi] ;  Implementation_Script: [JRuby] [Jython] [FScript] [BeanShell] [Groovy] [JavaScript] [Xquery] ;  Implementation_OSGi: (Apache_Felix|Knopflerfish|Equinox) ;  (Interface_Java -> MM_SCA); (Implementation_Spring -> MM_SCA); (Implementation_Script -> MM_FraSCAti); (Implementation_OSGi -> MF_OSGi); (Fscript -> BindingFactory); (Implementation_BPEL -> MM_SCA); (Binding_JSON_RPC -> MM_FraSCAti); (Explorer -> Implementation_Fractal); (JMX -> AssemblyFactory); (Implementation_OSGi -> MM_FraSCAti); (Binding_JMS -> BindingFactory); (Implementation_Java -> MM_SCA); (Binding_UPnP -> MM_UPnP); (Fscript -> AssemblyFactory); (Implementation_BPEL -> Interface_WSDL); (MF_OSGi -> Implementation_OSGi); (MF_OSGi -> MG_OSGi); (Binding_HTTP -> MM_Tuscany); (Binding_SCA -> MM_SCA); (Binding_WS -> BindingFactory); (Binding_REST -> MM_FraSCAti); (Binding_JMS -> MM_SCA); (Explorer -> AssemblyFactory); (RemoteManagement -> Fscript); (Binding_WS -> MM_SCA); (RemoteManagement -> Binding_REST); (Binding_JSON_RPC -> BindingFactory); (Binding_JavaRMI -> MM_FraSCAti); (Fscript -> Implementation_Fractal); (Interface_WSDL -> MM_SCA); (Interface_Native -> MM_Native); (Implementation_Fractal -> MM_FraSCAti); (Implementation_OSGi -> MG_OSGi); (MG_OSGi -> Implementation_OSGi); (AssemblyFactory -> ScaParser); (FScript -> Fscript); (AssemblyFactory -> ComponentFactory); (Explorer -> BindingFactory); (MG_OSGi -> MF_OSGi); (Binding_UPnP -> BindingFactory); (Binding_JavaRMI -> BindingFactory); (Implementation_Composite -> MM_SCA); (Implementation_Resource -> MM_Tuscany); (Binding_REST -> BindingFactory); (RemoteManagement -> AssemblyFactory); (Binding_JNA -> MM_Native);)"
>> list of DomainElement
[ROASSAL] DomainElement id="frascati" refers_on=[fm_frascati] MultiplicityElement=[me_frascati] belongs_to=[]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_frascati" lowerBound=1 upperBound=1
>> list of Feature
[ROASSAL] Feature id="fm_frascati.ComponentFactory" name="ComponentFactory"
[ROASSAL] Feature id="fm_frascati.MG_Tinfi" name="MG_Tinfi"
[ROASSAL] Feature id="fm_frascati.Interfaces" name="Interfaces"
[ROASSAL] Feature id="fm_frascati.Explorer" name="Explorer"
[ROASSAL] Feature id="fm_frascati.Binding_JMS" name="Binding_JMS"
[ROASSAL] Feature id="fm_frascati.JavaCompilers" name="JavaCompilers"
[ROASSAL] Feature id="fm_frascati.BindingFactory" name="BindingFactory"
[ROASSAL] Feature id="fm_frascati.MF_Julia" name="MF_Julia"
[ROASSAL] Feature id="fm_frascati.Interface_WSDL" name="Interface_WSDL"
[ROASSAL] Feature id="fm_frascati.JDT" name="JDT"
[ROASSAL] Feature id="fm_frascati.Implementations" name="Implementations"
[ROASSAL] Feature id="fm_frascati.Property_JAXB" name="Property_JAXB"
[ROASSAL] Feature id="fm_frascati.MembraneGenerators" name="MembraneGenerators"
[ROASSAL] Feature id="fm_frascati.Implementation_Resource" name="Implementation_Resource"
[ROASSAL] Feature id="fm_frascati.Implementation_Fractal" name="Implementation_Fractal"
[ROASSAL] Feature id="fm_frascati.Binding_REST" name="Binding_REST"
[ROASSAL] Feature id="fm_frascati.Binding_UPnP" name="Binding_UPnP"
[ROASSAL] Feature id="fm_frascati.JMX" name="JMX"
[ROASSAL] Feature id="fm_frascati.Metamodels" name="Metamodels"
[ROASSAL] Feature id="fm_frascati.Implementation_OSGi" name="Implementation_OSGi"
[ROASSAL] Feature id="fm_frascati.Binding_JavaRMI" name="Binding_JavaRMI"
[ROASSAL] Feature id="fm_frascati.MM_SCA" name="MM_SCA"
[ROASSAL] Feature id="fm_frascati.BeanShell" name="BeanShell"
[ROASSAL] Feature id="fm_frascati.Groovy" name="Groovy"
[ROASSAL] Feature id="fm_frascati.Implementation_Composite" name="Implementation_Composite"
[ROASSAL] Feature id="fm_frascati.MG_OSGi" name="MG_OSGi"
[ROASSAL] Feature id="fm_frascati.Equinox" name="Equinox"
[ROASSAL] Feature id="fm_frascati.MembraneGeneration" name="MembraneGeneration"
[ROASSAL] Feature id="fm_frascati.JavaScript" name="JavaScript"
[ROASSAL] Feature id="fm_frascati.Implementation_BPEL" name="Implementation_BPEL"
[ROASSAL] Feature id="fm_frascati.Binding_JNA" name="Binding_JNA"
[ROASSAL] Feature id="fm_frascati.Interface_Native" name="Interface_Native"
[ROASSAL] Feature id="fm_frascati.RemoteManagement" name="RemoteManagement"
[ROASSAL] Feature id="fm_frascati.Property_XSD" name="Property_XSD"
[ROASSAL] Feature id="fm_frascati.MM_FraSCAti" name="MM_FraSCAti"
[ROASSAL] Feature id="fm_frascati.Xquery" name="Xquery"
[ROASSAL] Feature id="fm_frascati.Binding_SCA" name="Binding_SCA"
[ROASSAL] Feature id="fm_frascati.MF_OSGi" name="MF_OSGi"
[ROASSAL] Feature id="fm_frascati.PropertyTypes" name="PropertyTypes"
[ROASSAL] Feature id="fm_frascati.FraSCAti" name="FraSCAti"
[ROASSAL] Feature id="fm_frascati.Binding_WS" name="Binding_WS"
[ROASSAL] Feature id="fm_frascati.JRuby" name="JRuby"
[ROASSAL] Feature id="fm_frascati.Jython" name="Jython"
[ROASSAL] Feature id="fm_frascati.FScript" name="FScript"
[ROASSAL] Feature id="fm_frascati.MF_Tinfi" name="MF_Tinfi"
[ROASSAL] Feature id="fm_frascati.Binding_HTTP" name="Binding_HTTP"
[ROASSAL] Feature id="fm_frascati.Bindings" name="Bindings"
[ROASSAL] Feature id="fm_frascati.Property_Java" name="Property_Java"
[ROASSAL] Feature id="fm_frascati.Implementation_Spring" name="Implementation_Spring"
[ROASSAL] Feature id="fm_frascati.Binding_JSON_RPC" name="Binding_JSON_RPC"
[ROASSAL] Feature id="fm_frascati.AssemblyFactory" name="AssemblyFactory"
[ROASSAL] Feature id="fm_frascati.Knopflerfish" name="Knopflerfish"
[ROASSAL] Feature id="fm_frascati.JDKSix" name="JDKSix"
[ROASSAL] Feature id="fm_frascati.MM_UPnP" name="MM_UPnP"
[ROASSAL] Feature id="fm_frascati.Fscript" name="Fscript"
[ROASSAL] Feature id="fm_frascati.MM_Native" name="MM_Native"
[ROASSAL] Feature id="fm_frascati.MembraneFactories" name="MembraneFactories"
[ROASSAL] Feature id="fm_frascati.ScaParser" name="ScaParser"
[ROASSAL] Feature id="fm_frascati.Implementation_Java" name="Implementation_Java"
[ROASSAL] Feature id="fm_frascati.Interface_Java" name="Interface_Java"
[ROASSAL] Feature id="fm_frascati.Implementation_Script" name="Implementation_Script"
[ROASSAL] Feature id="fm_frascati.Apache_Felix" name="Apache_Felix"
[ROASSAL] Feature id="fm_frascati.MM_Tuscany" name="MM_Tuscany"
[ROASSAL] END MODEL
'! !

!SPParserTest methodsFor: 'action deselect' stamp: 'SimonUrli 12/11/2012 11:17'!
testActionDeselect1
	| actionDeselect |
	
	actionDeselect := parser parseActionDeselect: '[ROASSAL] ActionDeselect id="AD_0" feature=[PictureAlbum] fm=[fm_renderer]'.
	
	self assert: actionDeselect name = 'AD_0'.
	self assert: actionDeselect feature = 'PictureAlbum'.
	self assert: actionDeselect fm = 'fm_renderer'.! !

!SPParserTest methodsFor: 'action select' stamp: 'SimonUrli 12/11/2012 11:17'!
testActionSelect1
	| actionDeselect |
	
	actionDeselect := parser parseActionSelect: '[ROASSAL] ActionSelect id="AS_0" feature=[Calendar] fm=[fm_renderer]'.
	
	self assert: actionDeselect name = 'AS_0'.
	self assert: actionDeselect feature = 'Calendar'.
	self assert: actionDeselect fm = 'fm_renderer'.! !

!SPParserTest methodsFor: 'begin end' stamp: 'AlexandreBergel 11/19/2012 12:27'!
testBeginEnd

	self should: [ parser parse: '' ] raise: Error.
	self should: [ parser parse: '[ROASSAL] BEGIN MODEL' ] raise: Error.
	self should: [ parser parse: '[ROASSAL] END MODEL' ] raise: Error.
	
	self shouldnt: [ parser parse: '[ROASSAL] BEGIN MODEL', String cr, '[ROASSAL] END MODEL' ] raise: Error.
	self shouldnt: [ parser parse: '>> list of FeatureModels', String cr, 
									'[ROASSAL] BEGIN MODEL', String cr, 
									'[ROASSAL] END MODEL' ] raise: Error.! !

!SPParserTest methodsFor: 'configuration state' stamp: 'SimonUrli 12/12/2012 12:31'!
testConfigurationState1
	| configurationState |
	
	configurationState := parser parseConfigurationState: '[ROASSAL] ConfigurationState id="cs_Rule_0" fm=[fm_source] selected=[Calendar] deselected=[]'.
	
	self assert: configurationState name = 'cs_Rule_0'.
	self assert: configurationState fm = 'fm_source'.
	self assert: configurationState selected = #('Calendar').
	self assert: configurationState deselected = #().! !

!SPParserTest methodsFor: 'configuration state' stamp: 'SimonUrli 12/12/2012 12:32'!
testConfigurationState2
	| configurationState |
	
	parser parse: self trace1.
	parser resolve.
	 
	configurationState := parser mooseModel entityNamed: 'cs_Rule_0'.
	
	self assert: configurationState name = 'cs_Rule_0'.
	self assert: configurationState fm = (parser mooseModel entityNamed: 'fm_source').
	self assert: configurationState selected = { parser mooseModel entityNamed: 'fm_source.PictureAlbum' }.
	self assert: configurationState deselected = #().
	 ! !

!SPParserTest methodsFor: 'configuration state' stamp: 'AlexandreBergel 11/23/2012 11:24'!
testConfigurationState4
	| config |
	
	parser parse: self trace1.
	parser resolve.
	
	config :=  parser mooseModel entityNamed: 'cs_Rule_1'.
	
	self assert: config selected isEmpty.
	self assert: config deselected size = 1.
	! !

!SPParserTest methodsFor: 'domain element' stamp: 'SimonUrli 12/12/2012 15:42'!
testDomainElement1
	| domainElementAssociation |
	
	domainElementAssociation := parser parseDEAssociation: '[ROASSAL] DEAssociation id="AssoSourceRenderer" source=[DEAEnd_AssoSourceRenderer_source] target=[DEAEnd_AssoSourceRenderer_target] restrictionFunctions=[SourceRendererTypeInfo]'.
	
	self assert: domainElementAssociation name = 'AssoSourceRenderer'.
	self assert: domainElementAssociation source = 'DEAEnd_AssoSourceRenderer_source'.
	self assert: domainElementAssociation target = 'DEAEnd_AssoSourceRenderer_target'.
	self assert: domainElementAssociation restrictionFunctions = #('SourceRendererTypeInfo').! !

!SPParserTest methodsFor: 'domain element' stamp: 'SimonUrli 12/12/2012 15:46'!
testDomainElement2
	| domainElement |
	
	domainElement := parser parseDomainElement: '[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_DE_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]'.
	
	self assert: domainElement name = 'source'.
	self assert: domainElement belongsTo = #('AssoSourceRenderer' 'AssoRendererSource').
	self assert: domainElement refersOn = 'fm_source'.
	self assert: domainElement multiplicityElement = 'me_DE_source'.! !

!SPParserTest methodsFor: 'domain element' stamp: 'SimonUrli 12/12/2012 15:53'!
testDomainElementEnd1
	| domainElementEnd |
	
	domainElementEnd := parser parseDomainElementEnd: '[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]'.
	
	self assert: domainElementEnd name = 'DEAEnd_AssoSourceRenderer_source'.
	self assert: domainElementEnd applyOn = 'source'.
	self assert: domainElementEnd linkMultiplicity = 'me_DEAEnd_AssoSourceRenderer_source'.! !

!SPParserTest methodsFor: 'domain element' stamp: 'SimonUrli 11/23/2012 21:43'!
testDomainElementWithAssociatedElement
	| domainElement |
	
	parser parse: self trace1.
	parser resolve.
	
	domainElement := parser mooseModel entityNamed: 'source'.
	
	self assert: domainElement name = 'source'.
	self assert: domainElement associatedDomainElements notEmpty.
	self assert: domainElement associatedDomainElements first == (parser mooseModel entityNamed: 'renderer') .! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/23/2012 11:32'!
testFailingParsing

	self should: [ parser getListNamed: 'selected' from: '[ROASSAL] ConfigurationState id="cs_Rule_1" fm=[fm_source] selected[] deselected=[fm_source.PictureAlbum]' ] raise: Error! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 11/23/2012 21:34'!
testFeature1
	| feature |
	
	feature := parser parseFeature: '[ROASSAL] Feature id="fm_layout.Picture" name="Picture"'.
	
	self assert: feature name = 'fm_layout.Picture'.
	self assert: feature shortName = 'Picture'.
! !

!SPParserTest methodsFor: 'feature model' stamp: 'AlexandreBergel 11/23/2012 11:03'!
testFeatureModel1
	| featureModel |
	featureModel := parser parseFeatureModel: '[ROASSAL] FeatureModel id="fm_source" features=[fm_source.Period,fm_source.Sort,fm_source.Popularity,fm_source.TimeLine,fm_source.Calendar,fm_source.Criteria,fm_source.Tweets,fm_source.Name,fm_source.Source,fm_source.TypeInfo,fm_source.FlickR,fm_source.Filter,fm_source.PictureAlbum,fm_source.Date,fm_source.HyperCal,fm_source.Picasa,fm_source.ICalReader,fm_source.Album,fm_source.Twitter] familiar="FM(Source: TypeInfo [Criteria] ;  TypeInfo: (Tweets|Calendar|PictureAlbum) ;  Criteria: [Filter] [Sort] ;  Tweets: Twitter ;  Calendar: (ICalReader|HyperCal) ;  PictureAlbum: (FlickR|Picasa) ;  Filter: (TimeLine|Album|Period) ;  Sort: (Popularity|Date|Name) ;  (TimeLine -> Twitter); (Album -> PictureAlbum); ((Popularity & Date) -> (Twitter | PictureAlbum)); (Name -> PictureAlbum); (Period -> Calendar);)"'.
	
	self assert: featureModel class == SPFeatureModel.
	self assert: featureModel name = 'fm_source'.
	
	self assert: featureModel fmFeatureModel notNil.
	self assert: featureModel numberOfFeatures = 19.
	
	self assert: featureModel numberOfFeatures = featureModel fmFeatureModel numberOfFeatures! !

!SPParserTest methodsFor: 'feature model' stamp: 'SimonUrli 11/26/2012 10:17'!
testFeatureModelResolve

	| feature fm |
	parser parse: self trace1.
	
	feature := parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	fm := parser mooseModel entityNamed: 'fm_source'.
	self assert: feature notNil.
	self assert: feature class == SPFeature.
	self assert: feature fmFeature isNil.
	self assert: feature featureModel isNil.
	
	parser resolve.
	self assert: feature fmFeature notNil.
	self assert: feature fmFeature name = 'PictureAlbum'.
	self assert: feature featureModel = fm.! !

!SPParserTest methodsFor: 'feature model' stamp: 'SimonUrli 11/26/2012 11:11'!
testFeatureModelResolveAndFeatureChildren
	| featurePictureAlbum featurePicasa featureFlickR subFeaturesName |
	parser parse: self trace1.
	
	featurePictureAlbum := parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	featurePicasa :=  parser mooseModel entityNamed: 'fm_source.Picasa'.
	featureFlickR :=  parser mooseModel entityNamed: 'fm_source.FlickR'.
	
	self assert: featurePictureAlbum notNil.
	self assert: featurePicasa notNil.
	self assert: featureFlickR notNil.
	self assert: featurePictureAlbum featureChildren isNil.
	self assert: featurePicasa featureChildren isNil.
	self assert: featureFlickR featureChildren isNil.
	
	parser resolve.
	self assert: featurePictureAlbum featureChildren notNil.
	self assert: featurePictureAlbum featureChildren isEmpty not.
	self assert: (featurePictureAlbum featureChildren includes: featurePicasa).
	self assert: (featurePictureAlbum featureChildren includes: featureFlickR).! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/20/2012 09:52'!
testGetIdFrom

	self assert: (parser getIdFrom: '[ROASSAL] DomainElement id="Source" Multipli') = 'Source'.
	self assert: (parser getIdFrom: '[ROASSAL] RestrictionFunction id="RendererSourceTypeInfo" rules=[TypeInfo3,TypeInfo4]') = 'RendererSourceTypeInfo'.! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/20/2012 10:09'!
testGetListNamedFrom

	self assert: (parser getListNamed: 'rules' from: '[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[TypeInfo1,TypeInfo2]')
					= #('TypeInfo1' 'TypeInfo2').

	self assert: (parser getListNamed: 'restrictionFunctions' from: '[ROASSAL] FMAssociation id="AssociationZoneRenderer" source=FMAEnd(apply_on=[Zone] LinkMultiplicity=ME(1,1)) target=FMAEnd(apply_on=[Renderer] LinkMultiplicity=ME(1,-1)) restrictionFunctions=[ZoneRendererElements]')
					= #('ZoneRendererElements').
					
	self assert: (parser getListNamed: 'belongs_to' from: '[ROASSAL] DomainElement id="Source" MultiplicityElement=ME(1,-1) belongs_to=[AssociationSourceRenderer,AssociationRendererSource] refers_on=[Source]') = #('AssociationSourceRenderer' 'AssociationRendererSource')! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 12/12/2012 12:16'!
testLaunchActionsOnFeatures
	| configurationState feature |
	
	parser parse: self trace1.
	parser resolve.
	
	feature :=  parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	
	self assert: feature launchActionsOnFeatures size = 2.
	self assert: feature launchActionsOnFeatures = { parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'.parser mooseModel entityNamed: 'fm_renderer.PictureAlbum' }! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 11/26/2012 17:25'!
testMetricsWithActions
	| configurationState feature |
	
	parser parse: self trace1.
	parser resolve.
	
	feature :=  parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	
	self assert: feature numberOfDeselectedActions = 1.
	self assert: feature deselectedActions asArray = { parser mooseModel entityNamed: 'AD_3' }.

	self assert: feature numberOfSelectedActions = 1.
	self assert: feature selectedActions asArray = { parser mooseModel entityNamed: 'AS_3' }.

	self assert: feature numberOfActions = 2.
	self assert: feature actions asArray = { parser mooseModel entityNamed: 'AD_3'.parser mooseModel entityNamed: 'AS_3' }! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 12/11/2012 11:33'!
testMetricsWithConfigurationState
	| configurationState feature |
	
	parser parse: self trace1.
	parser resolve.
	
	feature :=  parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	
	self assert: feature numberOfConfigurationSelectedStates = 1.
	self assert: feature configurationSelectedStates asArray = { parser mooseModel entityNamed: 'cs_Rule_0' }.
	
	self assert: feature numberOfConfigurationDeselectedStates = 1.
	self assert: feature configurationDeselectedStates asArray = { parser mooseModel entityNamed: 'cs_Rule_1' }.
	self assert: feature numberOfConfigurationStates = 2.
	self assert: feature configurationStates asArray = {parser mooseModel entityNamed: 'cs_Rule_0'. parser mooseModel entityNamed: 'cs_Rule_1' }.
	self assert: feature launchActionsOnFeatures asArray = {parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'.parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'}.
	self assert: feature isLaunchedByFeatures asArray = {parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'.parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'}.! !

!SPParserTest methodsFor: 'multiplicity' stamp: 'AlexandreBergel 11/22/2012 08:46'!
testMultiplicity1
	| multiplicity |
	
	multiplicity := parser parseMultiplicityElement: '[ROASSAL] MultiplicityElement id="me_DE_renderer" lowerBound=1 upperBound=-1'.
	
	self assert: multiplicity name = 'me_DE_renderer'.
	self assert: multiplicity lowerBound = 1.
	self assert: multiplicity upperBound = -1! !

!SPParserTest methodsFor: 'parsing' stamp: 'AlexandreBergel 11/23/2012 11:12'!
testParsing

	self assert: parser mooseModel size = 0.
	parser parse: self trace1.
	self assert: parser mooseModel size = 259.
	self assert: (parser mooseModel entities allSatisfy: [ :el | el mooseModel == parser mooseModel ])! !

!SPParserTest methodsFor: 'parsing' stamp: 'SimonUrli 12/12/2012 15:53'!
testResolveDependencies


	| deaEnd source linkMultiplicity listeDE |
	parser parse: self trace1.
	deaEnd := parser mooseModel entityNamed: 'DEAEnd_AssoSourceRenderer_source'.
	source := parser mooseModel entityNamed: 'source'.
	linkMultiplicity := parser mooseModel entityNamed: 'me_DEAEnd_AssoSourceRenderer_source'.
	
	self assert: deaEnd applyOn = 'source'.
	self assert: deaEnd linkMultiplicity = 'me_DEAEnd_AssoSourceRenderer_source'.
	
	parser resolve.

	self assert: deaEnd applyOn = source.
	self assert: deaEnd linkMultiplicity = linkMultiplicity.! !

!SPParserTest methodsFor: 'parsing' stamp: 'SimonUrli 12/11/2012 11:30'!
testResolveDependenciesWithDomainElement

	
	| featureModel feature familiarFeature action |
	parser parse: self trace1.
	featureModel := parser mooseModel entityNamed: 'fm_renderer'.
	self assert: featureModel notNil.

	action := parser mooseModel entityNamed: 'AD_0'.
	self assert: action feature = 'fm_renderer.PictureAlbum'.

	"We link everything"
	parser resolve.
	
	familiarFeature := featureModel getFeatureNamed: 'fm_renderer.PictureAlbum'.
	self assert: familiarFeature notNil.
	self assert: familiarFeature class == SPFeature.
	
	self assert: action feature = familiarFeature.! !

!SPParserTest methodsFor: 'parsing' stamp: 'SimonUrli 12/11/2012 11:27'!
testResolveDependenciesWithDomainElementWithError

	
	| featureModel feature familiarFeature action featureModel1 featureModel2 familiarFeature1 familiarFeature2 |
	parser parse: self trace1.
	featureModel1 := parser mooseModel entityNamed: 'fm_source'.
	featureModel2 := parser mooseModel entityNamed: 'fm_renderer'.

	"We link everything"
	parser resolve.
	
	familiarFeature1 := featureModel1 getFeatureNamed: 'fm_source.PictureAlbum'.
	familiarFeature2 := featureModel2 getFeatureNamed: 'fm_renderer.PictureAlbum'.
	self assert: familiarFeature1 ~~ familiarFeature2.
	"self assert: familiarFeature1 ~= familiarFeature2."
	self assert: familiarFeature1 name = 'fm_source.PictureAlbum'.
	self assert: familiarFeature2 name = 'fm_renderer.PictureAlbum'.
	 
	
	"---"
	action := parser mooseModel entityNamed: 'AD_0'.
	"self assert: action feature ~= { familiarFeature1 }."
	self assert: action feature = familiarFeature2.! !

!SPParserTest methodsFor: 'restriction function' stamp: 'AlexandreBergel 11/22/2012 09:12'!
testRestrictionFunction
	| restrictionFunction |
	
	restrictionFunction := parser parseRestrictionFunction: '[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[Rule_0,Rule_1]'.
	
	self assert: restrictionFunction name = 'SourceRendererTypeInfo'.
	self assert: restrictionFunction rules = #('Rule_0' 'Rule_1').! !

!SPParserTest methodsFor: 'rules' stamp: 'SimonUrli 12/12/2012 15:59'!
testRule1
	| rule |
	
	rule := parser parseRule: '[ROASSAL] Rule id="Rule_0" state=[cs_Rule_0] actions=[AS_0]'.
	
	self assert: rule name = 'Rule_0'.
	self assert: rule state = 'cs_Rule_0'.
	self assert: rule actions = 'AS_0'.! !

!SPParserTest methodsFor: 'rules' stamp: 'SimonUrli 12/12/2012 15:59'!
testRuleResolve
	
	| rule cs action |
	parser parse: self trace1.
	
	rule := parser mooseModel entityNamed: 'Rule_0'.
	cs := parser mooseModel entityNamed: 'cs_Rule_0'.
	action := parser mooseModel entityNamed: 'AS_0'.
	
	self assert: rule notNil.
	self assert: cs notNil.
	self assert: action notNil.
	
	self assert: rule state = 'cs_Rule_0'.
	self assert: rule actions = 'AS_0'.
	parser resolve.
	
	self assert: rule state = cs.
	self assert: rule actions = action.
	self assert: action rule = rule.
	self assert: cs rule = rule.
	! !

!SPParserTest methodsFor: 'begin end' stamp: 'AlexandreBergel 11/19/2012 15:56'!
testTag

	self should: [ parser assertBeginWithTag: '>> list of FeatureModels' ] raise: Error.
	self shouldnt: [ parser assertBeginWithTag: '[ROASSAL] FeatureModel' ] raise: Error! !

!SPParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 11/23/2012 11:33'!
trace1

^'[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_source" features=[fm_source.Period,fm_source.Sort,fm_source.Popularity,fm_source.TimeLine,fm_source.Calendar,fm_source.Criteria,fm_source.Tweets,fm_source.Source,fm_source.Name,fm_source.TypeInfo,fm_source.FlickR,fm_source.Filter,fm_source.PictureAlbum,fm_source.HyperCal,fm_source.Date,fm_source.Picasa,fm_source.ICalReader,fm_source.Album,fm_source.Twitter] familiar="FM(Source: TypeInfo [Criteria] ;  TypeInfo: (Tweets|Calendar|PictureAlbum) ;  Criteria: [Filter] [Sort] ;  Tweets: Twitter ;  Calendar: (ICalReader|HyperCal) ;  PictureAlbum: (FlickR|Picasa) ;  Filter: (TimeLine|Album|Period) ;  Sort: (Popularity|Date|Name) ;  (TimeLine -> Twitter); (Album -> PictureAlbum); ((Popularity & Date) -> (Twitter | PictureAlbum)); (Name -> PictureAlbum); (Period -> Calendar);)"
[ROASSAL] FeatureModel id="fm_devices" features=[fm_devices.Resolution,fm_devices.Product,fm_devices.Monitor,fm_devices.R1280x1024,fm_devices.Devices,fm_devices.M12F913,fm_devices.R1920x1080,fm_devices.X2427HD,fm_devices.R1600x900,fm_devices.TV,fm_devices.R1440x900] familiar="FM(Devices: Resolution Product ;  Resolution: (R1600x900|R1920x1080|R1280x1024|R1440x900) ;  Product: (Monitor|TV) ;  Monitor: X2427HD ;  TV: M12F913 ;  (X2427HD <-> (R1600x900 | R1920x1080)); (M12F913 <-> (R1280x1024 | R1440x900));)"
[ROASSAL] FeatureModel id="fm_renderer" features=[fm_renderer.Picture,fm_renderer.FullTweet,fm_renderer.Mosaic,fm_renderer.Week,fm_renderer.Format,fm_renderer.Slide,fm_renderer.Logo,fm_renderer.ContentOnly,fm_renderer.Calendar,fm_renderer.Day,fm_renderer.Tweets,fm_renderer.Month,fm_renderer.Title,fm_renderer.Cadre,fm_renderer.TypeInfo,fm_renderer.Text,fm_renderer.Renderer,fm_renderer.PictureAlbum,fm_renderer.Ligne,fm_renderer.Content] familiar="FM(Renderer: TypeInfo Format ;  TypeInfo: (Tweets|Calendar|PictureAlbum) ;  Format: (Cadre|Ligne) ;  Tweets: (ContentOnly|FullTweet) ;  Calendar: (Day|Week|Month) ;  PictureAlbum: (Mosaic|Slide) ;  Cadre: [Title] [Picture] Text ;  Ligne: Content [Logo] ;  (Logo <-> ContentOnly); (Calendar -> ((Cadre & Title) | (Ligne & !!Logo))); (Cadre -> ((FullTweet | Calendar) | PictureAlbum)); (ContentOnly -> (Ligne & Logo)); (Title <-> Calendar); (Ligne -> (ContentOnly | Calendar)); (FullTweet -> (Cadre & Picture)); (Picture -> (PictureAlbum | FullTweet)); (PictureAlbum -> (Cadre & Picture));)"
[ROASSAL] FeatureModel id="fm_layout" features=[fm_layout.Picture,fm_layout.IRSAM,fm_layout.Format,fm_layout.Resolution,fm_layout.Logo,fm_layout.CA,fm_layout.R1600x900,fm_layout.Title,fm_layout.Two,fm_layout.R1440x900,fm_layout.Cadre,fm_layout.EPU,fm_layout.Text,fm_layout.N2I,fm_layout.Layout,fm_layout.R1280x1024,fm_layout.Ligne,fm_layout.Zone,fm_layout.R1920x1080,fm_layout.One,fm_layout.Content] familiar="FM(Layout: Resolution Zone Format ;  Resolution: (R1600x900|R1920x1080|R1280x1024|R1440x900) ;  Zone: (Two|One) ;  Format: (Cadre|Ligne)+ ;  Two: (EPU|N2I) ;  One: (CA|IRSAM) ;  Cadre: [Title] [Picture] Text ;  Ligne: Content [Logo] ;  (EPU -> ((R1600x900 | R1920x1080) & ((Logo & Picture) & Title))); (R1920x1080 -> (N2I | EPU)); (Title -> EPU); (CA -> (((R1280x1024 & Cadre) & Picture) & !!Ligne)); (IRSAM -> ((R1440x900 & Cadre) & !!Ligne)); (!!Ligne -> (IRSAM | CA)); (N2I -> ((R1920x1080 & Picture) & Logo)); (Picture -> ((N2I | EPU) | CA));)"
>> list of DEAEnd
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererSource_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_target" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoRendererSource_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererLayout_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererLayout_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererLayout_target" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoRendererLayout_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutRenderer_source" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoLayoutRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoLayoutRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererDevices_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererDevices_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererDevices_target" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoRendererDevices_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesRenderer_source" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoDevicesRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoDevicesRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutDevices_source" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoLayoutDevices_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutDevices_target" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoLayoutDevices_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesLayout_source" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoDevicesLayout_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesLayout_target" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoDevicesLayout_target]
>> list of ActionDeselect
[ROASSAL] ActionDeselect id="AD_0" feature=[fm_renderer.PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_1" feature=[fm_renderer.Calendar] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_2" feature=[fm_renderer.Tweets] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_3" feature=[fm_source.PictureAlbum] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_4" feature=[fm_source.Calendar] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_5" feature=[fm_source.Tweets] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_6" feature=[fm_source.HyperCal] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_8" feature=[fm_renderer.Cadre] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_7" feature=[fm_renderer.Ligne] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_9" feature=[fm_renderer.Logo] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_10" feature=[fm_renderer.Picture] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_11" feature=[fm_renderer.Title] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_12" feature=[fm_renderer.Mosaic] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_13" feature=[fm_devices.R1280x1024] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_14" feature=[fm_devices.R1600x900] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_15" feature=[fm_devices.R1440x900] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_16" feature=[fm_devices.R1920x1080] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_17" feature=[fm_layout.R1280x1024] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_18" feature=[fm_layout.R1600x900] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_19" feature=[fm_layout.R1440x900] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_20" feature=[fm_layout.R1920x1080] fm=[fm_layout]
>> list of ActionSelect
[ROASSAL] ActionSelect id="AS_0" feature=[fm_renderer.PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_1" feature=[fm_renderer.Calendar] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_2" feature=[fm_renderer.Tweets] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_6" feature=[fm_renderer.Day] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_3" feature=[fm_source.PictureAlbum] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_4" feature=[fm_source.Calendar] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_5" feature=[fm_source.Tweets] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_8" feature=[fm_layout.Cadre] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_7" feature=[fm_layout.Ligne] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_9" feature=[fm_layout.Logo] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_10" feature=[fm_layout.Picture] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_11" feature=[fm_layout.Title] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_12" feature=[fm_devices.R1920x1080] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_13" feature=[fm_devices.R1280x1024] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_14" feature=[fm_devices.R1600x900] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_15" feature=[fm_devices.R1440x900] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_16" feature=[fm_devices.R1920x1080] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_17" feature=[fm_layout.R1280x1024] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_18" feature=[fm_layout.R1600x900] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_19" feature=[fm_layout.R1440x900] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_20" feature=[fm_layout.R1920x1080] fm=[fm_layout]
>> list of DomainElement
[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_DE_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]
[ROASSAL] DomainElement id="devices" refers_on=[fm_devices] MultiplicityElement=[me_DE_devices] belongs_to=[AssoRendererDevices,AssoDevicesRenderer,AssoLayoutDevices,AssoDevicesLayout]
[ROASSAL] DomainElement id="renderer" refers_on=[fm_renderer] MultiplicityElement=[me_DE_renderer] belongs_to=[AssoSourceRenderer,AssoRendererSource,AssoRendererLayout,AssoLayoutRenderer,AssoRendererDevices,AssoDevicesRenderer]
[ROASSAL] DomainElement id="layout" refers_on=[fm_layout] MultiplicityElement=[me_DE_layout] belongs_to=[AssoDevicesLayout,AssoLayoutDevices,AssoLayoutRenderer,AssoRendererLayout]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_DE_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_devices" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DE_renderer" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_layout" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererLayout_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererLayout_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutRenderer_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererDevices_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererDevices_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesRenderer_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutDevices_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutDevices_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesLayout_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesLayout_target" lowerBound=1 upperBound=1
>> list of ConfigurationState
[ROASSAL] ConfigurationState id="cs_Rule_0" fm=[fm_source] selected=[fm_source.PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_2" fm=[fm_source] selected=[fm_source.Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_4" fm=[fm_source] selected=[fm_source.Tweets] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_1" fm=[fm_source] selected=[] deselected=[fm_source.PictureAlbum]
[ROASSAL] ConfigurationState id="cs_Rule_3" fm=[fm_source] selected=[] deselected=[fm_source.Calendar]
[ROASSAL] ConfigurationState id="cs_Rule_5" fm=[fm_source] selected=[] deselected=[fm_source.Tweets]
[ROASSAL] ConfigurationState id="cs_Rule_12" fm=[fm_source] selected=[fm_source.HyperCal] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_6" fm=[fm_renderer] selected=[fm_renderer.PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_8" fm=[fm_renderer] selected=[fm_renderer.Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_10" fm=[fm_renderer] selected=[fm_renderer.Tweets] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_7" fm=[fm_renderer] selected=[] deselected=[fm_renderer.PictureAlbum]
[ROASSAL] ConfigurationState id="cs_Rule_9" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Calendar]
[ROASSAL] ConfigurationState id="cs_Rule_11" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Tweets]
[ROASSAL] ConfigurationState id="cs_Rule_13" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Day]
[ROASSAL] ConfigurationState id="cs_Rule_15" fm=[fm_renderer] selected=[fm_renderer.Cadre] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_14" fm=[fm_renderer] selected=[fm_renderer.Ligne] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_16" fm=[fm_renderer] selected=[fm_renderer.Logo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_17" fm=[fm_renderer] selected=[fm_renderer.Picture] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_18" fm=[fm_renderer] selected=[fm_renderer.Title] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_20" fm=[fm_layout] selected=[] deselected=[fm_layout.Cadre]
[ROASSAL] ConfigurationState id="cs_Rule_19" fm=[fm_layout] selected=[] deselected=[fm_layout.Ligne]
[ROASSAL] ConfigurationState id="cs_Rule_21" fm=[fm_layout] selected=[] deselected=[fm_layout.Logo]
[ROASSAL] ConfigurationState id="cs_Rule_22" fm=[fm_layout] selected=[] deselected=[fm_layout.Picture]
[ROASSAL] ConfigurationState id="cs_Rule_23" fm=[fm_layout] selected=[] deselected=[fm_layout.Title]
[ROASSAL] ConfigurationState id="cs_Rule_24" fm=[fm_renderer] selected=[fm_renderer.Mosaic] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_25" fm=[fm_devices] selected=[] deselected=[fm_devices.R1920x1080]
[ROASSAL] ConfigurationState id="cs_Rule_26" fm=[fm_layout] selected=[fm_layout.R1280x1024] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_28" fm=[fm_layout] selected=[fm_layout.R1600x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_30" fm=[fm_layout] selected=[fm_layout.R1440x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_32" fm=[fm_layout] selected=[fm_layout.R1920x1080] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_27" fm=[fm_layout] selected=[] deselected=[fm_layout.R1280x1024]
[ROASSAL] ConfigurationState id="cs_Rule_29" fm=[fm_layout] selected=[] deselected=[fm_layout.R1600x900]
[ROASSAL] ConfigurationState id="cs_Rule_31" fm=[fm_layout] selected=[] deselected=[fm_layout.R1440x900]
[ROASSAL] ConfigurationState id="cs_Rule_33" fm=[fm_layout] selected=[] deselected=[fm_layout.R1920x1080]
[ROASSAL] ConfigurationState id="cs_Rule_34" fm=[fm_devices] selected=[fm_devices.R1280x1024] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_36" fm=[fm_devices] selected=[fm_devices.R1600x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_38" fm=[fm_devices] selected=[fm_devices.R1440x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_40" fm=[fm_devices] selected=[fm_devices.R1920x1080] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_35" fm=[fm_devices] selected=[] deselected=[fm_devices.R1280x1024]
[ROASSAL] ConfigurationState id="cs_Rule_37" fm=[fm_devices] selected=[] deselected=[fm_devices.R1600x900]
[ROASSAL] ConfigurationState id="cs_Rule_39" fm=[fm_devices] selected=[] deselected=[fm_devices.R1440x900]
[ROASSAL] ConfigurationState id="cs_Rule_41" fm=[fm_devices] selected=[] deselected=[fm_devices.R1920x1080]
>> list of Rule
[ROASSAL] Rule id="Rule_0" state=[cs_Rule_0] actions=[AS_0]
[ROASSAL] Rule id="Rule_2" state=[cs_Rule_2] actions=[AS_1]
[ROASSAL] Rule id="Rule_4" state=[cs_Rule_4] actions=[AS_2]
[ROASSAL] Rule id="Rule_1" state=[cs_Rule_1] actions=[AD_0]
[ROASSAL] Rule id="Rule_3" state=[cs_Rule_3] actions=[AD_1]
[ROASSAL] Rule id="Rule_5" state=[cs_Rule_5] actions=[AD_2]
[ROASSAL] Rule id="Rule_12" state=[cs_Rule_12] actions=[AS_6]
[ROASSAL] Rule id="Rule_6" state=[cs_Rule_6] actions=[AS_3]
[ROASSAL] Rule id="Rule_8" state=[cs_Rule_8] actions=[AS_4]
[ROASSAL] Rule id="Rule_10" state=[cs_Rule_10] actions=[AS_5]
[ROASSAL] Rule id="Rule_7" state=[cs_Rule_7] actions=[AD_3]
[ROASSAL] Rule id="Rule_9" state=[cs_Rule_9] actions=[AD_4]
[ROASSAL] Rule id="Rule_11" state=[cs_Rule_11] actions=[AD_5]
[ROASSAL] Rule id="Rule_13" state=[cs_Rule_13] actions=[AD_6]
[ROASSAL] Rule id="Rule_15" state=[cs_Rule_15] actions=[AS_8]
[ROASSAL] Rule id="Rule_14" state=[cs_Rule_14] actions=[AS_7]
[ROASSAL] Rule id="Rule_16" state=[cs_Rule_16] actions=[AS_9]
[ROASSAL] Rule id="Rule_17" state=[cs_Rule_17] actions=[AS_10]
[ROASSAL] Rule id="Rule_18" state=[cs_Rule_18] actions=[AS_11]
[ROASSAL] Rule id="Rule_20" state=[cs_Rule_20] actions=[AD_8]
[ROASSAL] Rule id="Rule_19" state=[cs_Rule_19] actions=[AD_7]
[ROASSAL] Rule id="Rule_21" state=[cs_Rule_21] actions=[AD_9]
[ROASSAL] Rule id="Rule_22" state=[cs_Rule_22] actions=[AD_10]
[ROASSAL] Rule id="Rule_23" state=[cs_Rule_23] actions=[AD_11]
[ROASSAL] Rule id="Rule_24" state=[cs_Rule_24] actions=[AS_12]
[ROASSAL] Rule id="Rule_25" state=[cs_Rule_25] actions=[AD_12]
[ROASSAL] Rule id="Rule_26" state=[cs_Rule_26] actions=[AS_13]
[ROASSAL] Rule id="Rule_28" state=[cs_Rule_28] actions=[AS_14]
[ROASSAL] Rule id="Rule_30" state=[cs_Rule_30] actions=[AS_15]
[ROASSAL] Rule id="Rule_32" state=[cs_Rule_32] actions=[AS_16]
[ROASSAL] Rule id="Rule_27" state=[cs_Rule_27] actions=[AD_13]
[ROASSAL] Rule id="Rule_29" state=[cs_Rule_29] actions=[AD_14]
[ROASSAL] Rule id="Rule_31" state=[cs_Rule_31] actions=[AD_15]
[ROASSAL] Rule id="Rule_33" state=[cs_Rule_33] actions=[AD_16]
[ROASSAL] Rule id="Rule_34" state=[cs_Rule_34] actions=[AS_17]
[ROASSAL] Rule id="Rule_36" state=[cs_Rule_36] actions=[AS_18]
[ROASSAL] Rule id="Rule_38" state=[cs_Rule_38] actions=[AS_19]
[ROASSAL] Rule id="Rule_40" state=[cs_Rule_40] actions=[AS_20]
[ROASSAL] Rule id="Rule_35" state=[cs_Rule_35] actions=[AD_17]
[ROASSAL] Rule id="Rule_37" state=[cs_Rule_37] actions=[AD_18]
[ROASSAL] Rule id="Rule_39" state=[cs_Rule_39] actions=[AD_19]
[ROASSAL] Rule id="Rule_41" state=[cs_Rule_41] actions=[AD_20]
>> list of DEAssociation
[ROASSAL] DEAssociation id="AssoSourceRenderer" source=[DEAEnd_AssoSourceRenderer_source] target=[DEAEnd_AssoSourceRenderer_target] restrictionFunctions=[SourceRendererTypeInfo,SourceRendererSpecifService]
[ROASSAL] DEAssociation id="AssoRendererSource" source=[DEAEnd_AssoRendererSource_source] target=[DEAEnd_AssoRendererSource_target] restrictionFunctions=[RendererSourceTypeInfo,RendererSourceSpecifRenderer]
[ROASSAL] DEAssociation id="AssoRendererLayout" source=[DEAEnd_AssoRendererLayout_source] target=[DEAEnd_AssoRendererLayout_target] restrictionFunctions=[FormatRendererFormatLayout]
[ROASSAL] DEAssociation id="AssoLayoutRenderer" source=[DEAEnd_AssoLayoutRenderer_source] target=[DEAEnd_AssoLayoutRenderer_target] restrictionFunctions=[FormatLayoutFormatRenderer]
[ROASSAL] DEAssociation id="AssoRendererDevices" source=[DEAEnd_AssoRendererDevices_source] target=[DEAEnd_AssoRendererDevices_target] restrictionFunctions=[SpecifRendererResoDevices]
[ROASSAL] DEAssociation id="AssoDevicesRenderer" source=[DEAEnd_AssoDevicesRenderer_source] target=[DEAEnd_AssoDevicesRenderer_target] restrictionFunctions=[NonResoDevicesNonSpecifRenderer]
[ROASSAL] DEAssociation id="AssoLayoutDevices" source=[DEAEnd_AssoLayoutDevices_source] target=[DEAEnd_AssoLayoutDevices_target] restrictionFunctions=[LayoutDevicesResolution]
[ROASSAL] DEAssociation id="AssoDevicesLayout" source=[DEAEnd_AssoDevicesLayout_source] target=[DEAEnd_AssoDevicesLayout_target] restrictionFunctions=[DevicesLayoutResolution]
>> list of RestrictionFunction
[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[Rule_0,Rule_2,Rule_4,Rule_1,Rule_3,Rule_5]
[ROASSAL] RestrictionFunction id="SourceRendererSpecifService" rules=[Rule_12]
[ROASSAL] RestrictionFunction id="RendererSourceTypeInfo" rules=[Rule_6,Rule_8,Rule_10,Rule_7,Rule_9,Rule_11]
[ROASSAL] RestrictionFunction id="RendererSourceSpecifRenderer" rules=[Rule_13]
[ROASSAL] RestrictionFunction id="FormatRendererFormatLayout" rules=[Rule_15,Rule_14,Rule_16,Rule_17,Rule_18]
[ROASSAL] RestrictionFunction id="FormatLayoutFormatRenderer" rules=[Rule_20,Rule_19,Rule_21,Rule_22,Rule_23]
[ROASSAL] RestrictionFunction id="SpecifRendererResoDevices" rules=[Rule_24]
[ROASSAL] RestrictionFunction id="NonResoDevicesNonSpecifRenderer" rules=[Rule_25]
[ROASSAL] RestrictionFunction id="LayoutDevicesResolution" rules=[Rule_26,Rule_28,Rule_30,Rule_32,Rule_27,Rule_29,Rule_31,Rule_33]
[ROASSAL] RestrictionFunction id="DevicesLayoutResolution" rules=[Rule_34,Rule_36,Rule_38,Rule_40,Rule_35,Rule_37,Rule_39,Rule_41]
>> list of Feature
[ROASSAL] Feature id="fm_source.Period" name="Period"
[ROASSAL] Feature id="fm_source.Sort" name="Sort"
[ROASSAL] Feature id="fm_source.Popularity" name="Popularity"
[ROASSAL] Feature id="fm_source.TimeLine" name="TimeLine"
[ROASSAL] Feature id="fm_source.Calendar" name="Calendar"
[ROASSAL] Feature id="fm_source.Criteria" name="Criteria"
[ROASSAL] Feature id="fm_source.Tweets" name="Tweets"
[ROASSAL] Feature id="fm_source.Source" name="Source"
[ROASSAL] Feature id="fm_source.Name" name="Name"
[ROASSAL] Feature id="fm_source.TypeInfo" name="TypeInfo"
[ROASSAL] Feature id="fm_source.FlickR" name="FlickR"
[ROASSAL] Feature id="fm_source.Filter" name="Filter"
[ROASSAL] Feature id="fm_source.PictureAlbum" name="PictureAlbum"
[ROASSAL] Feature id="fm_source.HyperCal" name="HyperCal"
[ROASSAL] Feature id="fm_source.Date" name="Date"
[ROASSAL] Feature id="fm_source.Picasa" name="Picasa"
[ROASSAL] Feature id="fm_source.ICalReader" name="ICalReader"
[ROASSAL] Feature id="fm_source.Album" name="Album"
[ROASSAL] Feature id="fm_source.Twitter" name="Twitter"
[ROASSAL] Feature id="fm_devices.Resolution" name="Resolution"
[ROASSAL] Feature id="fm_devices.Product" name="Product"
[ROASSAL] Feature id="fm_devices.Monitor" name="Monitor"
[ROASSAL] Feature id="fm_devices.R1280x1024" name="R1280x1024"
[ROASSAL] Feature id="fm_devices.Devices" name="Devices"
[ROASSAL] Feature id="fm_devices.M12F913" name="M12F913"
[ROASSAL] Feature id="fm_devices.R1920x1080" name="R1920x1080"
[ROASSAL] Feature id="fm_devices.X2427HD" name="X2427HD"
[ROASSAL] Feature id="fm_devices.R1600x900" name="R1600x900"
[ROASSAL] Feature id="fm_devices.TV" name="TV"
[ROASSAL] Feature id="fm_devices.R1440x900" name="R1440x900"
[ROASSAL] Feature id="fm_renderer.Picture" name="Picture"
[ROASSAL] Feature id="fm_renderer.FullTweet" name="FullTweet"
[ROASSAL] Feature id="fm_renderer.Mosaic" name="Mosaic"
[ROASSAL] Feature id="fm_renderer.Week" name="Week"
[ROASSAL] Feature id="fm_renderer.Format" name="Format"
[ROASSAL] Feature id="fm_renderer.Slide" name="Slide"
[ROASSAL] Feature id="fm_renderer.Logo" name="Logo"
[ROASSAL] Feature id="fm_renderer.ContentOnly" name="ContentOnly"
[ROASSAL] Feature id="fm_renderer.Calendar" name="Calendar"
[ROASSAL] Feature id="fm_renderer.Day" name="Day"
[ROASSAL] Feature id="fm_renderer.Tweets" name="Tweets"
[ROASSAL] Feature id="fm_renderer.Month" name="Month"
[ROASSAL] Feature id="fm_renderer.Title" name="Title"
[ROASSAL] Feature id="fm_renderer.Cadre" name="Cadre"
[ROASSAL] Feature id="fm_renderer.TypeInfo" name="TypeInfo"
[ROASSAL] Feature id="fm_renderer.Text" name="Text"
[ROASSAL] Feature id="fm_renderer.Renderer" name="Renderer"
[ROASSAL] Feature id="fm_renderer.PictureAlbum" name="PictureAlbum"
[ROASSAL] Feature id="fm_renderer.Ligne" name="Ligne"
[ROASSAL] Feature id="fm_renderer.Content" name="Content"
[ROASSAL] Feature id="fm_layout.Picture" name="Picture"
[ROASSAL] Feature id="fm_layout.IRSAM" name="IRSAM"
[ROASSAL] Feature id="fm_layout.Format" name="Format"
[ROASSAL] Feature id="fm_layout.Resolution" name="Resolution"
[ROASSAL] Feature id="fm_layout.Logo" name="Logo"
[ROASSAL] Feature id="fm_layout.CA" name="CA"
[ROASSAL] Feature id="fm_layout.R1600x900" name="R1600x900"
[ROASSAL] Feature id="fm_layout.Title" name="Title"
[ROASSAL] Feature id="fm_layout.Two" name="Two"
[ROASSAL] Feature id="fm_layout.R1440x900" name="R1440x900"
[ROASSAL] Feature id="fm_layout.Cadre" name="Cadre"
[ROASSAL] Feature id="fm_layout.EPU" name="EPU"
[ROASSAL] Feature id="fm_layout.Text" name="Text"
[ROASSAL] Feature id="fm_layout.N2I" name="N2I"
[ROASSAL] Feature id="fm_layout.Layout" name="Layout"
[ROASSAL] Feature id="fm_layout.R1280x1024" name="R1280x1024"
[ROASSAL] Feature id="fm_layout.Ligne" name="Ligne"
[ROASSAL] Feature id="fm_layout.Zone" name="Zone"
[ROASSAL] Feature id="fm_layout.R1920x1080" name="R1920x1080"
[ROASSAL] Feature id="fm_layout.One" name="One"
[ROASSAL] Feature id="fm_layout.Content" name="Content"
[ROASSAL] END MODEL'! !

!SPParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 12/12/2012 15:44'!
trace2

^ '[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_source" features=[fm_source.TimeLine,fm_source.Weather2,fm_source.Criteria,fm_source.Ephemeride,fm_source.Menu,fm_source.Target,fm_source.Date,fm_source.Tag,fm_source.Views,fm_source.Forecast,fm_source.SaintDuJour,fm_source.Album,fm_source.Sort,fm_source.MenuInfo,fm_source.Popularity,fm_source.Tweet,fm_source.Announces,fm_source.Calendar,fm_source.Announcement,fm_source.City,fm_source.Name,fm_source.Source,fm_source.TypeInfo,fm_source.Filter,fm_source.FlickR,fm_source.PictureAlbum,fm_source.Picasa,fm_source.ICalReader] familiar="FM(Source: TypeInfo Criteria ;  TypeInfo: (Tweet|Calendar|PictureAlbum|Forecast|Ephemeride|Announces|Menu) ;  Criteria: [Filter] [Sort] ;  Calendar: ICalReader ;  PictureAlbum: (FlickR|Picasa) ;  Forecast: Weather2 ;  Announces: Announcement ;  Ephemeride: SaintDuJour ;  Menu: MenuInfo ;  Filter: (TimeLine|Date|Album|Target|Tag)+ [City] ;  Sort: (Popularity|Views)? [Name] ;  (Tag -> !!ICalReader); (Tag -> !!MenuInfo); (Tag -> !!Announces); (Target -> !!Picasa); (Ephemeride -> !!Target); (Sort -> Filter); (TimeLine -> !!Target); (TimeLine -> Tweet); (Target -> !!Tweet); (Tag -> !!Album); (Views -> PictureAlbum); (Name -> PictureAlbum); (Target -> !!Calendar); (Popularity -> Tweet); (Target -> !!PictureAlbum); (Date -> !!Popularity); (Album -> PictureAlbum); (Target -> !!Name); (Weather2 -> !!Target); (TimeLine -> !!Tag); (Weather2 -> !!Tag); (Weather2 <-> City); (Menu -> !!Target); (Target -> !!Tag); (Ephemeride -> !!Tag);)"
[ROASSAL] FeatureModel id="fm_renderer" features=[fm_renderer.Discretization,fm_renderer.Logo,fm_renderer.Graphic,fm_renderer.Unique,fm_renderer.ByMonth,fm_renderer.Output,fm_renderer.Temporal,fm_renderer.All,fm_renderer.Criteria,fm_renderer.BySize,fm_renderer.Ephemeride,fm_renderer.Renderer,fm_renderer.ByHour,fm_renderer.ByDay,fm_renderer.FixedTime,fm_renderer.Forecast,fm_renderer.Content,fm_renderer.Block,fm_renderer.FullPicture,fm_renderer.Thumbnails,fm_renderer.Spatial,fm_renderer.Tweet,fm_renderer.Announces,fm_renderer.TenInformations,fm_renderer.Calendar,fm_renderer.Title,fm_renderer.TypeInfo,fm_renderer.Text,fm_renderer.PictureAlbum,fm_renderer.FixedNumber,fm_renderer.Elements,fm_renderer.Clustering,fm_renderer.Line,fm_renderer.FlexibleTime] familiar="FM(Renderer: TypeInfo [Criteria] Elements Output Discretization ;  TypeInfo: (Tweet|Calendar|PictureAlbum|Forecast|Ephemeride|Announces) ;  Criteria: [Clustering] ;  Elements: Content [Title] [Logo] ;  Output: (Block|Line) ;  Discretization: Spatial Temporal ;  Clustering: (ByHour|ByMonth|ByDay|BySize) ;  Content: (Graphic|Text)+ ;  Spatial: (FixedNumber|All|Unique) ;  Temporal: (FixedTime|FlexibleTime) ;  Graphic: (Thumbnails|FullPicture) ;  FixedNumber: [TenInformations] ;  (Ephemeride -> !!FullPicture); (Ephemeride -> Text); (FullPicture -> !!Announces); (ByDay -> Text); (Forecast -> Title); (Line -> Tweet); (Ephemeride -> FixedTime); (BySize -> PictureAlbum); (Title -> Block); (All -> !!FullPicture); (Announces -> Unique); (Unique -> !!Tweet); (Clustering -> Title); (Logo -> !!Unique); (Calendar -> All); (All -> Text); (Calendar -> FlexibleTime); (ByMonth -> Calendar); (TenInformations -> FixedTime); (Forecast -> Thumbnails); (Announces -> Text); (Graphic -> !!ByMonth); (FullPicture -> Title); (Forecast -> FixedTime); (Logo -> Tweet); (ByDay -> !!Tweet); (All -> !!PictureAlbum); (TenInformations -> Line); (Thumbnails -> !!TenInformations); (Unique -> !!Clustering); (Text -> !!PictureAlbum); (TenInformations -> Logo); (Unique -> !!Line); (Graphic -> !!Calendar); (BySize -> FlexibleTime); (Ephemeride -> Title); (Tweet -> Text); (ByHour -> Calendar); (Ephemeride -> Unique); (Calendar -> Title); (BySize -> FixedNumber); (BySize -> !!Text); (Thumbnails -> Text); (PictureAlbum -> FullPicture); (Graphic -> !!ByHour); (Ephemeride -> !!Thumbnails);)"
[ROASSAL] FeatureModel id="fm_zone" features=[fm_zone.LeftBarVertical,fm_zone.ThinBarFooterNoLogo,fm_zone.Product,fm_zone.ThinBarHeader,fm_zone.Graphic,fm_zone.Logo,fm_zone.Title,fm_zone.Text,fm_zone.Elements,fm_zone.ThinBarFooter,fm_zone.Zone,fm_zone.Content,fm_zone.BigSquareCenter,fm_zone.Thumbnails,fm_zone.FullPicture] familiar="FM(Zone: Product Elements ;  Product: (LeftBarVertical|ThinBarFooterNoLogo|ThinBarFooter|ThinBarHeader|BigSquareCenter) ;  Elements: Content [Title] [Logo] ;  Content: [Graphic] Text ;  Graphic: Thumbnails [FullPicture] ;  (ThinBarFooterNoLogo -> !!Title); (LeftBarVertical -> Title); (Title -> !!ThinBarFooter); (ThinBarFooterNoLogo -> !!Logo); (ThinBarHeader -> !!Title); (Logo <-> Graphic); (BigSquareCenter <-> FullPicture); (LeftBarVertical -> !!Logo);)"
[ROASSAL] FeatureModel id="fm_layout" features=[fm_layout.IRSAM,fm_layout.Academic,fm_layout.ThinBarFooterNoLogo,fm_layout.Product,fm_layout.AnyPeople,fm_layout.CA,fm_layout.Property,fm_layout.Students,fm_layout.LayoutIRSAM,fm_layout.Children,fm_layout.Design,fm_layout.Usage,fm_layout.EPU,fm_layout.LayoutEPU,fm_layout.N2I,fm_layout.Layout,fm_layout.Target,fm_layout.LayoutCA,fm_layout.Disabilities,fm_layout.VisualDisability,fm_layout.Noel,fm_layout.ThinBarFooter,fm_layout.Zones,fm_layout.BigSquareCenter] familiar="FM(Layout: Property Design Product Zones ;  Property: Usage Target ;  Design: (EPU|Noel|N2I|CA|IRSAM) ;  Product: (LayoutIRSAM|LayoutEPU|LayoutCA) ;  Zones: (ThinBarFooterNoLogo|ThinBarFooter)? BigSquareCenter ;  Usage: (Academic|Disabilities) ;  Target: (Students|Children|AnyPeople) ;  Disabilities: [VisualDisability] ;  (CA <-> Children); (IRSAM -> !!ThinBarFooterNoLogo); (AnyPeople <-> LayoutIRSAM); (Academic <-> Students); (VisualDisability -> !!ThinBarFooter); (VisualDisability <-> CA); (ThinBarFooterNoLogo -> !!LayoutCA); (IRSAM <-> AnyPeople); (LayoutCA <-> VisualDisability); (IRSAM -> !!ThinBarFooter);)"
[ROASSAL] FeatureModel id="fm_behaviour" features=[fm_behaviour.Unique,fm_behaviour.Logo,fm_behaviour.Graphic,fm_behaviour.Behaviour,fm_behaviour.Appear,fm_behaviour.Scrolling,fm_behaviour.All,fm_behaviour.Direction,fm_behaviour.ScrollingBehaviour,fm_behaviour.SimpleRepeatBehaviour,fm_behaviour.Contrast,fm_behaviour.Repeat,fm_behaviour.Thumbnails,fm_behaviour.Right,fm_behaviour.Product,fm_behaviour.Animation,fm_behaviour.HorizontalScrollingSetBehaviour,fm_behaviour.Left,fm_behaviour.Title,fm_behaviour.Text,fm_behaviour.BasicBehaviour,fm_behaviour.HorizontalScrollingBehaviour,fm_behaviour.FixedNumber,fm_behaviour.Elements,fm_behaviour.Pause,fm_behaviour.Numbers,fm_behaviour.Loop,fm_behaviour.AppearanceBehaviour] familiar="FM(Behaviour: Animation Numbers Product Elements ;  Animation: (Repeat|Pause)? (Scrolling|Appear) ;  Numbers: (FixedNumber|Unique|All) ;  Product: (AppearanceBehaviour|ScrollingBehaviour) ;  Elements: [Title] [Logo] [Graphic] Text ;  Scrolling: Direction [Loop] ;  Repeat: [Contrast] ;  AppearanceBehaviour: (SimpleRepeatBehaviour|BasicBehaviour) ;  ScrollingBehaviour: (HorizontalScrollingSetBehaviour|HorizontalScrollingBehaviour) ;  Graphic: [Thumbnails] ;  Direction: (Right|Left) ;  (HorizontalScrollingSetBehaviour <-> Pause); (Unique <-> Logo); (Appear <-> Title); (ScrollingBehaviour <-> Scrolling); (Logo <-> Appear); (FixedNumber <-> HorizontalScrollingSetBehaviour); (SimpleRepeatBehaviour <-> Repeat); (All <-> Thumbnails); (FixedNumber -> !!Loop);)"
>> list of DEAEnd
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererSource_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_target" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoRendererSource_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererZone_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererZone_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererZone_target" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoRendererZone_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneRenderer_source" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoZoneRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoZoneRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneLayout_source" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoZoneLayout_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneLayout_target" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoZoneLayout_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutZone_source" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoLayoutZone_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutZone_target" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoLayoutZone_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneBehaviour_source" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoZoneBehaviour_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneBehaviour_target" apply_on=[behaviour] linkMultiplicity=[me_DEAEnd_AssoZoneBehaviour_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoBehaviourZone_source" apply_on=[behaviour] linkMultiplicity=[me_DEAEnd_AssoBehaviourZone_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoBehaviourZone_target" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoBehaviourZone_target]
>> list of ActionDeselect
[ROASSAL] ActionDeselect id="AD_0" feature=[fm_renderer.Tweet] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_1" feature=[fm_renderer.Calendar] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_2" feature=[fm_renderer.PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_3" feature=[fm_renderer.Forecast] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_4" feature=[fm_renderer.Ephemeride] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_5" feature=[fm_renderer.Announces] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_6" feature=[fm_renderer.ByDay] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_7" feature=[fm_source.Tweet] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_8" feature=[fm_source.Calendar] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_9" feature=[fm_source.PictureAlbum] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_10" feature=[fm_source.Forecast] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_11" feature=[fm_source.Ephemeride] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_12" feature=[fm_source.Announces] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_13" feature=[fm_zone.Content] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_14" feature=[fm_zone.Graphic] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_15" feature=[fm_zone.Thumbnails] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_16" feature=[fm_zone.FullPicture] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_17" feature=[fm_zone.Text] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_18" feature=[fm_zone.Logo] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_19" feature=[fm_zone.Title] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_20" feature=[fm_renderer.Content] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_21" feature=[fm_renderer.Graphic] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_22" feature=[fm_renderer.Thumbnails] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_23" feature=[fm_renderer.FullPicture] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_24" feature=[fm_renderer.Text] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_25" feature=[fm_renderer.Title] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_26" feature=[fm_renderer.Logo] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_27" feature=[fm_layout.BigSquareCenter] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_28" feature=[fm_layout.ThinBarFooterNoLogo] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_29" feature=[fm_layout.ThinBarFooter] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_30" feature=[fm_zone.ThinBarFooterNoLogo] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_31" feature=[fm_zone.ThinBarFooter] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_32" feature=[fm_zone.BigSquareCenter] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_33" feature=[fm_behaviour.Title] fm=[fm_behaviour]
[ROASSAL] ActionDeselect id="AD_34" feature=[fm_behaviour.Logo] fm=[fm_behaviour]
[ROASSAL] ActionDeselect id="AD_35" feature=[fm_behaviour.Graphic] fm=[fm_behaviour]
[ROASSAL] ActionDeselect id="AD_36" feature=[fm_behaviour.Thumbnails] fm=[fm_behaviour]
[ROASSAL] ActionDeselect id="AD_37" feature=[fm_behaviour.Text] fm=[fm_behaviour]
[ROASSAL] ActionDeselect id="AD_38" feature=[fm_zone.Graphic] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_39" feature=[fm_zone.Thumbnails] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_40" feature=[fm_zone.Text] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_41" feature=[fm_zone.Logo] fm=[fm_zone]
[ROASSAL] ActionDeselect id="AD_42" feature=[fm_zone.Title] fm=[fm_zone]
>> list of ActionSelect
[ROASSAL] ActionSelect id="AS_0" feature=[fm_renderer.Tweet] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_1" feature=[fm_renderer.Calendar] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_2" feature=[fm_renderer.PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_3" feature=[fm_renderer.Forecast] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_4" feature=[fm_renderer.Ephemeride] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_5" feature=[fm_renderer.Announces] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_6" feature=[fm_source.Tweet] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_7" feature=[fm_source.Calendar] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_8" feature=[fm_source.PictureAlbum] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_9" feature=[fm_source.Forecast] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_10" feature=[fm_source.Ephemeride] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_11" feature=[fm_source.Announces] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_12" feature=[fm_zone.Content] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_13" feature=[fm_zone.Graphic] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_14" feature=[fm_zone.Thumbnails] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_15" feature=[fm_zone.FullPicture] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_16" feature=[fm_zone.Text] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_17" feature=[fm_zone.Logo] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_18" feature=[fm_zone.Title] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_19" feature=[fm_renderer.Content] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_20" feature=[fm_renderer.Graphic] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_21" feature=[fm_renderer.Thumbnails] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_22" feature=[fm_renderer.FullPicture] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_23" feature=[fm_renderer.Text] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_24" feature=[fm_renderer.Title] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_25" feature=[fm_renderer.Logo] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_26" feature=[fm_layout.BigSquareCenter] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_27" feature=[fm_layout.ThinBarFooterNoLogo] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_28" feature=[fm_layout.ThinBarFooter] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_29" feature=[fm_zone.ThinBarFooterNoLogo] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_30" feature=[fm_zone.ThinBarFooter] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_31" feature=[fm_zone.BigSquareCenter] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_32" feature=[fm_behaviour.Title] fm=[fm_behaviour]
[ROASSAL] ActionSelect id="AS_33" feature=[fm_behaviour.Logo] fm=[fm_behaviour]
[ROASSAL] ActionSelect id="AS_34" feature=[fm_behaviour.Graphic] fm=[fm_behaviour]
[ROASSAL] ActionSelect id="AS_35" feature=[fm_behaviour.Thumbnails] fm=[fm_behaviour]
[ROASSAL] ActionSelect id="AS_36" feature=[fm_behaviour.Text] fm=[fm_behaviour]
[ROASSAL] ActionSelect id="AS_37" feature=[fm_zone.Graphic] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_38" feature=[fm_zone.Thumbnails] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_39" feature=[fm_zone.Text] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_40" feature=[fm_zone.Logo] fm=[fm_zone]
[ROASSAL] ActionSelect id="AS_41" feature=[fm_zone.Title] fm=[fm_zone]
>> list of DomainElement
[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]
[ROASSAL] DomainElement id="renderer" refers_on=[fm_renderer] MultiplicityElement=[me_renderer] belongs_to=[AssoSourceRenderer,AssoRendererSource,AssoRendererZone,AssoZoneRenderer]
[ROASSAL] DomainElement id="zone" refers_on=[fm_zone] MultiplicityElement=[me_zone] belongs_to=[AssoRendererZone,AssoZoneRenderer,AssoZoneLayout,AssoLayoutZone]
[ROASSAL] DomainElement id="layout" refers_on=[fm_layout] MultiplicityElement=[me_layout] belongs_to=[AssoZoneLayout,AssoLayoutZone]
[ROASSAL] DomainElement id="behaviour" refers_on=[fm_behaviour] MultiplicityElement=[me_behaviour] belongs_to=[AssoZoneBehaviour,AssoBehaviourZone]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_renderer" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_zone" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_layout" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_behaviour" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererZone_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererZone_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneRenderer_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneLayout_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneLayout_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutZone_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutZone_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneBehaviour_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneBehaviour_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoBehaviourZone_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoBehaviourZone_target" lowerBound=1 upperBound=1
>> list of ConfigurationState
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Sel0" fm=[fm_source] selected=[fm_source.Tweet] deselected=[]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Sel1" fm=[fm_source] selected=[fm_source.Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Sel2" fm=[fm_source] selected=[fm_source.PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Sel3" fm=[fm_source] selected=[fm_source.Forecast] deselected=[]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Sel4" fm=[fm_source] selected=[fm_source.Ephemeride] deselected=[]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Sel5" fm=[fm_source] selected=[fm_source.Announces] deselected=[]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Desel0" fm=[fm_source] selected=[] deselected=[fm_source.Tweet]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Desel1" fm=[fm_source] selected=[] deselected=[fm_source.Calendar]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Desel2" fm=[fm_source] selected=[] deselected=[fm_source.PictureAlbum]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Desel3" fm=[fm_source] selected=[] deselected=[fm_source.Forecast]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Desel4" fm=[fm_source] selected=[] deselected=[fm_source.Ephemeride]
[ROASSAL] ConfigurationState id="cs_SR_TypeInfo_Desel5" fm=[fm_source] selected=[] deselected=[fm_source.Announces]
[ROASSAL] ConfigurationState id="cs_notDate_imply_notByDay" fm=[fm_source] selected=[] deselected=[fm_source.Date]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Sel0" fm=[fm_renderer] selected=[fm_renderer.Tweet] deselected=[]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Sel1" fm=[fm_renderer] selected=[fm_renderer.Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Sel2" fm=[fm_renderer] selected=[fm_renderer.PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Sel3" fm=[fm_renderer] selected=[fm_renderer.Forecast] deselected=[]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Sel4" fm=[fm_renderer] selected=[fm_renderer.Ephemeride] deselected=[]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Sel5" fm=[fm_renderer] selected=[fm_renderer.Announces] deselected=[]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Desel0" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Tweet]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Desel1" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Calendar]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Desel2" fm=[fm_renderer] selected=[] deselected=[fm_renderer.PictureAlbum]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Desel3" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Forecast]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Desel4" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Ephemeride]
[ROASSAL] ConfigurationState id="cs_RS_TypeInfo_Desel5" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Announces]
[ROASSAL] ConfigurationState id="cs_Rule_25" fm=[fm_renderer] selected=[fm_renderer.Content] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_26" fm=[fm_renderer] selected=[fm_renderer.Graphic] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_27" fm=[fm_renderer] selected=[fm_renderer.Thumbnails] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_28" fm=[fm_renderer] selected=[fm_renderer.FullPicture] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_29" fm=[fm_renderer] selected=[fm_renderer.Text] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_30" fm=[fm_renderer] selected=[fm_renderer.Logo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_31" fm=[fm_renderer] selected=[fm_renderer.Title] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_32" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Content]
[ROASSAL] ConfigurationState id="cs_Rule_33" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Graphic]
[ROASSAL] ConfigurationState id="cs_Rule_34" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Thumbnails]
[ROASSAL] ConfigurationState id="cs_Rule_35" fm=[fm_renderer] selected=[] deselected=[fm_renderer.FullPicture]
[ROASSAL] ConfigurationState id="cs_Rule_36" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Text]
[ROASSAL] ConfigurationState id="cs_Rule_37" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Logo]
[ROASSAL] ConfigurationState id="cs_Rule_38" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Title]
[ROASSAL] ConfigurationState id="cs_Rule_39" fm=[fm_zone] selected=[fm_zone.Content] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_40" fm=[fm_zone] selected=[fm_zone.Graphic] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_41" fm=[fm_zone] selected=[fm_zone.Thumbnails] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_42" fm=[fm_zone] selected=[fm_zone.FullPicture] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_43" fm=[fm_zone] selected=[fm_zone.Text] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_44" fm=[fm_zone] selected=[fm_zone.Title] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_45" fm=[fm_zone] selected=[fm_zone.Logo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_46" fm=[fm_zone] selected=[] deselected=[fm_zone.Content]
[ROASSAL] ConfigurationState id="cs_Rule_47" fm=[fm_zone] selected=[] deselected=[fm_zone.Graphic]
[ROASSAL] ConfigurationState id="cs_Rule_48" fm=[fm_zone] selected=[] deselected=[fm_zone.Thumbnails]
[ROASSAL] ConfigurationState id="cs_Rule_49" fm=[fm_zone] selected=[] deselected=[fm_zone.FullPicture]
[ROASSAL] ConfigurationState id="cs_Rule_50" fm=[fm_zone] selected=[] deselected=[fm_zone.Text]
[ROASSAL] ConfigurationState id="cs_Rule_51" fm=[fm_zone] selected=[] deselected=[fm_zone.Title]
[ROASSAL] ConfigurationState id="cs_Rule_52" fm=[fm_zone] selected=[] deselected=[fm_zone.Logo]
[ROASSAL] ConfigurationState id="cs_Rule_53" fm=[fm_zone] selected=[fm_zone.BigSquareCenter] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_54" fm=[fm_zone] selected=[fm_zone.ThinBarFooterNoLogo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_55" fm=[fm_zone] selected=[fm_zone.ThinBarFooter] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_56" fm=[fm_zone] selected=[] deselected=[fm_zone.BigSquareCenter]
[ROASSAL] ConfigurationState id="cs_Rule_57" fm=[fm_zone] selected=[] deselected=[fm_zone.ThinBarFooterNoLogo]
[ROASSAL] ConfigurationState id="cs_Rule_58" fm=[fm_zone] selected=[] deselected=[fm_zone.ThinBarFooter]
[ROASSAL] ConfigurationState id="cs_Rule_59" fm=[fm_layout] selected=[fm_layout.ThinBarFooterNoLogo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_60" fm=[fm_layout] selected=[fm_layout.ThinBarFooter] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_61" fm=[fm_layout] selected=[fm_layout.BigSquareCenter] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_62" fm=[fm_layout] selected=[] deselected=[fm_layout.ThinBarFooterNoLogo]
[ROASSAL] ConfigurationState id="cs_Rule_63" fm=[fm_layout] selected=[] deselected=[fm_layout.ThinBarFooter]
[ROASSAL] ConfigurationState id="cs_Rule_64" fm=[fm_layout] selected=[] deselected=[fm_layout.BigSquareCenter]
[ROASSAL] ConfigurationState id="cs_Rule_65" fm=[fm_zone] selected=[fm_zone.Title] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_66" fm=[fm_zone] selected=[fm_zone.Logo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_67" fm=[fm_zone] selected=[fm_zone.Graphic] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_68" fm=[fm_zone] selected=[fm_zone.Thumbnails] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_69" fm=[fm_zone] selected=[fm_zone.Text] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_70" fm=[fm_zone] selected=[] deselected=[fm_zone.Title]
[ROASSAL] ConfigurationState id="cs_Rule_71" fm=[fm_zone] selected=[] deselected=[fm_zone.Logo]
[ROASSAL] ConfigurationState id="cs_Rule_72" fm=[fm_zone] selected=[] deselected=[fm_zone.Graphic]
[ROASSAL] ConfigurationState id="cs_Rule_73" fm=[fm_zone] selected=[] deselected=[fm_zone.Thumbnails]
[ROASSAL] ConfigurationState id="cs_Rule_74" fm=[fm_zone] selected=[] deselected=[fm_zone.Text]
[ROASSAL] ConfigurationState id="cs_Rule_75" fm=[fm_behaviour] selected=[fm_behaviour.Graphic] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_76" fm=[fm_behaviour] selected=[fm_behaviour.Thumbnails] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_77" fm=[fm_behaviour] selected=[fm_behaviour.Text] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_78" fm=[fm_behaviour] selected=[fm_behaviour.Logo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_79" fm=[fm_behaviour] selected=[fm_behaviour.Title] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_80" fm=[fm_behaviour] selected=[] deselected=[fm_behaviour.Graphic]
[ROASSAL] ConfigurationState id="cs_Rule_81" fm=[fm_behaviour] selected=[] deselected=[fm_behaviour.Thumbnails]
[ROASSAL] ConfigurationState id="cs_Rule_82" fm=[fm_behaviour] selected=[] deselected=[fm_behaviour.Text]
[ROASSAL] ConfigurationState id="cs_Rule_83" fm=[fm_behaviour] selected=[] deselected=[fm_behaviour.Logo]
[ROASSAL] ConfigurationState id="cs_Rule_84" fm=[fm_behaviour] selected=[] deselected=[fm_behaviour.Title]
>> list of Rule
[ROASSAL] Rule id="SR_TypeInfo_Sel0" state=[cs_SR_TypeInfo_Sel0] actions=[AS_0]
[ROASSAL] Rule id="SR_TypeInfo_Sel1" state=[cs_SR_TypeInfo_Sel1] actions=[AS_1]
[ROASSAL] Rule id="SR_TypeInfo_Sel2" state=[cs_SR_TypeInfo_Sel2] actions=[AS_2]
[ROASSAL] Rule id="SR_TypeInfo_Sel3" state=[cs_SR_TypeInfo_Sel3] actions=[AS_3]
[ROASSAL] Rule id="SR_TypeInfo_Sel4" state=[cs_SR_TypeInfo_Sel4] actions=[AS_4]
[ROASSAL] Rule id="SR_TypeInfo_Sel5" state=[cs_SR_TypeInfo_Sel5] actions=[AS_5]
[ROASSAL] Rule id="SR_TypeInfo_Desel0" state=[cs_SR_TypeInfo_Desel0] actions=[AD_0]
[ROASSAL] Rule id="SR_TypeInfo_Desel1" state=[cs_SR_TypeInfo_Desel1] actions=[AD_1]
[ROASSAL] Rule id="SR_TypeInfo_Desel2" state=[cs_SR_TypeInfo_Desel2] actions=[AD_2]
[ROASSAL] Rule id="SR_TypeInfo_Desel3" state=[cs_SR_TypeInfo_Desel3] actions=[AD_3]
[ROASSAL] Rule id="SR_TypeInfo_Desel4" state=[cs_SR_TypeInfo_Desel4] actions=[AD_4]
[ROASSAL] Rule id="SR_TypeInfo_Desel5" state=[cs_SR_TypeInfo_Desel5] actions=[AD_5]
[ROASSAL] Rule id="notDate_imply_notByDay" state=[cs_notDate_imply_notByDay] actions=[AD_6]
[ROASSAL] Rule id="RS_TypeInfo_Sel0" state=[cs_RS_TypeInfo_Sel0] actions=[AS_6]
[ROASSAL] Rule id="RS_TypeInfo_Sel1" state=[cs_RS_TypeInfo_Sel1] actions=[AS_7]
[ROASSAL] Rule id="RS_TypeInfo_Sel2" state=[cs_RS_TypeInfo_Sel2] actions=[AS_8]
[ROASSAL] Rule id="RS_TypeInfo_Sel3" state=[cs_RS_TypeInfo_Sel3] actions=[AS_9]
[ROASSAL] Rule id="RS_TypeInfo_Sel4" state=[cs_RS_TypeInfo_Sel4] actions=[AS_10]
[ROASSAL] Rule id="RS_TypeInfo_Sel5" state=[cs_RS_TypeInfo_Sel5] actions=[AS_11]
[ROASSAL] Rule id="RS_TypeInfo_Desel0" state=[cs_RS_TypeInfo_Desel0] actions=[AD_7]
[ROASSAL] Rule id="RS_TypeInfo_Desel1" state=[cs_RS_TypeInfo_Desel1] actions=[AD_8]
[ROASSAL] Rule id="RS_TypeInfo_Desel2" state=[cs_RS_TypeInfo_Desel2] actions=[AD_9]
[ROASSAL] Rule id="RS_TypeInfo_Desel3" state=[cs_RS_TypeInfo_Desel3] actions=[AD_10]
[ROASSAL] Rule id="RS_TypeInfo_Desel4" state=[cs_RS_TypeInfo_Desel4] actions=[AD_11]
[ROASSAL] Rule id="RS_TypeInfo_Desel5" state=[cs_RS_TypeInfo_Desel5] actions=[AD_12]
[ROASSAL] Rule id="Rule_25" state=[cs_Rule_25] actions=[AS_12]
[ROASSAL] Rule id="Rule_26" state=[cs_Rule_26] actions=[AS_13]
[ROASSAL] Rule id="Rule_27" state=[cs_Rule_27] actions=[AS_14]
[ROASSAL] Rule id="Rule_28" state=[cs_Rule_28] actions=[AS_15]
[ROASSAL] Rule id="Rule_29" state=[cs_Rule_29] actions=[AS_16]
[ROASSAL] Rule id="Rule_30" state=[cs_Rule_30] actions=[AS_17]
[ROASSAL] Rule id="Rule_31" state=[cs_Rule_31] actions=[AS_18]
[ROASSAL] Rule id="Rule_32" state=[cs_Rule_32] actions=[AD_13]
[ROASSAL] Rule id="Rule_33" state=[cs_Rule_33] actions=[AD_14]
[ROASSAL] Rule id="Rule_34" state=[cs_Rule_34] actions=[AD_15]
[ROASSAL] Rule id="Rule_35" state=[cs_Rule_35] actions=[AD_16]
[ROASSAL] Rule id="Rule_36" state=[cs_Rule_36] actions=[AD_17]
[ROASSAL] Rule id="Rule_37" state=[cs_Rule_37] actions=[AD_18]
[ROASSAL] Rule id="Rule_38" state=[cs_Rule_38] actions=[AD_19]
[ROASSAL] Rule id="Rule_39" state=[cs_Rule_39] actions=[AS_19]
[ROASSAL] Rule id="Rule_40" state=[cs_Rule_40] actions=[AS_20]
[ROASSAL] Rule id="Rule_41" state=[cs_Rule_41] actions=[AS_21]
[ROASSAL] Rule id="Rule_42" state=[cs_Rule_42] actions=[AS_22]
[ROASSAL] Rule id="Rule_43" state=[cs_Rule_43] actions=[AS_23]
[ROASSAL] Rule id="Rule_44" state=[cs_Rule_44] actions=[AS_24]
[ROASSAL] Rule id="Rule_45" state=[cs_Rule_45] actions=[AS_25]
[ROASSAL] Rule id="Rule_46" state=[cs_Rule_46] actions=[AD_20]
[ROASSAL] Rule id="Rule_47" state=[cs_Rule_47] actions=[AD_21]
[ROASSAL] Rule id="Rule_48" state=[cs_Rule_48] actions=[AD_22]
[ROASSAL] Rule id="Rule_49" state=[cs_Rule_49] actions=[AD_23]
[ROASSAL] Rule id="Rule_50" state=[cs_Rule_50] actions=[AD_24]
[ROASSAL] Rule id="Rule_51" state=[cs_Rule_51] actions=[AD_25]
[ROASSAL] Rule id="Rule_52" state=[cs_Rule_52] actions=[AD_26]
[ROASSAL] Rule id="Rule_53" state=[cs_Rule_53] actions=[AS_26]
[ROASSAL] Rule id="Rule_54" state=[cs_Rule_54] actions=[AS_27]
[ROASSAL] Rule id="Rule_55" state=[cs_Rule_55] actions=[AS_28]
[ROASSAL] Rule id="Rule_56" state=[cs_Rule_56] actions=[AD_27]
[ROASSAL] Rule id="Rule_57" state=[cs_Rule_57] actions=[AD_28]
[ROASSAL] Rule id="Rule_58" state=[cs_Rule_58] actions=[AD_29]
[ROASSAL] Rule id="Rule_59" state=[cs_Rule_59] actions=[AS_29]
[ROASSAL] Rule id="Rule_60" state=[cs_Rule_60] actions=[AS_30]
[ROASSAL] Rule id="Rule_61" state=[cs_Rule_61] actions=[AS_31]
[ROASSAL] Rule id="Rule_62" state=[cs_Rule_62] actions=[AD_30]
[ROASSAL] Rule id="Rule_63" state=[cs_Rule_63] actions=[AD_31]
[ROASSAL] Rule id="Rule_64" state=[cs_Rule_64] actions=[AD_32]
[ROASSAL] Rule id="Rule_65" state=[cs_Rule_65] actions=[AS_32]
[ROASSAL] Rule id="Rule_66" state=[cs_Rule_66] actions=[AS_33]
[ROASSAL] Rule id="Rule_67" state=[cs_Rule_67] actions=[AS_34]
[ROASSAL] Rule id="Rule_68" state=[cs_Rule_68] actions=[AS_35]
[ROASSAL] Rule id="Rule_69" state=[cs_Rule_69] actions=[AS_36]
[ROASSAL] Rule id="Rule_70" state=[cs_Rule_70] actions=[AD_33]
[ROASSAL] Rule id="Rule_71" state=[cs_Rule_71] actions=[AD_34]
[ROASSAL] Rule id="Rule_72" state=[cs_Rule_72] actions=[AD_35]
[ROASSAL] Rule id="Rule_73" state=[cs_Rule_73] actions=[AD_36]
[ROASSAL] Rule id="Rule_74" state=[cs_Rule_74] actions=[AD_37]
[ROASSAL] Rule id="Rule_75" state=[cs_Rule_75] actions=[AS_37]
[ROASSAL] Rule id="Rule_76" state=[cs_Rule_76] actions=[AS_38]
[ROASSAL] Rule id="Rule_77" state=[cs_Rule_77] actions=[AS_39]
[ROASSAL] Rule id="Rule_78" state=[cs_Rule_78] actions=[AS_40]
[ROASSAL] Rule id="Rule_79" state=[cs_Rule_79] actions=[AS_41]
[ROASSAL] Rule id="Rule_80" state=[cs_Rule_80] actions=[AD_38]
[ROASSAL] Rule id="Rule_81" state=[cs_Rule_81] actions=[AD_39]
[ROASSAL] Rule id="Rule_82" state=[cs_Rule_82] actions=[AD_40]
[ROASSAL] Rule id="Rule_83" state=[cs_Rule_83] actions=[AD_41]
[ROASSAL] Rule id="Rule_84" state=[cs_Rule_84] actions=[AD_42]
>> list of DEAssociation
[ROASSAL] DEAssociation id="AssoSourceRenderer" source=[DEAEnd_AssoSourceRenderer_source] target=[DEAEnd_AssoSourceRenderer_target] restrictionFunctions=[SourceRendererTI,SpecifRendereSource]
[ROASSAL] DEAssociation id="AssoRendererSource" source=[DEAEnd_AssoRendererSource_source] target=[DEAEnd_AssoRendererSource_target] restrictionFunctions=[RendererSourceTI]
[ROASSAL] DEAssociation id="AssoRendererZone" source=[DEAEnd_AssoRendererZone_source] target=[DEAEnd_AssoRendererZone_target] restrictionFunctions=[RZ_Element]
[ROASSAL] DEAssociation id="AssoZoneRenderer" source=[DEAEnd_AssoZoneRenderer_source] target=[DEAEnd_AssoZoneRenderer_target] restrictionFunctions=[ZR_Element]
[ROASSAL] DEAssociation id="AssoZoneLayout" source=[DEAEnd_AssoZoneLayout_source] target=[DEAEnd_AssoZoneLayout_target] restrictionFunctions=[ZL_Product]
[ROASSAL] DEAssociation id="AssoLayoutZone" source=[DEAEnd_AssoLayoutZone_source] target=[DEAEnd_AssoLayoutZone_target] restrictionFunctions=[LZ_Product]
[ROASSAL] DEAssociation id="AssoZoneBehaviour" source=[DEAEnd_AssoZoneBehaviour_source] target=[DEAEnd_AssoZoneBehaviour_target] restrictionFunctions=[ZB_Element]
[ROASSAL] DEAssociation id="AssoBehaviourZone" source=[DEAEnd_AssoBehaviourZone_source] target=[DEAEnd_AssoBehaviourZone_target] restrictionFunctions=[BZ_Element]
>> list of RestrictionFunction
[ROASSAL] RestrictionFunction id="SourceRendererTI" rules=[SR_TypeInfo_Sel0,SR_TypeInfo_Sel1,SR_TypeInfo_Sel2,SR_TypeInfo_Sel3,SR_TypeInfo_Sel4,SR_TypeInfo_Sel5,SR_TypeInfo_Desel0,SR_TypeInfo_Desel1,SR_TypeInfo_Desel2,SR_TypeInfo_Desel3,SR_TypeInfo_Desel4,SR_TypeInfo_Desel5]
[ROASSAL] RestrictionFunction id="SpecifRendereSource" rules=[notDate_imply_notByDay]
[ROASSAL] RestrictionFunction id="RendererSourceTI" rules=[RS_TypeInfo_Sel0,RS_TypeInfo_Sel1,RS_TypeInfo_Sel2,RS_TypeInfo_Sel3,RS_TypeInfo_Sel4,RS_TypeInfo_Sel5,RS_TypeInfo_Desel0,RS_TypeInfo_Desel1,RS_TypeInfo_Desel2,RS_TypeInfo_Desel3,RS_TypeInfo_Desel4,RS_TypeInfo_Desel5]
[ROASSAL] RestrictionFunction id="RZ_Element" rules=[Rule_25,Rule_26,Rule_27,Rule_28,Rule_29,Rule_30,Rule_31,Rule_32,Rule_33,Rule_34,Rule_35,Rule_36,Rule_37,Rule_38]
[ROASSAL] RestrictionFunction id="ZR_Element" rules=[Rule_39,Rule_40,Rule_41,Rule_42,Rule_43,Rule_44,Rule_45,Rule_46,Rule_47,Rule_48,Rule_49,Rule_50,Rule_51,Rule_52]
[ROASSAL] RestrictionFunction id="ZL_Product" rules=[Rule_53,Rule_54,Rule_55,Rule_56,Rule_57,Rule_58]
[ROASSAL] RestrictionFunction id="LZ_Product" rules=[Rule_59,Rule_60,Rule_61,Rule_62,Rule_63,Rule_64]
[ROASSAL] RestrictionFunction id="ZB_Element" rules=[Rule_65,Rule_66,Rule_67,Rule_68,Rule_69,Rule_70,Rule_71,Rule_72,Rule_73,Rule_74]
[ROASSAL] RestrictionFunction id="BZ_Element" rules=[Rule_75,Rule_76,Rule_77,Rule_78,Rule_79,Rule_80,Rule_81,Rule_82,Rule_83,Rule_84]
>> list of Feature
[ROASSAL] Feature id="fm_source.TimeLine" name="TimeLine"
[ROASSAL] Feature id="fm_source.Weather2" name="Weather2"
[ROASSAL] Feature id="fm_source.Criteria" name="Criteria"
[ROASSAL] Feature id="fm_source.Ephemeride" name="Ephemeride"
[ROASSAL] Feature id="fm_source.Menu" name="Menu"
[ROASSAL] Feature id="fm_source.Target" name="Target"
[ROASSAL] Feature id="fm_source.Date" name="Date"
[ROASSAL] Feature id="fm_source.Tag" name="Tag"
[ROASSAL] Feature id="fm_source.Views" name="Views"
[ROASSAL] Feature id="fm_source.Forecast" name="Forecast"
[ROASSAL] Feature id="fm_source.SaintDuJour" name="SaintDuJour"
[ROASSAL] Feature id="fm_source.Album" name="Album"
[ROASSAL] Feature id="fm_source.Sort" name="Sort"
[ROASSAL] Feature id="fm_source.MenuInfo" name="MenuInfo"
[ROASSAL] Feature id="fm_source.Popularity" name="Popularity"
[ROASSAL] Feature id="fm_source.Tweet" name="Tweet"
[ROASSAL] Feature id="fm_source.Announces" name="Announces"
[ROASSAL] Feature id="fm_source.Calendar" name="Calendar"
[ROASSAL] Feature id="fm_source.Announcement" name="Announcement"
[ROASSAL] Feature id="fm_source.City" name="City"
[ROASSAL] Feature id="fm_source.Name" name="Name"
[ROASSAL] Feature id="fm_source.Source" name="Source"
[ROASSAL] Feature id="fm_source.TypeInfo" name="TypeInfo"
[ROASSAL] Feature id="fm_source.Filter" name="Filter"
[ROASSAL] Feature id="fm_source.FlickR" name="FlickR"
[ROASSAL] Feature id="fm_source.PictureAlbum" name="PictureAlbum"
[ROASSAL] Feature id="fm_source.Picasa" name="Picasa"
[ROASSAL] Feature id="fm_source.ICalReader" name="ICalReader"
[ROASSAL] Feature id="fm_renderer.Discretization" name="Discretization"
[ROASSAL] Feature id="fm_renderer.Logo" name="Logo"
[ROASSAL] Feature id="fm_renderer.Graphic" name="Graphic"
[ROASSAL] Feature id="fm_renderer.Unique" name="Unique"
[ROASSAL] Feature id="fm_renderer.ByMonth" name="ByMonth"
[ROASSAL] Feature id="fm_renderer.Output" name="Output"
[ROASSAL] Feature id="fm_renderer.Temporal" name="Temporal"
[ROASSAL] Feature id="fm_renderer.All" name="All"
[ROASSAL] Feature id="fm_renderer.Criteria" name="Criteria"
[ROASSAL] Feature id="fm_renderer.BySize" name="BySize"
[ROASSAL] Feature id="fm_renderer.Ephemeride" name="Ephemeride"
[ROASSAL] Feature id="fm_renderer.Renderer" name="Renderer"
[ROASSAL] Feature id="fm_renderer.ByHour" name="ByHour"
[ROASSAL] Feature id="fm_renderer.ByDay" name="ByDay"
[ROASSAL] Feature id="fm_renderer.FixedTime" name="FixedTime"
[ROASSAL] Feature id="fm_renderer.Forecast" name="Forecast"
[ROASSAL] Feature id="fm_renderer.Content" name="Content"
[ROASSAL] Feature id="fm_renderer.Block" name="Block"
[ROASSAL] Feature id="fm_renderer.FullPicture" name="FullPicture"
[ROASSAL] Feature id="fm_renderer.Thumbnails" name="Thumbnails"
[ROASSAL] Feature id="fm_renderer.Spatial" name="Spatial"
[ROASSAL] Feature id="fm_renderer.Tweet" name="Tweet"
[ROASSAL] Feature id="fm_renderer.Announces" name="Announces"
[ROASSAL] Feature id="fm_renderer.TenInformations" name="TenInformations"
[ROASSAL] Feature id="fm_renderer.Calendar" name="Calendar"
[ROASSAL] Feature id="fm_renderer.Title" name="Title"
[ROASSAL] Feature id="fm_renderer.TypeInfo" name="TypeInfo"
[ROASSAL] Feature id="fm_renderer.Text" name="Text"
[ROASSAL] Feature id="fm_renderer.PictureAlbum" name="PictureAlbum"
[ROASSAL] Feature id="fm_renderer.FixedNumber" name="FixedNumber"
[ROASSAL] Feature id="fm_renderer.Elements" name="Elements"
[ROASSAL] Feature id="fm_renderer.Clustering" name="Clustering"
[ROASSAL] Feature id="fm_renderer.Line" name="Line"
[ROASSAL] Feature id="fm_renderer.FlexibleTime" name="FlexibleTime"
[ROASSAL] Feature id="fm_zone.LeftBarVertical" name="LeftBarVertical"
[ROASSAL] Feature id="fm_zone.ThinBarFooterNoLogo" name="ThinBarFooterNoLogo"
[ROASSAL] Feature id="fm_zone.Product" name="Product"
[ROASSAL] Feature id="fm_zone.ThinBarHeader" name="ThinBarHeader"
[ROASSAL] Feature id="fm_zone.Graphic" name="Graphic"
[ROASSAL] Feature id="fm_zone.Logo" name="Logo"
[ROASSAL] Feature id="fm_zone.Title" name="Title"
[ROASSAL] Feature id="fm_zone.Text" name="Text"
[ROASSAL] Feature id="fm_zone.Elements" name="Elements"
[ROASSAL] Feature id="fm_zone.ThinBarFooter" name="ThinBarFooter"
[ROASSAL] Feature id="fm_zone.Zone" name="Zone"
[ROASSAL] Feature id="fm_zone.Content" name="Content"
[ROASSAL] Feature id="fm_zone.BigSquareCenter" name="BigSquareCenter"
[ROASSAL] Feature id="fm_zone.Thumbnails" name="Thumbnails"
[ROASSAL] Feature id="fm_zone.FullPicture" name="FullPicture"
[ROASSAL] Feature id="fm_layout.IRSAM" name="IRSAM"
[ROASSAL] Feature id="fm_layout.Academic" name="Academic"
[ROASSAL] Feature id="fm_layout.ThinBarFooterNoLogo" name="ThinBarFooterNoLogo"
[ROASSAL] Feature id="fm_layout.Product" name="Product"
[ROASSAL] Feature id="fm_layout.AnyPeople" name="AnyPeople"
[ROASSAL] Feature id="fm_layout.CA" name="CA"
[ROASSAL] Feature id="fm_layout.Property" name="Property"
[ROASSAL] Feature id="fm_layout.Students" name="Students"
[ROASSAL] Feature id="fm_layout.LayoutIRSAM" name="LayoutIRSAM"
[ROASSAL] Feature id="fm_layout.Children" name="Children"
[ROASSAL] Feature id="fm_layout.Design" name="Design"
[ROASSAL] Feature id="fm_layout.Usage" name="Usage"
[ROASSAL] Feature id="fm_layout.EPU" name="EPU"
[ROASSAL] Feature id="fm_layout.LayoutEPU" name="LayoutEPU"
[ROASSAL] Feature id="fm_layout.N2I" name="N2I"
[ROASSAL] Feature id="fm_layout.Layout" name="Layout"
[ROASSAL] Feature id="fm_layout.Target" name="Target"
[ROASSAL] Feature id="fm_layout.LayoutCA" name="LayoutCA"
[ROASSAL] Feature id="fm_layout.Disabilities" name="Disabilities"
[ROASSAL] Feature id="fm_layout.VisualDisability" name="VisualDisability"
[ROASSAL] Feature id="fm_layout.Noel" name="Noel"
[ROASSAL] Feature id="fm_layout.ThinBarFooter" name="ThinBarFooter"
[ROASSAL] Feature id="fm_layout.Zones" name="Zones"
[ROASSAL] Feature id="fm_layout.BigSquareCenter" name="BigSquareCenter"
[ROASSAL] Feature id="fm_behaviour.Unique" name="Unique"
[ROASSAL] Feature id="fm_behaviour.Logo" name="Logo"
[ROASSAL] Feature id="fm_behaviour.Graphic" name="Graphic"
[ROASSAL] Feature id="fm_behaviour.Behaviour" name="Behaviour"
[ROASSAL] Feature id="fm_behaviour.Appear" name="Appear"
[ROASSAL] Feature id="fm_behaviour.Scrolling" name="Scrolling"
[ROASSAL] Feature id="fm_behaviour.All" name="All"
[ROASSAL] Feature id="fm_behaviour.Direction" name="Direction"
[ROASSAL] Feature id="fm_behaviour.ScrollingBehaviour" name="ScrollingBehaviour"
[ROASSAL] Feature id="fm_behaviour.SimpleRepeatBehaviour" name="SimpleRepeatBehaviour"
[ROASSAL] Feature id="fm_behaviour.Contrast" name="Contrast"
[ROASSAL] Feature id="fm_behaviour.Repeat" name="Repeat"
[ROASSAL] Feature id="fm_behaviour.Thumbnails" name="Thumbnails"
[ROASSAL] Feature id="fm_behaviour.Right" name="Right"
[ROASSAL] Feature id="fm_behaviour.Product" name="Product"
[ROASSAL] Feature id="fm_behaviour.Animation" name="Animation"
[ROASSAL] Feature id="fm_behaviour.HorizontalScrollingSetBehaviour" name="HorizontalScrollingSetBehaviour"
[ROASSAL] Feature id="fm_behaviour.Left" name="Left"
[ROASSAL] Feature id="fm_behaviour.Title" name="Title"
[ROASSAL] Feature id="fm_behaviour.Text" name="Text"
[ROASSAL] Feature id="fm_behaviour.BasicBehaviour" name="BasicBehaviour"
[ROASSAL] Feature id="fm_behaviour.HorizontalScrollingBehaviour" name="HorizontalScrollingBehaviour"
[ROASSAL] Feature id="fm_behaviour.FixedNumber" name="FixedNumber"
[ROASSAL] Feature id="fm_behaviour.Elements" name="Elements"
[ROASSAL] Feature id="fm_behaviour.Pause" name="Pause"
[ROASSAL] Feature id="fm_behaviour.Numbers" name="Numbers"
[ROASSAL] Feature id="fm_behaviour.Loop" name="Loop"
[ROASSAL] Feature id="fm_behaviour.AppearanceBehaviour" name="AppearanceBehaviour"
[ROASSAL] END MODEL'! !

MPImportCommand subclass: #FMTextImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:33'!
chooseDirectory
	"Let the user pick a folder. Load in Moose all the fml file contained in the folder"
	| dir file |
	dir := UIManager default chooseDirectory.
	dir ifNil: [ ^ self ].

	(dir fileNamesMatching: '*.fml') do: [ :fileName |
		self processFileNamed: (dir fullNameFor: fileName) ].
	
! !

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:35'!
chooseFile
	| fileName file |
	fileName := UIManager default chooseFullFileNameMatching: #('*.fml').
	(fileName isNil or: [ fileName isEmpty ]) ifTrue: [ ^ self ].
	self self processFileNamed: fileName ! !

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:12'!
enterTextualDescription
	| str |
	str := UIManager default 
			multiLineRequest: 'Enter a program' initialAnswer: 'enter your Familiar program' answerHeight: 250.
	self processText: str ! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/6/2012 11:28'!
execute
	| str sel fileName file |
	sel := UIManager default 
			chooseFrom:  #('choose file' 'choose folder' 'enter textual description') 
			values: #(#chooseFile #chooseDirectory #enterTextualDescription).
	sel ifNil: [ ^ self ].
	
	self perform: sel
	! !

!FMTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/1/2012 16:48'!
isParseable: string
	^ FMASTBuilder new program matches: string! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/6/2012 11:27'!
label
	^ 'Import Familiar description'! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/2/2012 00:13'!
modelForTextualDescription: string
	"parse string and fill up a moose model. string has to correspond to a program"
	
	| model program collectingVisitor |
	
	"Make sure that the code is parseable"
	self assert: [ self isParseable: string ] description: 'Entered code is not parseable. Please check'.
	model := MooseModel new.
	
	program := FMASTBuilder new program parse: string.
	collectingVisitor := CollectingVisitor new.
	program accept: collectingVisitor.
	model addAll: collectingVisitor elements.
	
	^ model
	! !

!FMTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/6/2012 11:27'!
processFileNamed: fileName
	| file |
	[file := FileStream fileNamed: fileName.
	self processText: file contents titled: file localName ]
		on: Error do: [ :ex | 
			UIManager default inform: ex printString.
			file ifNotNil: [ file close ] ] ! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/3/2012 16:54'!
processText: str
	self processText: str titled: 'no name'! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/3/2012 16:53'!
processText: str titled: title
	(str notNil and: [ str notEmpty ])
			ifTrue: [ MooseModel root add: ((self modelForTextualDescription: str) name: title) ]! !

MPImportCommand subclass: #SPTextImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/31/2013 08:06'!
chooseDirectory
	"Let the user pick a folder. Load in Moose all the fml file contained in the folder"
	| dir processableFiles |
	dir := UIManager default chooseDirectory.
	dir ifNil: [ ^ self ].
 
	"Maybe on some point, we can enforce a particular file extension"
	processableFiles := dir allChildren reject: #isDirectory.
	
	processableFiles do: [ :f  |
		self processFileNamed: f fullName ].
	
! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/25/2013 09:10'!
chooseFile
	| fileName |
	fileName := UIManager default chooseFullFileNameMatching: #('*').
	(fileName isNil or: [ fileName isEmpty ]) ifTrue: [ ^ self ].
	self processFileNamed: fileName ! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 11/23/2012 11:53'!
enterTextualDescription
	| str |
	str := UIManager default 
			multiLineRequest: 'Enter a program' initialAnswer: 'enter your Familiar program' answerHeight: 250.
	self processText: str ! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 11/23/2012 12:12'!
example1
	self processText: SPParserTest new trace1 titled: 'Example 1'! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 12/12/2012 15:45'!
example2
	self processText: SPParserTest new trace2 titled: 'Example 2'! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 12/19/2012 13:18'!
execute
	| str sel fileName file |
	sel := UIManager default 
			chooseFrom:  #('choose file' 'choose folder' 'enter textual description' 'example 1' 'example 2' 'frascati single FM') 
			values: #(#chooseFile #chooseDirectory #enterTextualDescription #example1 #example2 #frascatiSingleFM).
	sel ifNil: [ ^ self ].
	
	self perform: sel
	! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 12/19/2012 13:19'!
frascatiSingleFM
	self processText: SPParserTest new frascatiSingleFM titled: 'Frascati Single FM'! !

!SPTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 11:53'!
isParseable: string
	^ FMASTBuilder new program matches: string! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:53'!
label
	^ 'Import Spine description'! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:55'!
modelForTextualDescription: string
	"parse string and fill up a moose model. string has to correspond to a program"
	
	| model program collectingVisitor |
	
	"Make sure that the code is parseable"
	self assert: [ self isParseable: string ] description: 'Entered code is not parseable. Please check'.
	^ SPParser new 
		parse: string;
		resolve;
		mooseModel! !

!SPTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 11:53'!
processFileNamed: fileName
	| file |
	[file := FileStream fileNamed: fileName.
	self processText: file contents titled: file localName ]
		on: Error do: [ :ex | 
			UIManager default inform: ex printString.
			file ifNotNil: [ file close ] ] ! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:53'!
processText: str
	self processText: str titled: 'no name'! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:53'!
processText: str titled: title
	(str notNil and: [ str notEmpty ])
			ifTrue: [ MooseModel root add: ((self modelForTextualDescription: str) name: title) ]! !

Object subclass: #FMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

FMParser subclass: #FMASTBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:31'!
children
	^ super children ==> [ :node | node flatten ]! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/7/2012 14:17'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ((self fmlIdentifier trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] ) /
					(($!! asParser trim, self fmlIdentifier trim,  self constraintOperator , prim) ==> [ :n |  n third new left: (FMConstraintNegated new expr: n second) ; right: n fourth; yourself  ]) /

					((prim trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] ) / 
					prim.
	prim setParser: 
		
		($( asParser trim , term , $) asParser trim ==> [ :n | n second ]) /
		(($!! asParser trim, term) ==> [ :n | FMConstraintNegated new expr: n second ]) /
		(self fmlIdentifier trim ==> [ :n | n ]) 
				.

	^ term! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 17:23'!
constraintOperator
	^ ( '|'  asParser trim / 
						 'or'  asParser trim / 
						 'and'  asParser trim / 
						'&' asParser trim / 
						'->' asParser trim  /  
						'<->' asParser trim) ==> [ :n | FMConstraintBinOp for: n ] ! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 14:39'!
featureModel
	^ super featureModel ==> [ :node | 
		| prods cons fm |
		prods := node third collect: #first. 
		cons := node fourth flatten reject: [ :n | n = $; ]. 
		
		fm := FMFeatureModel new 
			addAllExpressions: prods;
			addAllConstraints: cons;
			yourself.
		fm features do: [ :f | f featureModel: fm ].
		fm ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 10:56'!
fmlIdentifier
	^ super fmlIdentifier ==> [ :node | FMFeature new name: node ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:26'!
mandatory
	^ super mandatory ==> [ :node | Array with: (FMFeatureMendatory new feature: node) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:27'!
mutexgroup
	^ super mutexgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureMutex new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:28'!
optional
	^ super optional ==> [ :node |  Array with: (FMFeatureOptional new feature: node second) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:21'!
orgroup
	^ super orgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureOr new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:58'!
production
	^ super production ==> [ :nodes | 
		FMFeatureProduction new 
			root: nodes first ; 
			addAll: nodes third ; 
			yourself ]
! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:59'!
xorgroup
	^ super xorgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureXor new feature: n ] ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:05'!
child
	^ self mandatory / self orgroup / self mutexgroup / self optional / self xorgroup ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
children
	^ self child plus! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 17:20'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ( prim,  ( 'or' asParser trim / 'and' asParser trim / '|'  asParser trim / '&' asParser trim / '->' asParser trim  /  '<->' asParser trim ) , prim) / 
					prim.
	prim setParser: ($( asParser trim , term , $) asParser trim) /
					($!! asParser trim, term) /
				self id.
					
	^ term! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:22'!
featureModel
	
	^ 'FM' asParser trim , self leftPar ,  ((self production  , self semiColumn ) plus) ,  (self constraint  , self semiColumn ) star , self rightPar
! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/3/2012 16:07'!
fmlIdentifier
	^ (#letter asParser , ( #letter asParser / #digit asParser / $_ asParser) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:03'!
id
	^  (#letter asParser , ( #letter asParser / #digit asParser ) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:13'!
leftPar 
	^ $( asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:47'!
mandatory
	"Mandatory   : name=ID ;
	ID : ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*; "
	
	^ self fmlIdentifier ! !

!FMParser methodsFor: 'private' stamp: 'SimonUrli 12/3/2012 15:01'!
mutexgroup
	"Mutexgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '?' ;"

	^ self leftPar , self fmlIdentifier  , ( self verticalBar , self fmlIdentifier ) plus , self rightPar , $? asParser! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:51'!
optional
	"Optional    : '[' name=FML_IDENTIFIER ']' ;"
	^ '[' asParser trim , self fmlIdentifier , ']' asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
orgroup
	"Orgroup    : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '+' ;"

	^ self leftPar  , self fmlIdentifier , ( self verticalBar  , self fmlIdentifier ) plus ,  self rightPar  , $+ asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
production
	^ (self fmlIdentifier ,  ':' asParser trim , self children) trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:06'!
program
	^ self statement star ==> [ :node | FMProgram new addAll: node ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:14'!
rightPar 
	^ $) asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:59'!
semiColumn
	^ $; asParser trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:05'!
statement
	^ (self id , $= asParser trim, self featureModel) ==>
			 [ :node | FMAssignment new variable: node first; featureModel: node third ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:58'!
verticalBar 
	^ $| asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:03'!
xorgroup
	"Xorgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN ;"

	^ self leftPar , self fmlIdentifier , ( self verticalBar , self fmlIdentifier ) plus ,  self rightPar! !

Object subclass: #FMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

FMVisitor subclass: #CollectingVisitor
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 14:31'!
constains: object
	^ elements includes: object! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:27'!
elements
	^ elements asSet asOrderedCollection! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:06'!
elementsOfKind: aClass
	^ self elements select: [ :el | el isKindOf: aClass ]! !

!CollectingVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 00:22'!
initialize 
	super initialize.
	elements := OrderedCollection new ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitAssigment: aFMAssignment 
	elements add: aFMAssignment ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 17:02'!
visitConstraintAnd: aFMConstraintAnd 
	elements add: aFMConstraintAnd ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:38'!
visitConstraintArrow: aFMConstraintArrow 
	elements add: aFMConstraintArrow ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
visitConstraintEquiv: aFMConstraintEquiv
	elements add: aFMConstraintEquiv ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:38'!
visitConstraintNegated: aFMConstraintNegated 
	elements add: aFMConstraintNegated ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:15'!
visitConstraintPipe: aFMConstraintPipe
	elements add: aFMConstraintPipe ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 14:26'!
visitFeature: aFMFeature 
	elements add: aFMFeature ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitFeatureModel: aFMFeatureModel 
	elements add: aFMFeatureModel ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitProgram: aFMProgram 
	elements add: aFMProgram ! !

FMVisitor subclass: #CountingFeatureVisitor
	instanceVariableNames: 'features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!CountingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:18'!
features 
	^ features asArray! !

!CountingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 10:49'!
initialize
	super initialize.
	features := OrderedCollection new.! !

!CountingFeatureVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 11/23/2012 09:48'!
visitFeature: aFMFeature 
	(features anySatisfy: [ :f | f name = aFMFeature name ] )
		ifFalse: [ features add: aFMFeature ]! !

FMVisitor subclass: #FMCollectingFeatureVisitor
	instanceVariableNames: 'featuresImplying featuresImplied focusedFeature exclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/6/2012 16:44'!
exclusions
	^ exclusions asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:35'!
featuresImplied
	^ featuresImplied asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:34'!
featuresImplying
	^ featuresImplying asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:22'!
focusedFeature
	^ focusedFeature! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:22'!
focusedFeature: anObject
	focusedFeature := anObject! !

!FMCollectingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/6/2012 16:19'!
initialize 
	super initialize.
	featuresImplying := OrderedCollection new.
	featuresImplied := OrderedCollection new.
	exclusions := OrderedCollection new! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'SimonUrli 12/15/2012 20:18'!
visitConstraintArrow: aFMConstraintArrow 
	| c featuresRight featuresLeft |

"self halt."

	"We ignore not on the left hand side"
	(aFMConstraintArrow left class == FMConstraintNegated) ifTrue: [ ^ self ].

	"We get what features is on the left hand side"
	c := CollectingVisitor new.
	aFMConstraintArrow left accept: c.
	featuresLeft := c elementsOfKind: FMFeature. 

	"We get what features is on the right hand side"
	c := CollectingVisitor new.
	aFMConstraintArrow right accept: c.
	featuresRight := c elementsOfKind: FMFeature. 


	(aFMConstraintArrow right class == FMConstraintNegated) 
		ifTrue: [
			(featuresRight includes: focusedFeature) ifTrue: [ exclusions addAll: featuresLeft ].
			(featuresLeft includes: focusedFeature) ifTrue: [ exclusions addAll: featuresRight ] ]
		ifFalse: [
			(featuresRight includes: focusedFeature) ifTrue: [ featuresImplied addAll: featuresLeft ].
			(featuresLeft includes: focusedFeature) ifTrue: [ featuresImplying addAll: featuresRight ] ]
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:15'!
visitAssigment: aFMAssignment 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/4/2012 16:46'!
visitConstraintAnd: aFMConstraintAnd 
! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:13'!
visitConstraintArrow: aFMConstraintArrow 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
visitConstraintEquiv: aFMConstraintEquiv 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/2/2012 13:30'!
visitConstraintNegated: aFMConstraintNegated 
! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:15'!
visitConstraintPipe: aFMConstraintPipe 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
visitFeature: aFMFeature 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:17'!
visitFeatureModel: aFMFeatureModel 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:14'!
visitProgram: aFMProgram 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
visitVariable: aVariable 
	! !

FMVisitor subclass: #FMWeightedVisitor
	instanceVariableNames: 'weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMWeightedVisitor methodsFor: 'util' stamp: 'AlexandreBergel 7/26/2013 08:40'!
inc: n
	weight := weight + n! !

!FMWeightedVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/26/2013 08:32'!
initialize
	super initialize.
	weight := 0.! !

!FMWeightedVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/26/2013 08:57'!
visitConstraintAnd: aFMConstraintAnd 
	self inc: 4! !

!FMWeightedVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/26/2013 08:53'!
visitConstraintArrow: aFMConstraintArrow 
	self inc: 2! !

!FMWeightedVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/26/2013 08:53'!
visitConstraintEquiv: aFMConstraintEquiv 
	self inc: 4! !

!FMWeightedVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/26/2013 08:57'!
visitConstraintNegated: aFMConstraintNegated 
	self inc: 2! !

!FMWeightedVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/26/2013 08:57'!
visitConstraintPipe: aFMConstraintPipe 
	self inc: 2! !

!FMWeightedVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/26/2013 08:32'!
weight
	^ weight! !

Object subclass: #SPParser
	instanceVariableNames: 'mooseModel features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPParser commentStamp: 'AlexandreBergel 11/23/2012 11:49' prior: 0!
(SPParser new parse: (SPParserTest new trace1)) mooseModel visualizeSPINE
!

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:17'!
assertBeginWithTag: string
	(self doesBeginWithTag: string)
		ifFalse: [ self error: 'Improper tag' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:49'!
assertContainsBeginStatement: lines
	(self containsBeginStatement: lines)
		ifFalse: [ self error: 'Missing begin statement' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:50'!
assertContainsEndingStatement: lines
	(self containsEndingStatement: lines)
		ifFalse: [ self error: 'Missing ending statement' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:48'!
containsBeginStatement: lines
	^ lines anySatisfy: [ :line | line = '[ROASSAL] BEGIN MODEL' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 7/25/2013 06:07'!
containsEndingStatement: lines
	^ lines anySatisfy: [ :line | line beginsWith: '[ROASSAL] END MODEL' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:17'!
doesBeginWithTag: string
	^ string beginsWith: '[ROASSAL] '! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 10:56'!
getIdFrom: featureModelString
	"Extract the id in a string"
	
	^ self getValueNamed: 'id' from: featureModelString! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 11:31'!
getListNamed: keyName from: stringToExtractFrom 
	| indexKey endingWhiteSpaceIndex str |
	indexKey := (stringToExtractFrom indexOfSubCollection: (' ', keyName, '=')) + 1.
	endingWhiteSpaceIndex := stringToExtractFrom indexOf: $  startingAt: indexKey ifAbsent: [ stringToExtractFrom size + 1].

	( (stringToExtractFrom at: (indexKey + keyName size)) = $= ) ifFalse: [ self error: 'Unexpected character for key ', keyName ].
	
	((stringToExtractFrom at: (indexKey + keyName size + 1)) = $[)
		ifTrue: [ 
			((indexKey + keyName size + 1) = (endingWhiteSpaceIndex -2 ))
				ifTrue: [ ^ #() ].
			
			(indexKey + keyName size + 2) >= (endingWhiteSpaceIndex - 2)
				ifTrue: [ self error: 'key ', keyName , ' not found' ].
				
			str := stringToExtractFrom copyFrom: (indexKey + keyName size + 2)  to: (endingWhiteSpaceIndex - 2).
			^ str subStrings: ',' ]
		
		ifFalse: [
			^ stringToExtractFrom copyFrom: (indexKey + keyName size + 1)  to: (endingWhiteSpaceIndex - 1) ]
	! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 10:55'!
getValueNamed: keyName from: stringToExtractFrom
	| indexKey endingClosingIndex str |
	indexKey := stringToExtractFrom indexOfSubCollection: keyName.
	endingClosingIndex := stringToExtractFrom indexOf: $" startingAt: (indexKey + keyName size + 2).

	self assert: [ (stringToExtractFrom at: (indexKey + keyName size)) = $= ].
	self assert: [ (stringToExtractFrom at: (indexKey + keyName size + 1)) = $" ].
	
	^ stringToExtractFrom copyFrom: (indexKey + keyName size + 2)  to: (endingClosingIndex - 1)
	! !

!SPParser methodsFor: 'initialize' stamp: 'AlexandreBergel 11/22/2012 09:48'!
initialize
	super initialize.
	mooseModel := MooseModel new.! !

!SPParser methodsFor: 'private' stamp: 'SimonUrli 11/23/2012 14:52'!
mooseModel 

^mooseModel ! !

!SPParser methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 12:25'!
parse: aString
	"Public method"

	^ self parseLines: aString lines ! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/11/2012 11:18'!
parseActionDeselect: actionDeselectString

	| actionDeselect | 
	self assertBeginWithTag: actionDeselectString.

	actionDeselect := SPActionDeselect new
						name: (self getIdFrom: actionDeselectString);
						feature: (self getListNamed: 'feature' from: actionDeselectString) first;
						fm: (self getListNamed: 'fm' from: actionDeselectString) first;
						yourself.
						
	^ actionDeselect 
! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/11/2012 11:18'!
parseActionSelect: actionDeselectString

	| actionDeselect | 
	self assertBeginWithTag: actionDeselectString.

	^ SPActionSelect new
						name: (self getIdFrom: actionDeselectString);
						feature: (self getListNamed: 'feature' from: actionDeselectString) first;
						fm: (self getListNamed: 'fm' from: actionDeselectString) first;
						yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:15'!
parseBEGIN: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/12/2012 12:29'!
parseConfigurationState: configurationStateString

	| actionDeselect | 
	self assertBeginWithTag: configurationStateString.

	^ SPConfigurationState new
				name: (self getIdFrom: configurationStateString);
				fm: (self getListNamed: 'fm' from: configurationStateString) first;
				selected: (self getListNamed: 'selected' from: configurationStateString);
				deselected: (self getListNamed: 'deselected' from: configurationStateString);
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:18'!
parseDEAEnd: string
	^ self parseDomainElementEnd: string! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/12/2012 15:39'!
parseDEAssociation: deAssociationString

	| actionDeselect | 
	self assertBeginWithTag: deAssociationString.

	^ SPDEAssociation new
				name: (self getIdFrom: deAssociationString);
				source: (self getListNamed: 'source' from: deAssociationString) first;
				target: (self getListNamed: 'target' from: deAssociationString) first;
				restrictionFunctions: (self getListNamed: 'restrictionFunctions' from: deAssociationString);
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/12/2012 15:44'!
parseDomainElement: domainElementString

	| domainElement | 
	self assertBeginWithTag: domainElementString.

	domainElement := SPDomainElement new
						name: (self getIdFrom: domainElementString);
						belongsTo: (self getListNamed: 'belongs_to' from: domainElementString);
						refersOn: (self getListNamed: 'refers_on' from: domainElementString) first;
						multiplicityElement: (self getListNamed: 'MultiplicityElement' from: domainElementString) first;
						yourself.
						
	^ domainElement 
! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/12/2012 15:50'!
parseDomainElementEnd: domainElementEndString

	| domainElementEnd | 
	self assertBeginWithTag: domainElementEndString.

	domainElementEnd := SPDomainElementEnd new
						name: (self getIdFrom: domainElementEndString);
						applyOn: (self getListNamed: 'apply_on' from: domainElementEndString) first;
						linkMultiplicity: (self getListNamed: 'linkMultiplicity' from: domainElementEndString) first;
						yourself.
						
	^ domainElementEnd
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:15'!
parseEND: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 11/23/2012 21:36'!
parseFeature: featureString
	self assertBeginWithTag: featureString.

	^ SPFeature new
						name: (self getIdFrom: featureString);
						shortName: (self getValueNamed: 'name' from: featureString);
						yourself.
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/23/2012 10:57'!
parseFeatureModel: featureModelString
	| featureName fmFamiliarString fmFeatureModel |
	self assertBeginWithTag: featureModelString.

	featureName := self getIdFrom: featureModelString.
	features := (self getListNamed: 'features' from: featureModelString).
	fmFamiliarString := (self getValueNamed:  'familiar' from: featureModelString).
	
	fmFeatureModel := FMASTBuilder new featureModel parse: fmFamiliarString.
	fmFeatureModel class == FMFeatureModel
		ifFalse: [ self error: 'Parsing error of the familiar feature model' ].
	^ SPFeatureModel new
		name: featureName;
		features: features;
		fmFeatureModel: fmFeatureModel;
		yourself! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:17'!
parseLine: line
 	| kind |
	(self doesBeginWithTag: line)
		ifFalse: [ ^ self ].
		
	kind := line substrings second.
	^ self perform: ('parse', kind, ':') asSymbol withArguments: (Array with: line)! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:49'!
parseLines: lines
	| v |
	self assertContainsBeginStatement: lines.
	lines do: [ :line | 
		v := self parseLine: line.
		(v ~~ self)
			ifTrue: [ mooseModel add: v ] ].
	self assertContainsEndingStatement: lines! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 08:44'!
parseMultiplicityElement: multiplicityElementString

	| actionDeselect | 
	self assertBeginWithTag: multiplicityElementString.

	^ SPMultiplicityElement new
				name: (self getIdFrom: multiplicityElementString);
				lowerBound: (self getListNamed: 'lowerBound' from: multiplicityElementString) asInteger;
				upperBound: (self getListNamed: 'upperBound' from: multiplicityElementString) asInteger;
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:11'!
parseRestrictionFunction: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	^ SPRestrictionFunction new
				name: (self getIdFrom: ruleString);
				rules: (self getListNamed: 'rules' from: ruleString);
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 12/12/2012 15:55'!
parseRule: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	^ SPRule new
				name: (self getIdFrom: ruleString);
				state: (self getListNamed: 'state' from: ruleString) first;
				actions: (self getListNamed: 'actions' from: ruleString) first;
				yourself.
						 
! !

!SPParser methodsFor: 'public' stamp: 'AlexandreBergel 12/18/2012 13:48'!
resolve

	mooseModel entities do: [ :e | e resolve ].
	self verifyNoError! !

!SPParser methodsFor: 'error' stamp: 'AlexandreBergel 12/18/2012 14:10'!
verifyNoError
	"Check the model is error free"
	"If an error is found, then the Error exception is thrown"
	
	self mooseModel allSpineFeatures do: [ :feature |
		feature fmFeature implying collect: [ :if | 
			(self mooseModel allWithType: SPFeature) 
				detect: [ :feat | (feature featureModel features includes: feat) & (feat shortName = if name) ]
				ifNone: [ self error: 'Error with implying of ', if printString ] ].
			
		feature fmFeature exclusions collect: [ :if | 
			(self mooseModel allWithType: SPFeature) 
				detect: [ :feat | (feature featureModel features includes: feat) & (feat shortName = if name) ]
				ifNone: [ self error: 'Error with exclusions of ', if printString ] ] ]! !
